 PROGRAM

   MAP
     YCalendar(<LONG>),LONG
     ZCalendar(<LONG>),LONG
     BigCal(<LONG>,<LONG>,<LONG>),LONG
     BigCal2(<LONG>,<LONG>,<LONG>,<LONG>),LONG
   END

   INCLUDE('Equates.CLW')
   INCLUDE('Keycodes.CLW')
   INCLUDE('Errors.CLW')

AppFrame APPLICATION('Test Calendars'),AT(,,193,73),CENTER,IMM,ICON('LSICAL.ICO'),STATUS,SYSTEM,MAX
       MENUBAR
         MENU('&File'),USE(?FileMenu)
           ITEM('Test &Y'),USE(?CalTestY),MSG('Test YCalendar - MINIMAL RESOURCE USAGE!')
           ITEM('Test &Z'),USE(?CalTestZ),MSG('Test ZCalendar - "almost" MINIMAL RESOURCE USAGE!')
           ITEM('Test &BigCal'),USE(?CalTestBIG),MSG('Test BIG Calendar - Large Display Calendar!')
           ITEM('Test BigCal w/ &DATA'),USE(?TestDATA),MSG('BIG Calendar w/ DATA - Large Display!')
           ITEM,SEPARATOR
           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
         END
       END
     END

  CODE
  OPEN(AppFrame)
  ACCEPT
    CASE FIELD()
    OF ?Exit
    OF ?CalTestY
      CASE EVENT()
      OF EVENT:Accepted
        YY# = YCalendar()          !<== Syntax: ([<StartDate>])
        IF YY#
          AppFrame{PROP:Text} = 'Test YCalendar - '&FORMAT(YY#,@d4)
        END
      END
    OF ?CalTestZ
      CASE EVENT()
      OF EVENT:Accepted
        YY# = ZCalendar()          !<== Syntax: ([<StartDate>])
        IF YY#
          AppFrame{PROP:Text} = 'Test ZCalendar - '&FORMAT(YY#,@d4)
        END
      END
    OF ?CalTestBIG
      CASE EVENT()
      OF EVENT:Accepted
        YY# = BigCal()             !<== Syntax: (<StartDate>[,<Xpos>,<Ypos>])
        IF YY#
          AppFrame{PROP:Text} = 'Test BIG Calendar - '&FORMAT(YY#,@d4)
        END
      END
    OF ?TestDATA
      CASE EVENT()
      OF EVENT:Accepted
        YY# = BigCal2(,,,1)        !<== Syntax: (<StartDate>[,<Xpos>,<Ypos>][,1{show data}])
        IF YY#
          AppFrame{PROP:Text} = 'BIG Calendar w/ DATA - '&FORMAT(YY#,@d4)
        END
      END
    END
  END
  RETURN


!=============================================================================
YCalendar   Function(StartDate)

!
! Uses far fewer resources than the original XCalendar, AND IS MUCH FASTER!
! (if you don't mind bolder fonts!!!)
!
! Up/Down/Left/Right arrow keys, PgUp/PgDn - Months, CtrlPgUp/CtrlPgDn - Years
! Home - Return to "StartDate"
! Enter/DoubleClick - Accept
! Esc/"><" button - Reject
!

WorkingDate LONG
WorkMonth   SHORT
Ymouse      SHORT
Xmouse      SHORT
Xaxis       SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(111)

Cal2 WINDOW,AT(,,95,122),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn),ALRT(HomeKey), |
         ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey),GRAY,DOUBLE
       STRING(@s20),AT(7,29,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[1:20]),TRN
       STRING(@s20),AT(7,41,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[22:41]),TRN
       STRING(@s20),AT(7,53,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[43:62]),TRN
       STRING(@s20),AT(7,65,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[64:83]),TRN
       STRING(@s20),AT(7,77,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[85:104]),TRN
       STRING(@s20),AT(7,89,83,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[106:111]),TRN
       STRING('Sun'),AT(5,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       STRING('Mon'),AT(17,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Tue'),AT(29,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Wed'),AT(41,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Thr'),AT(54,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Fri'),AT(65,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Sat'),AT(77,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       BOX,AT(5,27,84,72),COLOR(0808080H)
       LINE,AT(17,27,0,72),COLOR(0808080H)
       LINE,AT(29,27,0,72),COLOR(0808080H)
       LINE,AT(41,27,0,72),COLOR(0808080H)
       LINE,AT(53,27,0,72),COLOR(0808080H)
       LINE,AT(65,27,0,72),COLOR(0808080H)
       LINE,AT(77,27,0,72),COLOR(0808080H)
       LINE,AT(5,39,84,0),COLOR(0808080H)
       LINE,AT(5,51,84,0),COLOR(0808080H)
       LINE,AT(5,63,84,0),COLOR(0808080H)
       LINE,AT(5,75,84,0),COLOR(0808080H)
       LINE,AT(5,87,84,0),COLOR(0808080H)
       ENTRY(@s20),AT(24,5,65,10),FONT('Arial',8,,FONT:regular),USE(?ForLooksOnly),SKIP,DISABLE,CENTER
       REGION,AT(5,27,84,72),USE(?Region1),IMM
       BUTTON('Today !'),AT(28,105,39,11),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON,AT(5,105,14,11),FONT('Arial',8,,FONT:bold),USE(?MonthMinus),ICON(ICON:VCRback)
       BUTTON,AT(76,105,14,11),FONT('Arial',8,,FONT:bold),USE(?MonthPlus),ICON(ICON:VCRplay)
       BUTTON,AT(5,5,16,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate),ICON('VCREXIT.ICO')
       STRING(@d4),AT(26,7,61,7),FONT('Arial',8,,FONT:bold),USE(WorkingDate),TRN,CENTER
       BOX,AT(5,27,12,12),USE(?ActiveDay),COLOR(0FF0000H),FILL(0FFFFFFH)
     END

  CODE

  ROW# = 27
  COL# = 5
  Ymouse = 0
  Xmouse = 0

  IF ~StartDate THEN StartDate = TODAY().
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)

  OPEN(CAL2)
  DO PreLoad
  Select(?GoToday)
  ACCEPT

    DISPLAY()

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
    CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      Xmouse = 0
      Ymouse = 0
      Select(?GoToday)
      CYCLE
    END

    CASE FIELD()
    OF ?Region1
      IF EVENT() = EVENT:MouseUp
        IF MouseY()=Ymouse and MouseX()=Xmouse      !<== DOUBLE CLICK ON DATE, YES I KNOW... BUT IT _DOES_ WORK!
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
      END
    OF ?MonthPlus
      IF EVENT() = EVENT:Accepted
        DO NextMonth
        Xmouse = 0
        Ymouse = 0
      END
    OF ?MonthMinus
      IF EVENT() = EVENT:Accepted
        DO PrevMonth
        Xmouse = 0
        Ymouse = 0
      END
    OF ?ExitNoDate
      IF EVENT() = EVENT:Accepted
        WorkingDate = 0
        DO EndProcedure
      END
    OF ?GoToday
      IF EVENT() = EVENT:Accepted
        DO Set2Today
        Xmouse = 0
        Ymouse = 0
      END
    END
    Select(?GoToday)
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 12
  IF COL# > 77
    COL# = 5
    ROW# += 12
  END
  Cal2$?ActiveDay{PROP:Xpos} = COL#
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 12
  IF COL# < 5
    COL# = 77
    ROW# -= 12
  END
  Cal2$?ActiveDay{PROP:Xpos} = COL#
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 12
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 12
  Cal2$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextMonth Routine
  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine
  MonthText=''
  CLEAR(DG:ActualDate[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n3)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      Cal2$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      Cal2$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END
  END
  MonthText = ALL(' ',Start#*3-2)&LEFT(MonthText)
  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('05172941536577',(Xcount#*2)+1,2)
      DG:Y[Block#] = SUB('273951637587',(Ycount#*2)+1,2)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 5 to 16
    Xaxis = 1
  OF 17 to 28
    Xaxis = 2
  OF 29 to 40
    Xaxis = 3
  OF 41 to 52
    Xaxis = 4
  OF 53 to 64
    Xaxis = 5
  OF 65 to 76
    Xaxis = 6
  OF 77 to 89
    Xaxis = 7
  END
  CASE Ymouse
  OF 27 to 38
    DGpointer = Xaxis
  OF 39 to 50
    DGpointer = Xaxis+7
  OF 51 to 62
    DGpointer = Xaxis+14
  OF 63 to 74
    DGpointer = Xaxis+21
  OF 75 to 86
    DGpointer = Xaxis+28
  OF 87 to 98
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    Cal2$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    Cal2$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END


!=============================================================================
ZCalendar   Function(StartDate)

!
! Different layout than YCalendar, includes "Cancel" & "OK" Buttons
!
! Up/Down/Left/Right arrow keys, PgUp/PgDn = Months, CtrlPgUp/CtrlPgDn = Years
! Home = Return to "StartDate"
! "Today" sets highlight to today
! Enter/DoubleClick/"OK" = Accept
! Esc/"Cancel" button = Reject
!

WorkingDate LONG
WorkMonth   SHORT
Xaxis       SHORT
Xmouse      SHORT
Ymouse      SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(111)

Cal3 WINDOW,AT(,,125,103),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn),ALRT(HomeKey), |
         ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey),GRAY,DOUBLE
       STRING(@s2),AT(7,29,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[1:3]),TRN
       STRING(@s14),AT(19,29,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[4:18]),TRN
       STRING(@s2),AT(79,29,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[19:20]),TRN
       STRING(@s2),AT(7,41,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[22:24]),TRN
       STRING(@s14),AT(19,41,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[25:39]),TRN
       STRING(@s2),AT(79,41,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[40:41]),TRN
       STRING(@s2),AT(7,53,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[43:45]),TRN
       STRING(@s14),AT(19,53,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[46:60]),TRN
       STRING(@s2),AT(79,53,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[61:62]),TRN
       STRING(@s2),AT(7,65,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[64:66]),TRN
       STRING(@s14),AT(19,65,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[67:81]),TRN
       STRING(@s2),AT(79,65,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[82:83]),TRN
       STRING(@s2),AT(7,77,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[85:87]),TRN
       STRING(@s14),AT(19,77,60,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[88:102]),TRN
       STRING(@s2),AT(79,77,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[103:104]),TRN
       STRING(@s2),AT(7,89,12,10),FONT('Fixedsys',9,080H,FONT:regular),USE(MonthText[106:108]),TRN
       STRING(@s2),AT(19,89,12,10),FONT('Fixedsys',9,,FONT:regular),USE(MonthText[109:111]),TRN
       STRING('Sun'),AT(5,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       STRING('Mon'),AT(17,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Tue'),AT(29,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Wed'),AT(41,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Thr'),AT(54,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Fri'),AT(65,18,12,10),FONT('Arial',8,,FONT:regular),TRN,CENTER
       STRING('Sat'),AT(77,18,12,10),FONT('Arial',8,080H,FONT:regular),TRN,CENTER
       ENTRY(@s20),AT(6,5,83,10),FONT('Arial',8,,FONT:regular),USE(?ForLooksOnly),SKIP,DISABLE,CENTER
       REGION,AT(5,27,84,72),USE(?Region1),IMM
       BUTTON('&OK'),AT(94,68,26,10),FONT('Arial',8,,FONT:bold),USE(?OKButton),DEFAULT
       BUTTON('&Cancel'),AT(94,54,26,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate)
       BUTTON('&Today'),AT(94,40,26,10),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON,AT(94,26,12,10),FONT('Arial',8,,FONT:bold),USE(?MonthMinus),IMM,ICON(ICON:VCRback)
       BUTTON,AT(108,26,12,10),FONT('Arial',8,,FONT:bold),USE(?MonthPlus),IMM,ICON(ICON:VCRplay)
       STRING(@d4),AT(16,7,61,7),FONT('Arial',8,,FONT:bold),USE(WorkingDate),TRN,CENTER
       LINE,AT(5,25,84,0),USE(?Line1),COLOR(0808080H)
       BOX,AT(5,27,12,12),USE(?ActiveDay),COLOR(0FF0000H),FILL(0FFFFFFH)
     END


  CODE

  ROW# = 27
  COL# = 5

  IF ~StartDate THEN StartDate = TODAY().
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)

  OPEN(CAL3)
  DO PreLoad
  ACCEPT

    DISPLAY(?WorkingDate)

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
      CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      CYCLE

    OF EVENT:MouseUp
      IF FIELD() = ?Region1
        IF MouseY()=Ymouse and MouseX()=Xmouse
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
        CYCLE
      END

    OF EVENT:Accepted
      CASE FIELD()
      OF ?MonthPlus
        DO NextMonth
      OF ?MonthMinus
        DO PrevMonth
      OF ?ExitNoDate
        WorkingDate = 0
        DO EndProcedure
      OF ?GoToday
        DO Set2Today
      OF ?OKButton
        DO EndProcedure
      END

    END
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 12
  IF COL# > 77
    COL# = 5
    ROW# += 12
  END
  CAL3$?ActiveDay{PROP:Xpos} = COL#
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 12
  IF COL# < 5
    COL# = 77
    ROW# -= 12
  END
  CAL3$?ActiveDay{PROP:Xpos} = COL#
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 12
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 12
  CAL3$?ActiveDay{PROP:Ypos} = ROW#
  exit

NextMonth Routine
  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine
  MonthText=''
  CLEAR(DG:ActualDate[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n3)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      CAL3$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      CAL3$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END
  END
  MonthText = ALL(' ',Start#*3-2)&LEFT(MonthText)
  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('05172941536577',(Xcount#*2)+1,2)
      DG:Y[Block#] = SUB('273951637587',(Ycount#*2)+1,2)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 5 to 16
    Xaxis = 1
  OF 17 to 28
    Xaxis = 2
  OF 29 to 40
    Xaxis = 3
  OF 41 to 52
    Xaxis = 4
  OF 53 to 64
    Xaxis = 5
  OF 65 to 76
    Xaxis = 6
  OF 77 to 89
    Xaxis = 7
  END
  CASE Ymouse
  OF 27 to 38
    DGpointer = Xaxis
  OF 39 to 50
    DGpointer = Xaxis+7
  OF 51 to 62
    DGpointer = Xaxis+14
  OF 63 to 74
    DGpointer = Xaxis+21
  OF 75 to 86
    DGpointer = Xaxis+28
  OF 87 to 98
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    CAL3$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    CAL3$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END


!=============================================================================
BigCal      Function(StartDate,Xpos,Ypos)

WorkingDate LONG
WorkMonth   SHORT
Xaxis       SHORT
Xmouse      SHORT
Ymouse      SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(220)

BigCal WINDOW(':'),AT(,,223,146),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn),ALRT(HomeKey), |
         ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey),SYSTEM,GRAY
       BOX,AT(6,8,211,131),COLOR(0C0C0C0H),FILL(0808040H)
       BOX,AT(66,119,152,21),COLOR(0C0C0C0H),FILL(0C0C0C0H)
       LINE,AT(36,19,0,120),COLOR(0C0C0C0H)
       LINE,AT(66,19,0,120),COLOR(0C0C0C0H)
       LINE,AT(96,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(126,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(156,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(186,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(6,19,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,39,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,59,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,79,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,99,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,119,211,0),COLOR(0C0C0C0H)
       STRING('Sun'),AT(14,10,,),FONT(,0,080H,),TRN,CENTER
       STRING('Mon'),AT(44,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Tue'),AT(75,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Wed'),AT(104,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Thr'),AT(136,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Fri'),AT(166,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Sat'),AT(196,10,,),FONT(,0,080H,),TRN,CENTER
       STRING(@s38),AT(8,20,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[001:038]),TRN
       STRING(@s38),AT(8,40,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[043:080]),TRN
       STRING(@s38),AT(8,60,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[085:123]),TRN
       STRING(@s38),AT(8,80,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[127:165]),TRN
       STRING(@s38),AT(8,100,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[169:207]),TRN
       STRING(@s8),AT(8,120,42,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[211:219]),TRN
       REGION,AT(6,20,210,100),USE(?Region1),IMM
       REGION,AT(6,120,60,20),USE(?Region2),IMM
       BUTTON,AT(76,128,12,10),USE(?MonthMinus),ICON(ICON:VCRback)
       BUTTON,AT(88,128,12,10),USE(?MonthPlus),ICON(ICON:VCRplay)
       BUTTON('&Today'),AT(106,128,26,10),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON('&Cancel'),AT(150,128,26,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate)
       BUTTON('&OK'),AT(182,128,26,10),FONT('Arial',8,,FONT:bold),USE(?OKButton),DEFAULT
       BOX,AT(5,18,33,23),USE(?ActiveDay),COLOR(00H),FILL(0FFFFFFH)
     END


  CODE

  ROW# = 18
  COL# = 5

  IF ~StartDate THEN StartDate = TODAY().
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)

  OPEN(BigCal)

  IF Xpos AND Ypos
    BigCal{PROP:AT,1} = Xpos
    BigCal{PROP:AT,2} = Ypos
  END

  DO PreLoad

  ACCEPT

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
      CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      CYCLE

    OF EVENT:MouseUp
      IF FIELD() = ?Region1 or FIELD() = ?Region2
        IF MouseY()=Ymouse and MouseX()=Xmouse
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
        CYCLE
      END

    OF EVENT:Accepted
      CASE FIELD()
      OF ?MonthPlus
        DO NextMonth
      OF ?MonthMinus
        DO PrevMonth
      OF ?ExitNoDate
        WorkingDate = 0
        DO EndProcedure
      OF ?GoToday
        DO Set2Today
      OF ?OKButton
        DO EndProcedure
      END

    END
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

RefreshTitle Routine
  BigCal{PROP:Text}=Format(WorkingDate,@d4)
  exit

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 30
  IF COL# > 185
    COL# = 5
    ROW# += 20
  END
  BigCal$?ActiveDay{PROP:Xpos} = COL#
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 30
  IF COL# < 5
    COL# = 185
    ROW# -= 20
  END
  BigCal$?ActiveDay{PROP:Xpos} = COL#
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 20
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 20
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

NextMonth Routine
  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine
  MonthText=''
  CLEAR(DG:ActualDate[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n_6)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      BigCal$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      BigCal$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END
  END
  MonthText = ALL(' ',Start#*6-5)&LEFT(MonthText)
  DO RefreshTitle
  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('005035065095125155185',(Xcount#*3)+1,3)
      DG:Y[Block#] = SUB('018038058078098118',(Ycount#*3)+1,3)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 6 to 35
    Xaxis = 1
  OF 36 to 65
    Xaxis = 2
  OF 66 to 95
    Xaxis = 3
  OF 96 to 125
    Xaxis = 4
  OF 126 to 155
    Xaxis = 5
  OF 156 to 185
    Xaxis = 6
  OF 186 to 215
    Xaxis = 7
  END
  CASE Ymouse
  OF 19 to 38
    DGpointer = Xaxis
  OF 39 to 58
    DGpointer = Xaxis+7
  OF 59 to 78
    DGpointer = Xaxis+14
  OF 79 to 98
    DGpointer = Xaxis+21
  OF 99 to 118
    DGpointer = Xaxis+28
  OF 119 to 138
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    BigCal$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    BigCal$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END
  DO RefreshTitle
  exit


!=============================================================================
BigCal2     Function(StartDate,Xpos,Ypos,ShowData)

!
!  SLOW, but useful (maybe!)
!

WorkingDate LONG
WorkMonth   SHORT
Xaxis       SHORT
Xmouse      SHORT
Ymouse      SHORT
DGpointer   SHORT
DateGroup   Group,Pre(DG)
X             SHORT,DIM(42)
Y             SHORT,DIM(42)
SCALE         SHORT,DIM(42)
ActualDate    LONG,DIM(42)
            END

MonthText   String(220)

BigCal WINDOW(':'),AT(,,223,146),CENTER,ALRT(PgUpKey),ALRT(CtrlPgUp),ALRT(PgDnKey),ALRT(CtrlPgDn),ALRT(HomeKey), |
         ALRT(LeftKey),ALRT(UpKey),ALRT(RightKey),ALRT(DownKey),ALRT(EnterKey),ALRT(EscKey),SYSTEM,GRAY, |
         MAX,RESIZE
       BOX,AT(6,8,211,131),COLOR(0C0C0C0H),FILL(0808040H)
       BOX,AT(66,119,152,21),COLOR(0C0C0C0H),FILL(0C0C0C0H)
       LINE,AT(36,19,0,120),COLOR(0C0C0C0H)
       LINE,AT(66,19,0,120),COLOR(0C0C0C0H)
       LINE,AT(96,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(126,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(156,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(186,19,0,100),COLOR(0C0C0C0H)
       LINE,AT(6,19,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,39,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,59,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,79,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,99,211,0),COLOR(0C0C0C0H)
       LINE,AT(6,119,211,0),COLOR(0C0C0C0H)
       STRING('Sun'),AT(14,10,,),FONT(,0,080H,),TRN,CENTER
       STRING('Mon'),AT(44,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Tue'),AT(75,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Wed'),AT(104,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Thr'),AT(136,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Fri'),AT(166,10,,),FONT(,0,0FFFFFFH,),TRN,CENTER
       STRING('Sat'),AT(196,10,,),FONT(,0,080H,),TRN,CENTER
       STRING(@s38),AT(8,20,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[001:038]),TRN
       STRING(@s38),AT(8,40,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[043:080]),TRN
       STRING(@s38),AT(8,60,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[085:123]),TRN
       STRING(@s38),AT(8,80,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[127:165]),TRN
       STRING(@s38),AT(8,100,192,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[169:207]),TRN
       STRING(@s8),AT(8,120,42,10),FONT('Fixedsys',14,,FONT:regular),USE(MonthText[211:219]),TRN
       REGION,AT(6,20,210,100),USE(?Region1),IMM
       REGION,AT(6,120,60,20),USE(?Region2),IMM
       BUTTON,AT(76,128,12,10),USE(?MonthMinus),ICON(ICON:VCRback)
       BUTTON,AT(88,128,12,10),USE(?MonthPlus),ICON(ICON:VCRplay)
       BUTTON('&Today'),AT(106,128,26,10),FONT('Arial',8,,FONT:bold),USE(?GoToday)
       BUTTON('&Cancel'),AT(150,128,26,10),FONT('Arial',8,,FONT:bold),USE(?ExitNoDate)
       BUTTON('&OK'),AT(182,128,26,10),FONT('Arial',8,,FONT:bold),USE(?OKButton),DEFAULT
       BOX,AT(5,18,33,23),USE(?ActiveDay),COLOR(00H),FILL(0FFFFFFH)
       BOX,AT(9,32,0,5),USE(?Scale1),COLOR(0808040H),FILL(00H)
       BOX,AT(39,32,0,5),USE(?Scale2),COLOR(0808040H),FILL(00H)
       BOX,AT(69,32,0,5),USE(?Scale3),COLOR(0808040H),FILL(00H)
       BOX,AT(99,32,0,5),USE(?Scale4),COLOR(0808040H),FILL(00H)
       BOX,AT(129,32,0,5),USE(?Scale5),COLOR(0808040H),FILL(00H)
       BOX,AT(159,32,0,5),USE(?Scale6),COLOR(0808040H),FILL(00H)
       BOX,AT(189,32,0,5),USE(?Scale7),COLOR(0808040H),FILL(00H)
       BOX,AT(9,52,0,5),USE(?Scale8),COLOR(0808040H),FILL(00H)
       BOX,AT(39,52,0,5),USE(?Scale9),COLOR(0808040H),FILL(00H)
       BOX,AT(69,52,0,5),USE(?Scale10),COLOR(0808040H),FILL(00H)
       BOX,AT(99,52,0,5),USE(?Scale11),COLOR(0808040H),FILL(00H)
       BOX,AT(129,52,0,5),USE(?Scale12),COLOR(0808040H),FILL(00H)
       BOX,AT(159,52,0,5),USE(?Scale13),COLOR(0808040H),FILL(00H)
       BOX,AT(189,52,0,5),USE(?Scale14),COLOR(0808040H),FILL(00H)
       BOX,AT(9,72,0,5),USE(?Scale15),COLOR(0808040H),FILL(00H)
       BOX,AT(39,72,0,5),USE(?Scale16),COLOR(0808040H),FILL(00H)
       BOX,AT(69,72,0,5),USE(?Scale17),COLOR(0808040H),FILL(00H)
       BOX,AT(99,72,0,5),USE(?Scale18),COLOR(0808040H),FILL(00H)
       BOX,AT(129,72,0,5),USE(?Scale19),COLOR(0808040H),FILL(00H)
       BOX,AT(159,72,0,5),USE(?Scale20),COLOR(0808040H),FILL(00H)
       BOX,AT(189,72,0,5),USE(?Scale21),COLOR(0808040H),FILL(00H)
       BOX,AT(9,92,0,5),USE(?Scale22),COLOR(0808040H),FILL(00H)
       BOX,AT(39,92,0,5),USE(?Scale23),COLOR(0808040H),FILL(00H)
       BOX,AT(69,92,0,5),USE(?Scale24),COLOR(0808040H),FILL(00H)
       BOX,AT(99,92,0,5),USE(?Scale25),COLOR(0808040H),FILL(00H)
       BOX,AT(129,92,0,5),USE(?Scale26),COLOR(0808040H),FILL(00H)
       BOX,AT(159,92,0,5),USE(?Scale27),COLOR(0808040H),FILL(00H)
       BOX,AT(189,92,0,5),USE(?Scale28),COLOR(0808040H),FILL(00H)
       BOX,AT(9,112,0,5),USE(?Scale29),COLOR(0808040H),FILL(00H)
       BOX,AT(39,112,0,5),USE(?Scale30),COLOR(0808040H),FILL(00H)
       BOX,AT(69,112,0,5),USE(?Scale31),COLOR(0808040H),FILL(00H)
       BOX,AT(99,112,0,5),USE(?Scale32),COLOR(0808040H),FILL(00H)
       BOX,AT(129,112,0,5),USE(?Scale33),COLOR(0808040H),FILL(00H)
       BOX,AT(159,112,0,5),USE(?Scale34),COLOR(0808040H),FILL(00H)
       BOX,AT(189,112,0,5),USE(?Scale35),COLOR(0808040H),FILL(00H)
       BOX,AT(9,132,0,5),USE(?Scale36),COLOR(0808040H),FILL(00H)
       BOX,AT(39,132,0,5),USE(?Scale37),COLOR(0808040H),FILL(00H)
     END


  CODE

  ROW# = 18
  COL# = 5

  IF ~StartDate THEN StartDate = TODAY().
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)

  OPEN(BigCal)

  IF Xpos AND Ypos
    BigCal{PROP:AT,1} = Xpos
    BigCal{PROP:AT,2} = Ypos
  END

  DO PreLoad

  ACCEPT

    CASE EVENT()
    OF EVENT:OpenWindow
    OF EVENT:GainFocus
    OF EVENT:AlertKey
      CASE Keycode()
      OF RightKey
        DO NextDay
      OF LeftKey
        DO PrevDay
      OF DownKey
        DO NextWeek
      OF UpKey
        DO PrevWeek
      OF PgDnKey
        DO NextMonth
      OF PgUpKey
        DO PrevMonth
      OF HomeKey
        DO Set2Start
      OF CtrlPgDn
        DO NextYear
      OF CtrlPgUp
        DO PrevYear
      OF EnterKey
        DO EndProcedure
      OF EscKey
        WorkingDate = 0
        DO EndProcedure
      END
      CYCLE

    OF EVENT:MouseUp
      IF FIELD() = ?Region1 or FIELD() = ?Region2
        IF MouseY()=Ymouse and MouseX()=Xmouse
          DO EndProcedure
        END
        Ymouse = MouseY()
        Xmouse = MouseX()
        DO FindMouseQ
        IF ~FOUND#
          Xmouse = 0
          Ymouse = 0
        END
        CYCLE
      END

    OF EVENT:Accepted
      CASE FIELD()
      OF ?MonthPlus
        DO NextMonth
      OF ?MonthMinus
        DO PrevMonth
      OF ?ExitNoDate
        WorkingDate = 0
        DO EndProcedure
      OF ?GoToday
        DO Set2Today
      OF ?OKButton
        DO EndProcedure
      END

    END
  END
  DO EndProcedure

EndProcedure Routine
  POST(EVENT:CloseWindow)
  RETURN(WorkingDate)

RefreshTitle Routine
  BigCal{PROP:Text}=Format(WorkingDate,@d4)
  exit

NextDay Routine
  WorkingDate += 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# += 30
  IF COL# > 185
    COL# = 5
    ROW# += 20
  END
  BigCal$?ActiveDay{PROP:Xpos} = COL#
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

PrevDay Routine
  WorkingDate -= 1
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  COL# -= 30
  IF COL# < 5
    COL# = 185
    ROW# -= 20
  END
  BigCal$?ActiveDay{PROP:Xpos} = COL#
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

NextWeek Routine
  WorkingDate += 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# += 20
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

PrevWeek Routine
  WorkingDate -= 7
  IF Month(WorkingDate)<>WorkMonth
    WorkMonth = Month(WorkingDate)
    DO LoadMonth
    exit
  END
  ROW# -= 20
  BigCal$?ActiveDay{PROP:Ypos} = ROW#
  DO RefreshTitle
  exit

NextMonth Routine
  WorkingDate=Date(WorkMonth+1,day(WorkingDate),year(WorkingDate))      !            But it works OK when month = 13
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevMonth Routine
  IF WorkMonth=1                                                        !Workaround: CW(1001) has a problem with its
    WorkingDate=Date(12,day(WorkingDate),year(WorkingDate)-1)           !            DATE() function when month = 0
  ELSE
    WorkingDate=Date(WorkMonth-1,day(WorkingDate),year(WorkingDate))
  END
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

NextYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)+1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

PrevYear Routine
  WorkingDate=Date(WorkMonth,day(WorkingDate),year(WorkingDate)-1)
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Today Routine
  WorkingDate = TODAY()
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

Set2Start Routine
  WorkingDate = StartDate
  WorkMonth = Month(WorkingDate)
  DO LoadMonth
  exit

LoadMonth routine

  IF ShowData > 0
  BigCal$?SCALE1{PROP:AT,3}   = 0
  BigCal$?SCALE2{PROP:AT,3}   = 0
  BigCal$?SCALE3{PROP:AT,3}   = 0
  BigCal$?SCALE4{PROP:AT,3}   = 0
  BigCal$?SCALE5{PROP:AT,3}   = 0
  BigCal$?SCALE6{PROP:AT,3}   = 0
  BigCal$?SCALE7{PROP:AT,3}   = 0
  BigCal$?SCALE8{PROP:AT,3}   = 0
  BigCal$?SCALE9{PROP:AT,3}   = 0
  BigCal$?SCALE10{PROP:AT,3}  = 0
  BigCal$?SCALE11{PROP:AT,3}  = 0
  BigCal$?SCALE12{PROP:AT,3}  = 0
  BigCal$?SCALE13{PROP:AT,3}  = 0
  BigCal$?SCALE14{PROP:AT,3}  = 0
  BigCal$?SCALE15{PROP:AT,3}  = 0
  BigCal$?SCALE16{PROP:AT,3}  = 0
  BigCal$?SCALE17{PROP:AT,3}  = 0
  BigCal$?SCALE18{PROP:AT,3}  = 0
  BigCal$?SCALE19{PROP:AT,3}  = 0
  BigCal$?SCALE20{PROP:AT,3}  = 0
  BigCal$?SCALE21{PROP:AT,3}  = 0
  BigCal$?SCALE22{PROP:AT,3}  = 0
  BigCal$?SCALE23{PROP:AT,3}  = 0
  BigCal$?SCALE24{PROP:AT,3}  = 0
  BigCal$?SCALE25{PROP:AT,3}  = 0
  BigCal$?SCALE26{PROP:AT,3}  = 0
  BigCal$?SCALE27{PROP:AT,3}  = 0
  BigCal$?SCALE28{PROP:AT,3}  = 0
  BigCal$?SCALE29{PROP:AT,3}  = 0
  BigCal$?SCALE30{PROP:AT,3}  = 0
  BigCal$?SCALE31{PROP:AT,3}  = 0
  BigCal$?SCALE32{PROP:AT,3}  = 0
  BigCal$?SCALE33{PROP:AT,3}  = 0
  BigCal$?SCALE34{PROP:AT,3}  = 0
  BigCal$?SCALE35{PROP:AT,3}  = 0
  BigCal$?SCALE36{PROP:AT,3}  = 0
  BigCal$?SCALE37{PROP:AT,3}  = 0
  END

  MonthText=''
  CLEAR(DG:ActualDate[])
  CLEAR(DG:SCALE[])
  XDate#=date(month(WorkingDate),1,year(WorkingDate))
  Kill#=day(date(month(WorkingDate)+1,1,year(WorkingDate))-1)
  Start#=(XDate#%7)+1
  Loop Block#=Start# to Kill#+Start#-1
    MonthText = CLIP(MonthText)&FORMAT(Block#-Start#+1,@n_6)
    DG:ActualDate[Block#] = XDate#+Block#-Start#
    IF DG:ActualDate[Block#] = WorkingDate
      BigCal$?ActiveDay{PROP:Xpos} = DG:X[Block#]
      BigCal$?ActiveDay{PROP:Ypos} = DG:Y[Block#]
      COL# = DG:X[Block#]
      ROW# = DG:Y[Block#]
    END

    DG:SCALE[Block#]=RANDOM(0,25)                 !<== Random "DATA" added here

  END
  MonthText = ALL(' ',Start#*6-5)&LEFT(MonthText)
  DO RefreshTitle

  IF ShowData > 0
  Loop Block#=Start# to Kill#+Start#-1
    IF DG:SCALE[Block#] < 2 THEN CYCLE.

    IF DG:ActualDate[Block#]%7 = 6 OR NOT DG:ActualDate[Block#]%7 THEN CYCLE.

    IF DG:SCALE[Block#] >= 23                   !<== change fill color by %
      EXECUTE Block#
        BigCal$?SCALE1{PROP:Fill}  = 0FFH
        BigCal$?SCALE2{PROP:Fill}  = 0FFH
        BigCal$?SCALE3{PROP:Fill}  = 0FFH
        BigCal$?SCALE4{PROP:Fill}  = 0FFH
        BigCal$?SCALE5{PROP:Fill}  = 0FFH
        BigCal$?SCALE6{PROP:Fill}  = 0FFH
        BigCal$?SCALE7{PROP:Fill}  = 0FFH
        BigCal$?SCALE8{PROP:Fill}  = 0FFH
        BigCal$?SCALE9{PROP:Fill}  = 0FFH
        BigCal$?SCALE10{PROP:Fill} = 0FFH
        BigCal$?SCALE11{PROP:Fill} = 0FFH
        BigCal$?SCALE12{PROP:Fill} = 0FFH
        BigCal$?SCALE13{PROP:Fill} = 0FFH
        BigCal$?SCALE14{PROP:Fill} = 0FFH
        BigCal$?SCALE15{PROP:Fill} = 0FFH
        BigCal$?SCALE16{PROP:Fill} = 0FFH
        BigCal$?SCALE17{PROP:Fill} = 0FFH
        BigCal$?SCALE18{PROP:Fill} = 0FFH
        BigCal$?SCALE19{PROP:Fill} = 0FFH
        BigCal$?SCALE20{PROP:Fill} = 0FFH
        BigCal$?SCALE21{PROP:Fill} = 0FFH
        BigCal$?SCALE22{PROP:Fill} = 0FFH
        BigCal$?SCALE23{PROP:Fill} = 0FFH
        BigCal$?SCALE24{PROP:Fill} = 0FFH
        BigCal$?SCALE25{PROP:Fill} = 0FFH
        BigCal$?SCALE26{PROP:Fill} = 0FFH
        BigCal$?SCALE27{PROP:Fill} = 0FFH
        BigCal$?SCALE28{PROP:Fill} = 0FFH
        BigCal$?SCALE29{PROP:Fill} = 0FFH
        BigCal$?SCALE30{PROP:Fill} = 0FFH
        BigCal$?SCALE31{PROP:Fill} = 0FFH
        BigCal$?SCALE32{PROP:Fill} = 0FFH
        BigCal$?SCALE33{PROP:Fill} = 0FFH
        BigCal$?SCALE34{PROP:Fill} = 0FFH
        BigCal$?SCALE35{PROP:Fill} = 0FFH
        BigCal$?SCALE36{PROP:Fill} = 0FFH
        BigCal$?SCALE37{PROP:Fill} = 0FFH
      END

    ELSIF DG:SCALE[Block#] >= 19
      EXECUTE Block#
        BigCal$?SCALE1{PROP:Fill}  = 080FFH
        BigCal$?SCALE2{PROP:Fill}  = 080FFH
        BigCal$?SCALE3{PROP:Fill}  = 080FFH
        BigCal$?SCALE4{PROP:Fill}  = 080FFH
        BigCal$?SCALE5{PROP:Fill}  = 080FFH
        BigCal$?SCALE6{PROP:Fill}  = 080FFH
        BigCal$?SCALE7{PROP:Fill}  = 080FFH
        BigCal$?SCALE8{PROP:Fill}  = 080FFH
        BigCal$?SCALE9{PROP:Fill}  = 080FFH
        BigCal$?SCALE10{PROP:Fill} = 080FFH
        BigCal$?SCALE11{PROP:Fill} = 080FFH
        BigCal$?SCALE12{PROP:Fill} = 080FFH
        BigCal$?SCALE13{PROP:Fill} = 080FFH
        BigCal$?SCALE14{PROP:Fill} = 080FFH
        BigCal$?SCALE15{PROP:Fill} = 080FFH
        BigCal$?SCALE16{PROP:Fill} = 080FFH
        BigCal$?SCALE17{PROP:Fill} = 080FFH
        BigCal$?SCALE18{PROP:Fill} = 080FFH
        BigCal$?SCALE19{PROP:Fill} = 080FFH
        BigCal$?SCALE20{PROP:Fill} = 080FFH
        BigCal$?SCALE21{PROP:Fill} = 080FFH
        BigCal$?SCALE22{PROP:Fill} = 080FFH
        BigCal$?SCALE23{PROP:Fill} = 080FFH
        BigCal$?SCALE24{PROP:Fill} = 080FFH
        BigCal$?SCALE25{PROP:Fill} = 080FFH
        BigCal$?SCALE26{PROP:Fill} = 080FFH
        BigCal$?SCALE27{PROP:Fill} = 080FFH
        BigCal$?SCALE28{PROP:Fill} = 080FFH
        BigCal$?SCALE29{PROP:Fill} = 080FFH
        BigCal$?SCALE30{PROP:Fill} = 080FFH
        BigCal$?SCALE31{PROP:Fill} = 080FFH
        BigCal$?SCALE32{PROP:Fill} = 080FFH
        BigCal$?SCALE33{PROP:Fill} = 080FFH
        BigCal$?SCALE34{PROP:Fill} = 080FFH
        BigCal$?SCALE35{PROP:Fill} = 080FFH
        BigCal$?SCALE36{PROP:Fill} = 080FFH
        BigCal$?SCALE37{PROP:Fill} = 080FFH
      END
    ELSE
      EXECUTE Block#
        BigCal$?SCALE1{PROP:Fill}  = 00H
        BigCal$?SCALE2{PROP:Fill}  = 00H
        BigCal$?SCALE3{PROP:Fill}  = 00H
        BigCal$?SCALE4{PROP:Fill}  = 00H
        BigCal$?SCALE5{PROP:Fill}  = 00H
        BigCal$?SCALE6{PROP:Fill}  = 00H
        BigCal$?SCALE7{PROP:Fill}  = 00H
        BigCal$?SCALE8{PROP:Fill}  = 00H
        BigCal$?SCALE9{PROP:Fill}  = 00H
        BigCal$?SCALE10{PROP:Fill} = 00H
        BigCal$?SCALE11{PROP:Fill} = 00H
        BigCal$?SCALE12{PROP:Fill} = 00H
        BigCal$?SCALE13{PROP:Fill} = 00H
        BigCal$?SCALE14{PROP:Fill} = 00H
        BigCal$?SCALE15{PROP:Fill} = 00H
        BigCal$?SCALE16{PROP:Fill} = 00H
        BigCal$?SCALE17{PROP:Fill} = 00H
        BigCal$?SCALE18{PROP:Fill} = 00H
        BigCal$?SCALE19{PROP:Fill} = 00H
        BigCal$?SCALE20{PROP:Fill} = 00H
        BigCal$?SCALE21{PROP:Fill} = 00H
        BigCal$?SCALE22{PROP:Fill} = 00H
        BigCal$?SCALE23{PROP:Fill} = 00H
        BigCal$?SCALE24{PROP:Fill} = 00H
        BigCal$?SCALE25{PROP:Fill} = 00H
        BigCal$?SCALE26{PROP:Fill} = 00H
        BigCal$?SCALE27{PROP:Fill} = 00H
        BigCal$?SCALE28{PROP:Fill} = 00H
        BigCal$?SCALE29{PROP:Fill} = 00H
        BigCal$?SCALE30{PROP:Fill} = 00H
        BigCal$?SCALE31{PROP:Fill} = 00H
        BigCal$?SCALE32{PROP:Fill} = 00H
        BigCal$?SCALE33{PROP:Fill} = 00H
        BigCal$?SCALE34{PROP:Fill} = 00H
        BigCal$?SCALE35{PROP:Fill} = 00H
        BigCal$?SCALE36{PROP:Fill} = 00H
        BigCal$?SCALE37{PROP:Fill} = 00H
      END
    END

    EXECUTE Block#
      BigCal$?SCALE1{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE2{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE3{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE4{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE5{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE6{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE7{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE8{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE9{PROP:AT,3}  = DG:SCALE[Block#]
      BigCal$?SCALE10{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE11{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE12{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE13{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE14{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE15{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE16{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE17{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE18{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE19{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE20{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE21{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE22{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE23{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE24{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE25{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE26{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE27{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE28{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE29{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE30{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE31{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE32{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE33{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE34{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE35{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE36{PROP:AT,3} = DG:SCALE[Block#]
      BigCal$?SCALE37{PROP:AT,3} = DG:SCALE[Block#]
    END
  END
  END

  exit

PreLoad routine
  CLEAR(DateGroup)
  Block# = 1
  Loop Ycount#=0 to 5
    Loop Xcount#=0 to 6
      DG:X[Block#] = SUB('005035065095125155185',(Xcount#*3)+1,3)
      DG:Y[Block#] = SUB('018038058078098118',(Ycount#*3)+1,3)
      Block#+=1
    END
  END
  DO LoadMonth
  exit

FindMouseQ Routine
  FOUND# = 0
  CASE Xmouse
  OF 6 to 35
    Xaxis = 1
  OF 36 to 65
    Xaxis = 2
  OF 66 to 95
    Xaxis = 3
  OF 96 to 125
    Xaxis = 4
  OF 126 to 155
    Xaxis = 5
  OF 156 to 185
    Xaxis = 6
  OF 186 to 215
    Xaxis = 7
  END
  CASE Ymouse
  OF 19 to 38
    DGpointer = Xaxis
  OF 39 to 58
    DGpointer = Xaxis+7
  OF 59 to 78
    DGpointer = Xaxis+14
  OF 79 to 98
    DGpointer = Xaxis+21
  OF 99 to 118
    DGpointer = Xaxis+28
  OF 119 to 138
    DGpointer = Xaxis+35
  END
  IF DG:ActualDate[DGpointer]
    WorkingDate = DG:ActualDate[DGpointer]
    BigCal$?ActiveDay{PROP:Xpos} = DG:X[DGpointer]
    BigCal$?ActiveDay{PROP:Ypos} = DG:Y[DGpointer]
    COL# = DG:X[DGpointer]
    ROW# = DG:Y[DGpointer]
    FOUND# = 1
  END
  DO RefreshTitle
  exit

