#TEMPLATE (Cardinal, 'Cardinal Computer Templates')
#! 
#! ------------------------------------------------------------------------------
#! Template Release  1
#! ------------------------------------------------------------------------------
#! Cardinal Templates
#! ------------------------------------------------------------------------------
#! 
#! These are the Cardinal Template Additions.  The templates
#! included in this template set are:
#!
#!
#! CONTROLS
#! 
#! RecursiveAdd   - Recursively Add Records to a File From the Form
#! ------------------------------------------------------------------------------
#! CONTROLS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#! ------------------------------------------------------------------------------
#! RecursiveAdd  - Recursively Add Records to a File From the Form
#! ------------------------------------------------------------------------------
#CONTROL (RecursiveAdd, 'Provide Recursive Add functionality to a FORM'), PRIMARY('Selected File', NOKEY), PROCEDURE
     CONTROLS
       BUTTON('Add'),MSG('Add Another Record'),USE(?RecursiveAdd)
     END

#DISPLAY ('This template will create a button that allows the user')
#DISPLAY ('to recursively add records to a file without returning')
#DISPLAY ('to the browse after each record is added.')
#DISPLAY ('')
#DISPLAY ('(c) 1995 - Cardinal Computer Services - All Rights Reserved')
#ATSTART
#DECLARE (%AutoIncrementOnAdd)
#FIX (%File, %PRIMARY)
#FOR (%Key), WHERE(%KeyAuto)
   #SET (%AutoIncrementOnAdd, %True)
   #BREAK
#ENDFOR
#ENDAT
#AT (%DataSectionAfterWindow)
RecurAddMode Byte
#ENDAT
#AT (%AfterWindowOpening)
  ! --- Cardinal Computer Services Recursive Add Template Code
  if LocalRequest <> InsertRecord
    ?RecursiveAdd{Prop:Hide} = 1
  else
    ?RecursiveAdd{Prop:Hide} = 0
  end
  ! --- End Cardinal Computer Services Recursive Add Template Code
#ENDAT
#AT (%AfterWindowClosing)
  ! --- Cardinal Computer Services Recursive Add Template Code
  IF RecurAddMode
    LocalResponse = RequestCompleted
  end
  ! --- End Cardinal Computer Services Recursive Add Template Code
#ENDAT
#AT (%ControlEventHandling, '?RecursiveAdd', 'Accepted')
  ! --- Cardinal Computer Services Recursive Add Template Code
  #IF (%AutoIncrementOnAdd)
  PUT(%Primary)
  #ELSE
  ADD(%Primary)
  #END
  RecurAddMode = True
  CASE ErrorCode()
    OF NoError
      #FIX (%File, %Primary)
      clear(%FilePrefix:Record)
      if ~WindowInitialized
        do InitializeWindow
      end
      do PrimeFields
      SELECT(FirstField())
    OF DupKeyErr
  #FOR (%Key), WHERE(%KeyDuplicate = 0)
    #FIX (%Key, %Key)
    IF DUPLICATE(%Key)
      IF StandardWarning(Warn:DuplicateKey,'%KeyDescription')
        SELECT(FIRSTFIELD())
        CYCLE
      END
    END
  #ENDFOR
  ELSE
    IF StandardWarning(WARN:InsertError)
      SELECT(FIRSTFIELD())
      CYCLE
    END
  END
  ! --- End Cardinal Computer Services Recursive Add Template Code
#ENDAT
