  PROGRAM

!*********************************************************
! This example program developed to illustrate the use of 
! CW 1.0 in the development of MCI applications by: 
!
!  Larry Teames  [Team TopSpeed]
!  Creative PC Solutions, Chandler AZ
!  CIS:  73150,104
!
!*********************************************************


 INCLUDE('EQUATES.CLW')
 INCLUDE('KEYCODES.CLW')

 INCLUDE('CWWINAPI.INC')


MciGroup        GROUP
MciCommandStr     CSTRING(128)
NbrOfTracks       BYTE
CurrentTrack      BYTE
ContinuousPlay    BYTE
RepeatThisTrack   BYTE
UnitPaused        BYTE
TrackTime         LONG
TrackPosn         LONG
TotalTime         LONG
TotalPosn         LONG
                END

NoShowError     BYTE
DeviceOpen      BYTE
StayOnTop       BYTE
MciCommandRet   CSTRING(128)
PrevStatus      CSTRING(128)
MaxPctBar       LONG
CurrBarPct      DECIMAL(3,2)
PrevBarPct      DECIMAL(3,2)


MAXPNAMELEN     EQUATE(32)

AUXCAPS              GROUP
acaps_wMid             SHORT    ! manufacturer ID
acaps_wPid             SHORT    ! product ID
acaps_vDriverVersion   SHORT    ! version of the driver
acaps_szPname          CSTRING(MAXPNAMELEN) ! product name (NULL terminated string)
acaps_wTechnology      SHORT    ! type of device
acaps_dwSupport        LONG     ! functionality supported by driver
                     END


! flags for wTechnology field in AUXCAPS structure

AUXCAPS_CDAUDIO    EQUATE(1)       ! audio from internal CD-ROM drive
AUXCAPS_AUXIN      EQUATE(2)       ! audio from auxiliary input jacks


! flags for dwSupport field in AUXCAPS structure

AUXCAPS_VOLUME      EQUATE(0001h)  ! supports volume control
AUXCAPS_LRVOLUME    EQUATE(0002h)  ! separate left-right volume control


! Volume Structure

AUX_Volume          LONG
AUX_Volume_LR       GROUP,OVER(AUX_Volume)
AUX_Volume_L          USHORT
AUX_Volume_R          USHORT
                    END

MMVolume            DECIMAL(3,1)

VolumeScale         CSTRING(562)


VersionNo           STRING('ver 1.1')

    MAP
      CD_PLAYER
      MCIcommand(STRING),LONG
    END


  CODE
  CD_Player



CD_PLAYER     PROCEDURE


CDPlayWin WINDOW('Audio CD Player'),AT(,,155,85),CENTER,IMM,ICON('CD.ICO'),STATUS(30,30,40,30,30),SYSTEM, |
         GRAY,MAX,DOUBLE,AUTO
       GROUP,AT(3,0,137,22),USE(?Group1),BOXED
         BUTTON,AT(6,6,14,13),USE(?MMffwd),ICON('SMM_FFWD.ICO')
         BUTTON,AT(22,6,14,13),USE(?MMplay),ICON('SMM_PLAY.ICO')
         BUTTON,AT(38,6,14,13),USE(?MMback),ICON('SMM_BACK.ICO')
         BUTTON,AT(54,6,14,13),USE(?MMrwnd),ICON('SMM_RWND.ICO')
         BUTTON,AT(72,6,14,13),USE(?MMpause),ICON('SMM_PAUS.ICO')
         BUTTON,AT(88,6,14,13),USE(?MMstop),ICON('SMM_STOP.ICO')
         BUTTON,AT(106,6,14,13),USE(?MMopen),ICON('SMM_OPEN.ICO')
         BUTTON,AT(122,6,14,13),USE(?MMclose),ICON('SMM_CLOS.ICO')
       END
       GROUP,AT(3,19,137,44),USE(?Group2),BOXED
         CHECK('Repeat Track:'),AT(88,26,,),FONT('Arial',8,,FONT:bold),USE(RepeatThisTrack),LEFT
         CHECK('Continuous Play:'),AT(80,38,,),FONT('Arial',8,,FONT:bold),USE(ContinuousPlay),LEFT
         BUTTON('01'),AT(6,26,10,10),FONT('Arial',8,,),USE(?TRACK01)
         BUTTON('02'),AT(18,26,10,10),FONT('Arial',8,,),USE(?TRACK02)
         BUTTON('03'),AT(30,26,10,10),FONT('Arial',8,,),USE(?TRACK03)
         BUTTON('04'),AT(42,26,10,10),FONT('Arial',8,,),USE(?TRACK04)
         BUTTON('05'),AT(54,26,10,10),FONT('Arial',8,,),USE(?TRACK05)
         BUTTON('06'),AT(66,26,10,10),FONT('Arial',8,,),USE(?TRACK06)
         BUTTON('07'),AT(6,38,10,10),FONT('Arial',8,,),USE(?TRACK07)
         BUTTON('08'),AT(18,38,10,10),FONT('Arial',8,,),USE(?TRACK08)
         BUTTON('09'),AT(30,38,10,10),FONT('Arial',8,,),USE(?TRACK09)
         BUTTON('10'),AT(42,38,10,10),FONT('Arial',8,,),USE(?TRACK10)
         BUTTON('11'),AT(54,38,10,10),FONT('Arial',8,,),USE(?TRACK11)
         BUTTON('12'),AT(66,38,10,10),FONT('Arial',8,,),USE(?TRACK12)
         BUTTON('13'),AT(6,50,10,10),FONT('Arial',8,,),USE(?TRACK13)
         BUTTON('14'),AT(18,50,10,10),FONT('Arial',8,,),USE(?TRACK14)
         BUTTON('15'),AT(30,50,10,10),FONT('Arial',8,,),USE(?TRACK15)
         BUTTON('16'),AT(42,50,10,10),FONT('Arial',8,,),USE(?TRACK16)
         BUTTON('17'),AT(54,50,10,10),FONT('Arial',8,,),USE(?TRACK17)
         BUTTON('18'),AT(66,50,10,10),FONT('Arial',8,,),USE(?TRACK18)
         CHECK('Always on Top:'),AT(84,50,,),FONT('Arial',8,,FONT:bold),USE(StayOnTop),LEFT
       END
       GROUP,AT(3,62,137,13),USE(?Group3),BOXED
         BOX,AT(5,68,133,5),USE(?PCTBAR),FILL(0FFH)
       END
       STRING('Vol'),AT(143,3,10,9),FONT('Arial',8,,FONT:bold),USE(?Volstr),TRN
       LIST,AT(143,10,9,74),FONT('Arial',8,,FONT:regular),USE(MMVolume),IMM,VSCROLL,CENTER,FROM('0')
       STRING('(c) Creative PC Solutions & Larry Teames, 1994'),AT(8,76,,),FONT('Arial',8,0808080H,FONT:bold+FONT:italic), |
           USE(?Copyright)
     END


  CODE

  OPEN(CDPlayWin)
  TARGET{PROP:TEXT} = 'CD Audio Player '&VersionNo
  MaxPctBar = ?PctBar{PROP:WIDTH}
  DO DISABLE_BUTTONS

  AuxDevs# = auxGetNumDevs()
  IF ~AuxDevs#
    IF MESSAGE('No AUX Device Drivers Installed.').
  END

  IF ~AuxDevs#
    MMVolume = 0
    ?MMVolume{PROP:Hide} = True
    TARGET{PROP:WIDTH} = 143
  ELSE
    LOOP AD# = 1 TO AuxDevs#
      Err# = auxGetDevCaps(AD#-1,AUXCAPS,SIZE(AUXCAPS))
      IF Err# OR acaps_wTechnology <> AUXCAPS_CDAUDIO; CYCLE.
      Err# = auxGetVolume(AD#-1,Aux_Volume)
      IF Err#; CYCLE.
      ?MMvolume{PROP:FROM} = ''
      MMvolume = 0
      AuxDev# = AD#
      LOOP CNT# = 1 TO 110  ! 110 because thumb only returns 90 if 100 entries
       VolumeScale = VolumeScale & FORMAT(CNT#/10,@N4.1) & '|'
      END
      VolumeScale[LEN(VolumeScale)] = '<0>'
      ?MMvolume{PROP:FROM} = VolumeScale
      MMVolume = ROUND((Aux_Volume_L*10)/0FFFFh,.1)
      MMVolume = 10.0 - MMVolume
      IF MMVolume = 0; MMVolume = .1 .
      ?MMvolume{PROP:VSCROLL} = MMVolume * 10
      DO SET_Volume
      ?VolStr{PROP:Hide} = False
      ?MMVolume{PROP:Hide} = False
      BREAK
    END
  END


  ACCEPT
    CASE EVENT()
      OF EVENT:OpenWindow
        DISABLE(?MMffwd,?MMclose)
        DISABLE(?RepeatThisTrack,?ContinuousPlay)
        CLEAR(MciGroup)
        CLEAR(PrevStatus)
        Err# = MciCommand('open cdaudio alias music')
        IF Err#; RETURN.
        Err# = MciCommand('set music time format tmsf')
        IF Err#; RETURN.
        DeviceOpen = 1
        TARGET{PROP:TIMER} = 50
        StayOnTop = 0


      OF EVENT:CloseDown
      OROF EVENT:CloseWindow
        IF DeviceOpen
          NoShowError = 1
          Err# = MciCommand('stop music')
          Err# = MciCommand('close music')
        END


      OF EVENT:Timer
        IF StayOnTop
          IF SetWindowPos(TARGET{PROP:Handle},HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE).
        END

        Err# = MciCommand('status music mode')
        IF ~Err# AND ((MciCommandRet <> PrevStatus) OR (MciCommandRet = 'stopped' AND UnitPaused))
          IF MciCommandRet <> 'stopped' OR ~UnitPaused
            TARGET{PROP:Timer} = 50
            ?MMpause{PROP:ICON} = '~SMM_PAUS.ICO'
          END
          CASE MciCommandRet
            OF 'not ready'
              CLEAR(MciGroup)
              DO DISABLE_BUTTONS
              DISABLE(?MMffwd,?MMclose)
              DISABLE(?RepeatThisTrack,?ContinuousPlay)
              ENABLE(?MMopen)
            OF 'open'
              CLEAR(MciGroup)
              DO DISABLE_BUTTONS
              DISABLE(?MMffwd,?MMclose)
              DISABLE(?RepeatThisTrack,?ContinuousPlay)
              ENABLE(?MMclose)
            OF 'stopped'
              IF ~UnitPaused
                DISABLE(?MMffwd,?MMclose)
                DISABLE(?RepeatThisTrack,?ContinuousPlay)
                ENABLE(?MMplay)
                ENABLE(?MMopen)
              ELSIF UnitPaused = 1
                ENABLE(?MMffwd,?MMclose)
                ENABLE(?RepeatThisTrack,?ContinuousPlay)
                DISABLE(?MMclose)
                DISABLE(?MMstop)
                DISABLE(?MMplay)
                UnitPaused = 2
                TARGET{PROP:Timer} = 75
              ELSE
                IF UnitPaused = 2
                  ?MMpause{PROP:ICON} = '~SMM_PAUS.ICO'
                  UnitPaused = 3
                ELSE
                  ?MMpause{PROP:ICON} = '~SMM_PAU2.ICO'
                  UnitPaused = 2
                END
              END

            OF 'playing'
              ENABLE(?MMffwd,?MMclose)
              ENABLE(?RepeatThisTrack,?ContinuousPlay)
              DISABLE(?MMplay)
              DISABLE(?MMclose)
              UnitPaused = 0
            OF 'seeking'
              DISABLE(?MMffwd,?MMclose)
              DISABLE(?RepeatThisTrack,?ContinuousPlay)
              ENABLE(?MMopen)
              UnitPaused = 0
          END
        END
        PrevStatus = MciCommandRet
        IF ~Err# AND PrevStatus AND |
          PrevStatus <> 'open' AND PrevStatus <> 'not ready'
            Err# = MciCommand('status music current track')
            IF ~Err#
              CurrentTrack = MciCommandRet
            END
        END

        x# = mcicommand('set music time format ms')
        IF ~TotalTime AND PrevStatus AND |
           PrevStatus <> 'open' AND PrevStatus <> 'not ready'
          Err# = MciCommand('status music number of tracks')
          IF ~Err#
            NbrOfTracks = MciCommandRet
            DO ENABLE_BUTTONS
            MciCommandRet = ''
          END
          x# = mcicommand('status music length')
          TotalTime = MciCommandRet / 10
        END

        IF CurrentTrack
          x# = mcicommand('status music length track ' & CurrentTrack)
          TrackTime = MciCommandRet / 10

          x# = mcicommand('status music position')
          TotalPosn = MciCommandRet / 10

          x# = mcicommand('status music position track '&CurrentTrack)
          TrackPosn = TotalPosn - (MciCommandRet / 10) + 1
          TARGET{PROP:StatusText,3} = 'Track ' & CurrentTrack
        ELSE
          TARGET{PROP:StatusText,3} = ''
        END
        TARGET{PROP:StatusText,1} = FORMAT(TotalTime,@t4)
        TARGET{PROP:StatusText,2} = FORMAT(TotalPosn,@t4)
        TARGET{PROP:StatusText,4} = FORMAT(TrackTime,@t4)
        TARGET{PROP:StatusText,5} = FORMAT(TrackPosn,@t4)
        CurrBarPct = TotalPosn/TotalTime
        IF CurrBarPct <> PrevBarPct
          ?PctBar{PROP:WIDTH} = ROUND(MaxPctBar * CurrBarPct,0)
        END
        PrevBarPct = CurrBarPct
        x# = mcicommand('set music time format tmsf')
        IF RepeatThisTrack
          IF PrevTrack# and PrevTrack# < CurrentTrack
            POST(EVENT:Accepted,?MMback)
          END
        END
        IF CurrentTrack AND CurrentTrack <> PrevTrack#
          SELECT(?Track01+CurrentTrack-1)
        END
        PrevTrack# = CurrentTrack
        IF TotalPosn AND (TotalPosn => TotalTime)
          IF RepeatThisTrack
            Err# = MciCommand('play music from ' & CurrentTrack)
          ELSIF ContinuousPlay
            POST(EVENT:Accepted,?MMrwnd)
          ELSE
            CurrentTrack = 1
            Err# = MciCommand('seek music to start')
          END
        END


      OF EVENT:SCROLLDRAG
        CASE FIELD()
          OF ?MMvolume
            V# = ?MMvolume{PROP:VSCROLLPOS}
            MMvolume = V# / 10
            DO SET_VOLUME
        END


      OF EVENT:SCROLLUP
        IF MMvolume > .1
          MMvolume -= .1
          ?MMvolume{PROP:VSCROLLPOS} = MMvolume * 10
          DO SET_VOLUME
        END

      OF EVENT:SCROLLDOWN
        IF MMvolume < 10.0
          MMvolume += .1
          ?MMvolume{PROP:VSCROLLPOS} = MMvolume * 10
          DO SET_VOLUME
        END


      OF EVENT:Accepted
        CASE Accepted()

          OF ?MMplay
            Err# = MciCommand('play music from ' & CurrentTrack)
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?MMffwd
            IF CurrentTrack+1 <= NbrOfTracks
              CurrentTrack += 1
              Err# = MciCommand('play music from ' & CurrentTrack)
            END
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?MMback
            CurrentTrack -= 1
            IF CurrentTrack < 1; CurrentTrack = 1.
            Err# = MciCommand('play music from ' & CurrentTrack)
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?MMrwnd
            CurrentTrack = 1
            Err# = MciCommand('play music from ' & CurrentTrack)


          OF ?MMstop
            Err# = MciCommand('stop music')
            PrevStatus = ''
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?MMpause
            IF ~UnitPaused
              UnitPaused = 1
              Err# = MciCommand('pause music')
            ELSE
              UnitPaused = 0
              Err# = MciCommand('play music')
            END
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).



          OF ?MMopen
            Err# = MciCommand('set music door open')


          OF ?MMclose
            Err# = MciCommand('set music door closed')


!          OF ?MMVolume
!            DO SET_VOLUME


          OF ?TRACK01 TO ?TRACK18
            CurrentTrack = FIELD()-?TRACK01+1
            Err# = MciCommand('play music from ' & CurrentTrack)
            UnitPaused = 0


          OF ?ContinuousPlay
            RepeatThisTrack = 0
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?RepeatThisTrack
            ContinuousPlay = 0
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


          OF ?StayOnTop
            IF ~StayOnTop
              IF SetWindowPos(TARGET{PROP:Handle},HWND_NONTOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE).
            END
            IF CurrentTrack; SELECT(?Track01+CurrentTrack-1).


        END
    END
  END
  CLOSE(CDPlayWin)



SET_VOLUME        ROUTINE
  Aux_Volume_L = 6552*(10.0 - MMVolume)     ! 65520 / 10
  Aux_Volume_R = Aux_Volume_L
  Err# = auxSetVolume(AuxDev#-1,Aux_Volume)


DISABLE_BUTTONS   ROUTINE
  LOOP T# = ?TRACK01 TO ?TRACK18
    T#{PROP:TEXT} = ''
    T#{PROP:HIDE} = True
    DISABLE(T#)
    ?PctBar{PROP:WIDTH} = 0
  END


ENABLE_BUTTONS   ROUTINE
  LOOP T# = ?TRACK01 TO ?TRACK18
    T#{PROP:TEXT} = T#-?TRACK01+1
    T#{PROP:HIDE} = False
    ENABLE(T#)
    IF T#-?TRACK01+1 = NbrOfTracks
      BREAK
    END
  END


!-------------------------------------------------------------------------
!-------------------------------------------------------------------------
MCIcommand   FUNCTION(MciCmdStr)

  CODE
  MciCommandStr = MciCmdStr
  RetErr# = MciSendString(MciCommandStr, MciCommandRet, 128, 0)
  IF NoShowError; RETURN(RetErr#).
  IF RetErr#
    y# = MciGetErrorString(RetErr#,MciCommandRet,128)
    IF MESSAGE(MciCommandRet).
    RETURN(RetErr#)
  ELSE
    RETURN(0)
  END
