
                MEMBER( 'HCWSM' )

!=========================================================================
!  Browse Data Dictionary
!=========================================================================
DDMbrw          FUNCTION

                ! Return:
ilRetVal        LONG

                ! Locals:
sIndex          STRING(20)

List1:Queue     QUEUE,PRE(L1Q)
sType             STRING(12)
sField            STRING(64)
ilID              LONG
                END

wWindow WINDOW('HCW Data Dictionary'),AT(,,320,240),FONT('MS Sans Serif',10,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MAXIMIZE
       STRING('Criteria Headings'),AT(96,4,,),USE(?String3)
       STRING('Data Fields'),AT(100,120,,),USE(?String1)
       CUSTOM('Outline'),AT(8,16,220,96),USE(?Outline),CLASS('MSOUTLIN.VBX','Outline')
       BUTTON('&Expand All'),AT(236,32,44,14),USE(?ExpandAll)
       BUTTON('&Collapse All'),AT(236,84,44,14),USE(?CollapseAll)
       LIST,AT(8,132,220,76),USE(?List1),VSCROLL,FORMAT('53L(2)|~Type~C(0)@s12@20L(2)~Description~@s64@'), |
           FROM(List1:Queue)
       BUTTON('&Select'),AT(236,136,44,14),USE(?Select),DEFAULT
       BUTTON('&New'),AT(236,168,44,14),USE(?New)
       BUTTON('&Change'),AT(236,192,44,14),USE(?Change)
     END

isIndex         SHORT
isIndent        SHORT

  CODE
  FileOpen(QueHeads, QueHeads::Open)
  FileOpen(DDMst,    DDMst::Open   )
  FileOpen(DDTypes,  DDTypes::Open )

  OPEN(wWindow)

  DO InitOutline

  ACCEPT
     CASE EVENT()
      OF EVENT:VbxEvent
        CASE FIELD()
          OF ?Outline
            CASE ?Outline{PROP:VBXEvent}
              OF 'Click'
                DO LoadFields
            END
        END
       OF EVENT:Accepted
        CASE FIELD()
          OF ?ExpandAll
            DO ExpandAll
          OF ?CollapseAll
            DO CollapseAll
          OF ?Select
            DO SelField
            POST(EVENT:CloseWindow)
          OF ?Change
            DO ChangeField
          OF ?New
            DO NewField
        END
     END
   END
   CLOSE( wWindow )
   FileClose(QueHeads, QueHeads::Open)
   FileClose(DDMst,    DDMst::Open   )
   FileClose(DDTypes,  DDTypes::Open )
   RETURN( ilRetVal )

!--------------------------------------------------------------------
InitOutline     ROUTINE
!--------------------------------------------------------------------
  ?Outline{'Style'}       = 6
  ?Outline{'BorderStyle'} = 1
  ?Outline{'BackColor'}   = COLOR:Red

  ?Outline{'List',   0} = 'HCW Selection Criteria'
  ?Outline{'Indent', 0} = 0
  isIndex = 1

  SET( QHD:ByLevel )
  LOOP
    NEXT( QueHeads )
    IF ERRORCODE() THEN BREAK.
    IF    QHD:ibLevel2
      isIndent = 3
    ELSIF QHD:ibLevel1
      isIndent = 2
    ELSE
      isIndent = 1
    END
    ?Outline{'List',   isIndex} = QHD:sText
    ?Outline{'Indent', isIndex} = isIndent
    isIndex += 1
  END

  ?Outline{'ListIndex'} = 0
  ?Outline{'TabStop'}   = TRUE

!--------------------------------------------------------------------
ExpandAll       ROUTINE
!--------------------------------------------------------------------
  MaxItems# = ?Outline{'ListCount'}
  LOOP isIndex = 0 TO MaxItems# - 1
    ?Outline{'Expand', isIndex} = TRUE
  END

!--------------------------------------------------------------------
CollapseAll     ROUTINE
!--------------------------------------------------------------------
  MaxItems# = ?Outline{'ListCount'}
  LOOP isIndex = 0 TO MaxItems# - 1
    ?Outline{'Expand', isIndex} = FALSE
  END

!--------------------------------------------------------------------
LoadFields      ROUTINE
!--------------------------------------------------------------------
  isIndex = ?Outline{'ListIndex'}
  FREE(List1:Queue)
  CLEAR(DDM:Record)
  DDM:ilCategID = isIndex
  SET(DDM:ByCateg, DDM:ByCateg)
  LOOP
    NEXT(DDMSt)
    IF ERRORCODE() THEN BREAK.
    IF DDM:ilCategID <> isIndex THEN BREAK.
    CLEAR( DDT:Record )
    DDT:ilID = DDM:ilTypeID
    GET(DDTypes, DDT:ByID)
    L1Q:sType  = DDT:sName
    L1Q:sField = DDM:sDesc
    L1Q:ilID   = DDM:ilID
    ADD(List1:Queue)
  END
  DISPLAY

!--------------------------------------------------------------------
SelField        ROUTINE
!--------------------------------------------------------------------
  IF CHOICE(?List1)
    GET(List1:Queue, CHOICE(?List1))
    CLEAR( DDM:Record )
    DDM:ilID = L1Q:ilID
    GET(DDMst, DDM:ByID)
    ilRetVal = L1Q:ilID
  ELSE
    ilRetVal = 0
  END

!--------------------------------------------------------------------
ChangeField     ROUTINE
!--------------------------------------------------------------------
  IF CHOICE(?List1)
    GET(List1:Queue, CHOICE(?List1))
    CLEAR( DDM:Record )
    DDM:ilID = L1Q:ilID
    GET(DDMst, DDM:ByID)
    IF DDMupd(ChangeRecord, isIndex)
      DO LoadFields
    END
  END

!--------------------------------------------------------------------
NewField        ROUTINE
!--------------------------------------------------------------------
  IF DDMupd(InsertRecord, isIndex)
    DO LoadFields
  END
