
                MEMBER( 'HCWSM' )

!-------------------------------------------------------------------------
!  Module Equates
!-------------------------------------------------------------------------

eFirstHandle    EQUATE(1000)
eFirstRegion    EQUATE(1100)
eFirstOutline   EQUATE(1200)

!-------------------------------------------------------------------------
!  Module Variables
!-------------------------------------------------------------------------
sMemo           STRING(SIZE(SCN:Memo)),OVER(SCN:Memo)

!-------------------------------------------------------------------------
!  Local Map
!-------------------------------------------------------------------------
  MAP
    Max( SHORT, SHORT ), SHORT
    Preview( STRING, SHORT, SHORT )
  END


!=========================================================================
! Main procedure
!=========================================================================
EditScreen      PROCEDURE

bbMoving        BYTE

bbResizing      BYTE
isResizeFlags   SHORT

sPriority       STRING(32)

isField         SHORT
isParent        SHORT

isHandle        SHORT

isFirstField    SHORT
isLastField     SHORT

ilDDID          LONG

wWindow WINDOW,AT(0,0,365,183),FONT('Arial',10,,FONT:regular),SYSTEM,MAX,MAXIMIZE,MDI
       MENUBAR,NOMERGE
         MENU('&File'),USE(?File)
           ITEM('&Close'),USE(?Close)
         END
         MENU('&Edit'),USE(?Edit)
           ITEM('C&ut'),USE(?Cut),KEY(DeleteKey)
           ITEM('&Copy'),USE(?Copy),KEY(CtrlInsert)
           ITEM('&Paste'),USE(?Paste),KEY(ShiftInsert)
         END
         MENU('&Options'),USE(?Options)
           ITEM('&Grid'),USE(?Grid)
         END
       END
       BUTTON('&Next Page'),AT(292,156,56,20),USE(?Button1),DEFAULT
       BUTTON('&Previous Page'),AT(292,188,56,20),USE(?Button2)
     END

isRegion        SHORT

isOutline       SHORT

isQueueNdx      SHORT

isDeltaX        SHORT
isDeltaY        SHORT

isXPos          SHORT
isYPos          SHORT
isWidth         SHORT
isHeight        SHORT

isNewXPos       SHORT
isNewYPos       SHORT
isNewWidth      SHORT
isNewHeight     SHORT

isRetVal        SHORT

isCreate        SHORT
ilFldTyp        LONG

  CODE                                          ! Begin processed code
  FileOpen(ScrnIndx, ScrnIndx::Open)
  FileOpen(DDMst,    DDMst::Open   )

  CLEAR(SCN:Record)
  SCN:ilID = ilgScreenID
  GET(ScrnIndx, SCN:ByID)
  IF ERRORCODE()
    Warning( 'Could not load record: ' & ilgScreenID )
  END

  OPEN(wWindow)
  wWindow{PROP:Text} = CLIP(sWindowTitle) &  ' (Design Mode)'

  DO Init

  DO CreateRegion

  FieldInit()

  isFirstField = 100
  isLastField  =  99
  FieldLoad(sMemo, isLastField)
  UNHIDE(isFirstField, isLastField)

  isOutline = eFirstOutline
  CREATE(isOutline, CREATE:Region)
  isOutline{PROP:Color} = COLOR:Red

  IF NOT isgToolsThread
    isgToolsThread = START(ToolsPalette, 16000)
  END

  SELECT( isRegion )
  ACCEPT
    isgMouseX = MOUSEX()
    isgMouseY = MOUSEY()

    CASE ACCEPTED()
      OF ?Cut
        IF isField
          HandleShow( 0 )
          FieldCut( isField )
          isField = 0
        END
        CYCLE
      OF ?Close
        POST(EVENT:CloseWindow)
        CYCLE
    END
 
    CASE EVENT()

      OF EVENT:ToolArrow
        SETCURSOR()
        isCreate = 0

      OF EVENT:ToolDataFld
        ilDDID = DDMbrw()
        IF ilDDID
          SETCURSOR(CURSOR:Cross)
          ilFldTyp = DDM:ilTypeID
          CASE ilFldTyp
            OF eDDType_Check
              isCreate = CREATE:Check
            OF eDDType_Entry
              isCreate = CREATE:Entry
            OF eDDType_DropList
              isCreate = CREATE:DropList
            OF eDDType_Option
              isCreate = CREATE:Option
          END
        END

      OF EVENT:ToolRadioBtn
        SETCURSOR(CURSOR:Cross)
        ilDDID   = 0
        ilFldTyp = 0
        isCreate = CREATE:Radio
        SETCURSOR(CURSOR:Cross)

      OF EVENT:ToolText
        SETCURSOR(CURSOR:Cross)
        ilFldTyp = 0
        ilDDID   = 0
        isCreate = CREATE:String

      OF EVENT:ToolGroupBox
        SETCURSOR(CURSOR:Cross)
        ilDDID   = 0
        ilFldTyp = 0
        isCreate = CREATE:Group

      OF EVENT:ToolBox
        SETCURSOR(CURSOR:Cross)
        ilDDID   = 0
        ilFldTyp = 0
        isCreate = CREATE:Box

      OF EVENT:ToolImage
        SETCURSOR(CURSOR:Cross)
        ilDDID   = 0
        ilFldTyp = 0
        isCreate = CREATE:Image

      OF EVENT:ToolPreview
        Preview( sWindowTitle, isFirstField, isLastField )

      OF EVENT:MouseDown
        CASE KEYCODE()
          OF MouseLeft
            IF isCreate
              isParent = 0
              IF isCreate = CREATE:Radio
                isParent = FieldIndex(isgMouseX, isgMouseY)
                IF (NOT isParent) OR (isParent{PROP:Type} <> CREATE:Option)
                  Junk# = Message( 'Radio Buttons may only be placed within a Radio Box' )
                  CYCLE
                END
              END
              isLastField += 1
              isField = FieldNew( isLastField, ilDDID, isCreate, isParent )
              UNHIDE( isField )
              HandleShow( isField )
              POST(EVENT:ToolArrow,, isgToolsThread)
              isCreate = 0
              isParent = 0
              SETCURSOR()
              DO MouseRightUp
            ELSE
              DO MouseLeftDown
            END
        END

      OF EVENT:MouseMove
        POST(EVENT:ToolPosition,, isgToolsThread)
        DO MouseMove

      OF EVENT:MouseUp
        CASE KEYCODE()
          OF MouseLeft
            DO MouseLeftUp
          OF MouseRight
            DO MouseRightUp
        END

      OF EVENT:CloseWindow
        Resp# = Message( 'Save changes to window layout?', 'Confirm',, |
                      BUTTON:Yes + BUTTON:No + BUTTON:Cancel, BUTTON:Yes)
        CASE Resp#
          OF BUTTON:Cancel
            CYCLE
          OF BUTTON:Yes
            FieldSave(sMemo, isFirstField, isLastField)
            PUT(ScrnIndx)
        END

    END
  END

  POST(EVENT:CloseWindow,, isgToolsThread)

  FileClose(DDMst,    DDMst::Open   )
  FileClose(ScrnIndx, ScrnIndx::Open)
  CLOSE(wWindow)
  RETURN

!-------------------------------------------------------------------------
Init            ROUTINE     ! Initialize variables
!-------------------------------------------------------------------------
  bbMoving   = FALSE
  bbResizing = FALSE
  isCreate   = 0
  isField    = 0
  HandleInit( eFirstHandle )

!-------------------------------------------------------------------------
CreateRegion    ROUTINE     ! Create full-screen region for mouse events
!-------------------------------------------------------------------------
  isRegion = eFirstRegion
  CREATE(isRegion, CREATE:Region)
  isRegion{PROP:XPos}   = wWindow{PROP:XPos}
  isRegion{PROP:YPos}   = wWindow{PROP:YPos}
  isRegion{PROP:Width}  = wWindow{PROP:Width}
  isRegion{PROP:Height} = wWindow{PROP:Height}
  isRegion{PROP:Imm}    = TRUE
  UNHIDE(isRegion)

!-------------------------------------------------------------------------
MouseRightUp    ROUTINE     ! Handle mouse right button down event
!-------------------------------------------------------------------------
 ! Display control handles on selected field, if any
  isField = FieldIndex(isgMouseX, isgMouseY)
  HandleShow( isField )

 ! Display appropriate dialog box
  isRetVal = 0
  IF isField
    CASE isField{PROP:Type}
      OF CREATE:String
        isRetVal = TextDlg( isField )
      OF CREATE:Image
        isRetVal = ImageDlg( isField )
      OF CREATE:Box
        isRetVal = BoxDlg( isField )
      OF CREATE:Entry
        isRetVal = EntryFldDlg( isField )
      OF CREATE:Group
        isRetVal = GroupBoxDlg( isField )
      OF CREATE:Check
        isRetVal = CheckBoxDlg( isField )
      OF CREATE:Option
        isRetVal = RadioBoxDlg( isField )
      OF CREATE:Radio
        isRetVal = RadioBtnDlg( isField )
    END
    IF isRetVal
      FieldWrite( isField )
    END
  END

 ! Redisplay control handles on selected field
  HandleShow( isField )

!-------------------------------------------------------------------------
MouseLeftDown   ROUTINE     ! Handle mouse down event
!-------------------------------------------------------------------------
 ! Clear flags
  bbMoving   = FALSE                            
  bbResizing = FALSE

 ! Hide any currently displayed control handles
  HandleShow( 0 )

 ! Check for click on resize handles
  IF isField
    isHandle = HandleIndex(isgMouseX, isgMouseY)
    IF isHandle
      isResizeFlags = HandleGetFlags( isHandle )
      HandleCursor( isHandle )
      bbResizing = TRUE
    END
  END

 ! Check for click on field
  IF NOT bbResizing
    isField = FieldIndex(isgMouseX, isgMouseY)
    IF isField
      bbMoving = TRUE
    END
  END

 ! Display control outline if moving or resizing
  IF bbMoving OR bbResizing
    isDeltaX = isgMouseX - isField{PROP:XPos}
    isDeltaY = isgMouseY - isField{PROP:YPos}
    GETPOSITION(isField,   isNewXPos, isNewYpos, isNewWidth, isNewHeight)
    HIDE( isField )
    SETPOSITION(isOutline, isNewXPos, isNewYpos, isNewWidth, isNewHeight)
    UNHIDE( isOutline )
    IF bbMoving
      SETCURSOR( CURSOR:Cross )
    END
  END

!-------------------------------------------------------------------------
MouseMove       ROUTINE     ! Handle mouse move event
!-------------------------------------------------------------------------
!  IF NOT (bbMoving OR bbResizing)
!    isField = FieldIndex(isgMouseX, isgMouseY)
!    IF isField
!      wWindow{PROP:StatusText, 1} = 'Hello'
!    ELSE
!      wWindow{PROP:StatusText, 1} = ''
!    END
!  END

 ! Move control outline if in move mode
  IF bbMoving
    GETPOSITION(isOutline, isNewXPos, isNewYpos, isNewWidth, isNewHeight)
    isNewXPos = isgMouseX - isDeltaX
    isNewYPos = isgMouseY - isDeltaY

    isNewXPos = 5 * ROUND(isNewXPos / 5, 1)
    isNewYPos = 5 * ROUND(isNewYPos / 5, 1)
    SETPOSITION(isOutline, isNewXPos, isNewYpos)
  END

 ! Resize control outline if in resize mode
  IF bbResizing
    GETPOSITION(isOutline, isNewXPos, isNewYpos, isNewWidth, isNewHeight)
    IF BAND(isResizeFlags, eHandleNorth)
      isNewHeight = isNewHeight + (isNewYPos - isgMouseY)
      isNewYPos   = isgMouseY
    END
    IF BAND(isResizeFlags, eHandleSouth)
      isNewHeight = isgMouseY - isNewYPos
    END
    IF BAND(isResizeFlags, eHandleEast)
      isNewWidth = isgMouseX - isNewXPos
    END
    IF BAND(isResizeFlags, eHandleWest)
      isNewWidth = isNewWidth + (isNewXPos - isgMouseX)
      isNewXPos  = isgMouseX
    END
    isNewWidth  = Max(isNewWidth,  5)
    isNewHeight = Max(isNewHeight, 5)

    isNewXPos   = 5 * ROUND(isNewXPos   / 5, 1)
    isNewYPos   = 5 * ROUND(isNewYPos   / 5, 1)
    isNewWidth  = 5 * ROUND(isNewWidth  / 5, 1)
    isNewHeight = 5 * ROUND(isNewHeight / 5, 1)

    SETPOSITION(isOutline, isNewXPos, isNewYPos, isNewWidth, isNewHeight)
  END

!-------------------------------------------------------------------------
MouseLeftUp     ROUTINE     ! Handle mouse left button up event
!-------------------------------------------------------------------------
 ! Update control position if moving or resizing
  IF bbMoving OR bbResizing
    HIDE( isOutline )
    SETPOSITION(isField, isNewXPos, isNewYPos, isNewWidth, isNewHeight)
    UNHIDE( isField )
    FieldRead( isField )
    bbMoving   = FALSE
    bbResizing = FALSE
  END

 ! Display control handles on selected field, if any
  isField = FieldIndex(isgMouseX, isgMouseY)
  HandleShow( isField )
  SETCURSOR()


!=========================================================================
! Preview the current window design
!=========================================================================
Preview          PROCEDURE( sTitle, isFirstField, isLastField )

sPriority       STRING(32)

wWindow WINDOW,AT(0,0,365,229),FONT('Arial',10,,FONT:regular),STATUS,SYSTEM,GRAY,MAXIMIZE
       BUTTON('&Next Page'),AT(292,156,56,20),USE(?Button1),DEFAULT
       BUTTON('&Previous Page'),AT(292,188,56,20),USE(?Button2)
     END

  CODE
  OPEN( wWindow )
  wWindow{PROP:Text} = CLIP(sTitle) &  ' (Preview Mode)'
  wWindow{PROP:StatusText} = 'Press ESC to exit preview mode'

  LOOP I# = isFirstField TO isLastField
    FieldCreate( I# )
    UNHIDE( I# )
  END

  ACCEPT
    CASE EVENT()
      OF EVENT:Accepted
        IF FIELD(){PROP:Type} = CREATE:Button
          BREAK
        END
    END
  END
  CLOSE( wWindow )
  RETURN


!=========================================================================
! Return larger of two quantities
!=========================================================================
Max             FUNCTION( Arg1, Arg2 )

  CODE
  IF Arg1 > Arg2
    RETURN( Arg1 )
  ELSE
    RETURN( Arg2 )
  END

