                     MEMBER('ESTIMATE.clw')       ! This is a MEMBER module
Company PROCEDURE

LocalRequest         LONG,AUTO
OriginalRequest      LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
SAV::COM:Record      STRING(SIZE(COM:Record))
FormWindow           WINDOW('Your Company Information'),AT(22,5,195,154),CENTER,SYSTEM,GRAY,MDI
                       ENTRY(@s30),AT(51,6,135,12),USE(COM:Companyname)
                       ENTRY(@s30),AT(51,21,135,12),USE(COM:Address1)
                       ENTRY(@s30),AT(51,36,135,12),USE(COM:Address2)
                       ENTRY(@s15),AT(51,51,,),USE(COM:City)
                       ENTRY(@s2),AT(123,51,,),USE(COM:State)
                       ENTRY(@K#####-####K),AT(141,51,,),USE(COM:Zip)
                       ENTRY(@s20),AT(51,66,,),USE(COM:Contact)
                       ENTRY(@s20),AT(51,81,,),USE(COM:Title)
                       ENTRY(@K(###) ###-####K),AT(51,96,72,12),USE(COM:Phone)
                       ENTRY(@K(###) ###-####K),AT(51,111,72,12),USE(COM:Fax)
                       BUTTON('OK'),AT(20,133,40,12),USE(?OK),DEFAULT,REQ
                       BUTTON('Cancel'),AT(65,133,40,12),USE(?Cancel)
                       PROMPT('&Contact:'),AT(15,66,27,10),USE(?COM:Contact:Prompt)
                       PROMPT('&Company:'),AT(10,6,33,10),USE(?COM:Companyname:Prompt)
                       PROMPT('&Address:'),AT(13,24,30,10),USE(?COM:Address1:Prompt)
                       PROMPT('&Title:'),AT(24,81,18,10),USE(?COM:Title:Prompt)
                       PROMPT('&City:'),AT(28,51,15,10),USE(?COM:City:Prompt)
                       PROMPT('&Phone:'),AT(18,96,25,10),USE(?COM:Phone:Prompt)
                       PROMPT('&Fax:'),AT(27,111,17,10),USE(?COM:Fax:Prompt)
                     END
  CODE
  LocalRequest = GlobalRequest
  OriginalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  IF Company::Used = 0
    CheckOpen(Company,1)
  END
  Company::Used += 1
  SAV::COM:Record = COM:Record
  IF LocalRequest = InsertRecord
    DO PrimeFields
  END
    IF LocalRequest = DeleteRecord
      IF StandardWarning(Warn:StandardDelete) = Button:OK
        LOOP
          LocalResponse = RequestCancelled
          SETCURSOR(Cursor:Wait)
          IF RIDelete:Company()
            SETCURSOR()
            CASE StandardWarning(Warn:DeleteError)
            OF Button:Yes
              CYCLE
            OF Button:No OROF Button:Cancel
              BREAK
            END
          ELSE
            SETCURSOR()
            LocalResponse = RequestCompleted
          END
          BREAK
        END
      END
      DO ProcedureReturn
    END
  OPEN(FormWindow)
  WindowOpened=True
  CASE LocalRequest
  OF InsertRecord
    ActionMessage = 'Record will be Added'
  OF ChangeRecord
    ActionMessage = 'Record will be Changed'
  OF DeleteRecord
  END
  FormWindow{Prop:StatusText,1} = ActionMessage
  ACCEPT
    CASE EVENT()
    OF EVENT:CloseWindow
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::COM:Record <> COM:Record
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:ConfirmCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?COM:Companyname)
            CYCLE
          END
        END
      END
    OF EVENT:CloseDown
      IF LocalResponse <> RequestCompleted
        RecordChanged = False
        IF LocalRequest = InsertRecord OR LocalRequest = ChangeRecord
          IF SAV::COM:Record <> COM:Record
            RecordChanged = True
          END
        END
        IF RecordChanged
          CASE StandardWarning(Warn:ConfirmCancel)
          OF Button:Yes
            POST(Event:Accepted,?OK)
            CYCLE
          OF Button:No
          OF BUTTON:Cancel
            SELECT(?COM:Companyname)
            CYCLE
          END
        END
      END
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
      END
      SELECT(?COM:Companyname)
    OF EVENT:GainFocus
      WindowInitialized = True
      DO InitializeWindow
    ELSE
      IF EVENT() = Event:Completed
        CASE LocalRequest
        OF InsertRecord
          ADD(Company)
          CASE ERRORCODE()
          OF NoError
            LocalResponse = RequestCompleted
            POST(Event:CloseWindow)
          OF DupKeyErr
            IF DUPLICATE(COM:Key_Companyname)
              IF StandardWarning(Warn:DuplicateKey,'COM:Key_Companyname')
                SELECT(?COM:Companyname)
                CYCLE
              END
            END
          ELSE
            IF StandardWarning(Warn:InsertError)
              SELECT(?COM:Companyname)
              CYCLE
            END
          END
        OF ChangeRecord
          LOOP
            LocalResponse = RequestCancelled
            SETCURSOR(Cursor:Wait)
            IF RIUpdate:Company(SAV::COM:Record)
              SETCURSOR()
              CASE StandardWarning(Warn:UpdateError)
              OF Button:Yes
                CYCLE
              OF Button:No
                POST(Event:CloseWindow)
                BREAK
              OF Button:Cancel
                SELECT(?COM:Companyname)
                BREAK
              END
            ELSE
              SETCURSOR()
              LocalResponse = RequestCompleted
              POST(Event:CloseWindow)
            END
            BREAK
          END
        END
      END
    END
    CASE FIELD()
    OF ?OK
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        IF OriginalRequest = ChangeRecord OR OriginalRequest = InsertRecord
          SELECT()
        ELSE
          POST(EVENT:Completed)
        END
      END
    OF ?Cancel
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn
!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
  Company::Used -= 1
  IF Company::Used = 0 THEN CLOSE(Company).
  IF WindowOpened
    CLOSE(FormWindow)
  END
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!---------------------------------------------------------------------------
InitializeWindow ROUTINE
  DO RefreshWindow
!---------------------------------------------------------------------------
RefreshWindow ROUTINE
  DISPLAY()
  ForceRefresh = False
!---------------------------------------------------------------------------
SyncWindow ROUTINE
!---------------------------------------------------------------------------
PrimeFields ROUTINE
  COM:Record = SAV::COM:Record
  SAV::COM:Record = COM:Record
