
                MEMBER( 'HCWSM' )

!-------------------------------------------------------------------------
!  Module Variables
!-------------------------------------------------------------------------
qFields         QUEUE,PRE(QFI)
isField           SHORT
ilDDID            LONG
isCtrlType        SHORT
isParent          SHORT
isWndTabOrd       SHORT
isGrpTabOrd       SHORT
isXPos            SHORT
isYPos            SHORT
isWidth           SHORT
isHeight          SHORT
sTypeface         STRING(32)
isFontSize        SHORT
ilFontColor       LONG
isFontStyle       SHORT
ilBordColor       LONG
ilFillColor       LONG
bbBoxed           BYTE
isDrop            SHORT
sUse              STRING(32)
sText             STRING(128)
sMessage          STRING(255)
                END

gProps2         GROUP
                  SHORT( eFldField     ); STRING( 'FIELD       ' )
                  SHORT( eFldType      ); STRING( 'TYPE        ' )
                  SHORT( eFldControl   ); STRING( 'CONTROL     ' )
                  SHORT( eFldParent    ); STRING( 'PARENT      ' )
                  SHORT( eFldWndTabOrd ); STRING( 'WNDTABORD   ' )
                  SHORT( eFldGrpTabOrd ); STRING( 'GRPTABORD   ' )
                  SHORT( eFldXpos      ); STRING( 'XPOS        ' )
                  SHORT( eFldYPos      ); STRING( 'YPOS        ' )
                  SHORT( eFldWidth     ); STRING( 'WIDTH       ' )
                  SHORT( eFldHeight    ); STRING( 'HEIGHT      ' )
                  SHORT( eFldTypeface  ); STRING( 'TYPEFACE    ' )
                  SHORT( eFldFontSize  ); STRING( 'FONTSIZE    ' )
                  SHORT( eFldFontColor ); STRING( 'FONTCOLOR   ' )
                  SHORT( eFldFontStyle ); STRING( 'FONTSTYLE   ' )
                  SHORT( eFldBordColor ); STRING( 'BORDERCOLOR ' )
                  SHORT( eFldFillColor ); STRING( 'FILLCOLOR   ' )
                  SHORT( eFldBoxed     ); STRING( 'BOXED       ' )
                  SHORT( eFldDrop      ); STRING( 'DROP        ' )
                  SHORT( eFldUse       ); STRING( 'USE         ' )
                  SHORT( eFldText      ); STRING( 'TEXT        ' )
                  SHORT( eFldMessage   ); STRING( 'MESSAGE     ' )
                  SHORT( eFldEnd       ); STRING( 'END         ' )
                END

gProps          GROUP,DIM(22),PRE(GPR),OVER(gProps2)
isPropID          SHORT
sPropName         STRING(12)
                END

qProps          QUEUE,PRE(QPR)
isPropID          SHORT
sPropName         STRING(12)
                END


!=========================================================================
! Create the specified child control on the active window
!=========================================================================
FieldCreate     PROCEDURE( isField )

  CODE
  QFI:isField = isField
  GET(qFields, +QFI:isField)

  IF QFI:isParent
    CREATE(isField, QFI:isCtrlType, QFI:isParent)
  ELSE
    CREATE(isField, QFI:isCtrlType)
  END

  SETPOSITION(isField, QFI:isXPos, QFI:isYPos, QFI:isWidth, QFI:isHeight)

  IF QFI:sTypeface
    isField{PROP:FontName}  = QFI:sTypeface
  END
  IF QFI:isFontSize
    isField{PROP:FontSize}  = QFI:isFontSize
  END
  IF QFI:ilFontColor
    isField{PROP:FontColor}  = QFI:ilFontColor
  END
  IF QFI:isFontStyle
    isField{PROP:FontStyle}  = QFI:isFontStyle
  END

  isField{PROP:Text} = QFI:sText

  IF QFI:sMessage
    isField{PROP:Msg}  = QFI:sMessage
  END

  CASE QFI:isCtrlType
    OF CREATE:Group
      isField{PROP:Boxed} = QFI:bbBoxed
    OF CREATE:Box
      isField{PROP:Color} = QFI:ilBordColor
      isField{PROP:Fill}  = QFI:ilFillColor
    OF CREATE:Option
      isField{PROP:Boxed} = QFI:bbBoxed
    OF CREATE:DropCombo
      isField{PROP:Drop}  = QFI:isDrop
  END
  RETURN


!=========================================================================
! Delete the specified field
!=========================================================================
FieldCut        PROCEDURE( isField )

  CODE
  HIDE( isField )
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  DELETE( qFields )
  RETURN


!=========================================================================
! Close fields module
!=========================================================================
FieldDone       PROCEDURE

  CODE
  FREE( qFields )
  FREE( qProps  )
  RETURN


!=========================================================================
! Translate mouse click to field equate index
!=========================================================================
FieldIndex      FUNCTION( isMouseX, isMouseY )

                ! Return:
isRetVal        SHORT

                ! Locals:
isQueueNdx      SHORT
isField         SHORT
isCtrlX1        SHORT
isCtrlY1        SHORT
isCtrlX2        SHORT
isCtrlY2        SHORT

  CODE
  isRetVal = 0
  LOOP isQueueNdx = 1 TO RECORDS(qFields)
    GET(qFields, isQueueNdx)
    isField  = QFI:isField
    isCtrlX1 = isField{PROP:XPos}
    isCtrlX2 = isCtrlX1 + isField{PROP:Width}
    isCtrlY1 = isField{PROP:YPos}
    isCtrlY2 = isCtrlY1 + isField{PROP:Height}
    IF INRANGE(isMouseX, isCtrlX1, isCtrlX2) AND INRANGE(isMouseY, isCtrlY1, isCtrlY2)
      isRetVal = isField
      IF (QFI:isCtrlType <> CREATE:Group) AND (QFI:isCtrlType <> CREATE:Option)
        BREAK
      END
    END
  END
  RETURN( isRetVal )


!=========================================================================
! Initialize fields module
!=========================================================================
FieldInit       PROCEDURE

                ! Locals:
isIndex         SHORT

  CODE
  FREE( qFields )
  FREE( qProps  )
  LOOP isIndex = 1 TO MAXIMUM(gProps, 1)
    qProps = gProps[isIndex]
    ADD( qProps )
  END
  RETURN


!=========================================================================
!  Load fields from screen definition (*.SCR) file
!=========================================================================
FieldLoad       PROCEDURE( sBuffer, isLastField )

                ! Locals:
sLine           STRING(255)
isPos           SHORT
sProp           STRING(  32 )
sValue          STRING( 255 )
isInNdx         SHORT
isEndNdx        SHORT

  CODE
  isInNdx = 1
  SORT(qProps, +QPR:sPropName)
  LOOP
    isEndNdx = INSTRING('<255>', sBuffer, 1, isInNdx)
    IF isEndNdx = 0 THEN BREAK.
    sLine = SUB(sBuffer, isInNdx, isEndNdx - isInNdx)
    DO Parse
    QPR:sPropName = sProp
    GET(qProps, +QPR:sPropName)
    IF ERRORCODE()
      Warning( 'Syntax error in screen definition' )
    ELSE
      DO SetProps
    END
    isInNdx = isEndNdx + 1
  END
  RETURN

!-------------------------------------------------------------------------
Parse           ROUTINE ! Parse the line
!-------------------------------------------------------------------------
  sProp   = ''
  sValue  = ''
  isPos = INSTRING('=', sLine)
  IF isPos
    sProp   = UPPER(LEFT(sLine[1:isPos-1]))
    sValue  = LEFT(sLine[isPos+1:255] )
  ELSE
    sProp = UPPER(LEFT(sLine))
  END

!-------------------------------------------------------------------------
SetProps        ROUTINE ! Set control properties
!-------------------------------------------------------------------------
 CASE QPR:isPropID
   OF eFldField
     CLEAR( qFields )
     isLastField += 1
     QFI:isField  = isLastField
   OF eFldType
     QFI:ilDDID = sValue
   OF eFldControl
     QFI:isCtrlType = sValue
   OF eFldParent
     QFI:isParent = sValue
   OF eFldWndTabOrd
     QFI:isWndTabOrd = sValue
   OF eFldGrpTabOrd
     QFI:isGrpTabOrd = sValue
   OF eFldXpos
     QFI:isXPos = sValue
   OF eFldYpos
     QFI:isYPos = sValue
   OF eFldWidth
     QFI:isWidth = sValue
   OF eFldHeight
     QFI:isHeight = sValue
   OF eFldTypeface
     QFI:sTypeface = sValue
   OF eFldFontSize
     QFI:isFontSize = sValue
   OF eFldFontColor
     QFI:ilFontColor = sValue
   OF eFldFontStyle
     QFI:isFontStyle = sValue
   OF eFldBordColor
     QFI:ilBordColor = sValue
   OF eFldFillColor
     QFI:ilFillColor = sValue
   OF eFldBoxed
     QFI:bbBoxed = sValue
   OF eFldDrop
     QFI:isDrop = sValue
   OF eFldUse
     QFI:sUse = sValue
   OF eFldText
     QFI:sText = sValue
   OF eFldMessage
     QFI:sMessage = sValue
   OF eFldEnd
     ADD(qFields, +QFI:isField)
     FieldCreate( QFI:isField )
  END


!=========================================================================
! Create a new field of the specified type
!=========================================================================
FieldNew        FUNCTION( isField, ilDDID, isCtrlType, isParent )

  CODE
  FileOpen(DDMst, DDMst::Open)
  CLEAR( qFields )
  QFI:isField    = isField
  QFI:ilDDID     = ilDDID
  QFI:isCtrlType = isCtrlType
  QFI:isXPos     = MOUSEX()
  QFI:isYPos     = MOUSEY()
  QFI:isWidth    = 60
  QFI:isHeight   = 10
  IF ilDDID
    CLEAR(DDM:Record)
    DDM:ilID = ilDDID
    GET(DDMst, DDM:ByID)
    QFI:sText = DDM:sText
  ELSE
    QFI:sText = 'Text'
  END
  CASE isCtrlType
    OF CREATE:Group
      QFI:bbBoxed  = TRUE
      QFI:isWidth  = 100
      QFI:isHeight = 100
    OF CREATE:Entry
      QFI:sText = DDM:sPicture
    OF CREATE:Option
      QFI:bbBoxed = TRUE
      QFI:isWidth  = 100
      QFI:isHeight = 100
    OF CREATE:Radio
      QFI:isParent = isParent
    OF CREATE:DropCombo
      QFI:isDrop = 6
    OF CREATE:Button
      QFI:sText  = 'Push Button ' & isField
      QFI:isWidth  = 40
      QFI:isHeight = 25
  END

  ADD(qFields, +QFI:isField)

  FieldCreate( QFI:isField )
  FileClose(DDMst, DDMst::Open)
  RETURN( isField )


!=========================================================================
! Update field information from screen element
!=========================================================================
FieldRead           PROCEDURE( isField )

  CODE
  IF isField
    QFI:isField = isField
    GET(qFields, +QFI:isField)
    QFI:isXPos   = isField{PROP:XPos}
    QFI:isYPos   = isField{PROP:YPos}
    QFI:isWidth  = isField{PROP:Width}
    QFI:isHeight = isField{PROP:Height}
    PUT( qFields )
  END


!=========================================================================
! Save field information for specified screen to screen (*.SCR) file
!=========================================================================
FieldSave       PROCEDURE( sBuffer, isFirstField, isLastField )

                ! Locals:
sLine           STRING( 255 )
sProp           STRING(  32 )
sValue          STRING( 255 )
isPropID        SHORT
isFieldNo       SHORT
isIndex         SHORT
isOutNdx        SHORT

  CODE
  isOutNdx = 1
  CLEAR( sBuffer )
  SORT(qProps, +QPR:isPropID)
  LOOP isFieldNo = isFirstField TO isLastField
    QFI:isField = isFieldNo
    GET(qFields, +QFI:isField)
    DO WriteFieldInfo
  END
  RETURN

!-------------------------------------------------------------------------
WriteFieldInfo  ROUTINE ! Write field info to file
!-------------------------------------------------------------------------
  LOOP isIndex = 1 TO MAXIMUM(gProps, 1)
    isPropID = GPR:isPropID[isIndex]
    sProp    = GPR:sPropName[isIndex]
    CASE isPropID
      OF eFldType
        sValue = QFI:ilDDID
      OF eFldControl
        sValue = QFI:isCtrlType
      OF eFldParent
        sValue = QFI:isParent
      OF eFldWndTabOrd
        sValue = QFI:isWndTabOrd
      OF eFldGrpTabOrd
        sValue = QFI:isGrpTabOrd
      OF eFldXpos
        sValue = QFI:isXPos
      OF eFldYpos
        sValue = QFI:isYPos
      OF eFldWidth
        sValue = QFI:isWidth
      OF eFldHeight
        sValue = QFI:isHeight
      OF eFldTypeface
        sValue = QFI:sTypeface
      OF eFldFontSize
        sValue = QFI:isFontSize
      OF eFldFontColor
         sValue = QFI:ilFontColor
      OF eFldBordColor
        sValue = QFI:ilBordColor
      OF eFldFillColor
        sValue = QFI:ilFillColor
      OF eFldBoxed
        sValue = QFI:bbBoxed
      OF eFldDrop
        sValue = QFI:isDrop
      OF eFldUse
        sValue = QFI:sUse
      OF eFldText
        sValue = QFI:sText
      OF eFldMessage
        sValue = QFI:sMessage
    END

    sLine = ''
    CASE isPropID
      OF eFldField
        sLine = CLIP(sProp) & '=' & CLIP(QFI:isField) & '<255>'
      OF eFldEnd
        sLine = CLIP(sProp) & '<255>'
    ELSE
      IF sValue
        sLine = CLIP(sProp) & '=' & CLIP(sValue) & '<255>'
      END
    END
    IF sLine
      sBuffer = CLIP(sBuffer) & sLine
    END
  END


!=========================================================================
! Update screen element from field information
!=========================================================================
FieldWrite      PROCEDURE( isField )

  CODE
  IF isField
    QFI:isField = isField
    GET(qFields, +QFI:isField)
    isField{PROP:XPos}      = QFI:isXPos
    isField{PROP:YPos}      = QFI:isYPos
    isField{PROP:Width}     = QFI:isWidth
    isField{PROP:Height}    = QFI:isHeight
    isField{PROP:FontName}  = QFI:sTypeface
    isField{PROP:FontSize}  = QFI:isFontSize
    isField{PROP:FontColor} = QFI:ilFontColor
    isField{PROP:FontStyle} = QFI:isFontStyle
    isField{PROP:Boxed}     = QFI:bbBoxed
    isField{PROP:Drop}      = QFI:isDrop
    isField{PROP:Color}     = QFI:ilBordColor
    isField{PROP:Fill}      = QFI:ilFillColor
    isField{PROP:Text}      = QFI:sText
    isField{PROP:Msg}       = QFI:sMessage
  END


!=========================================================================
! Change pushbutton properties
!=========================================================================
PushBtnDlg      FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Pushbutton Properties'),AT(,,290,68),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       ENTRY(@n6),AT(52,8,16,12),USE(QFI:isField),READONLY
       PROMPT('Control ID:'),AT(12,8,36,10),USE(?Prompt3),RIGHT
       PROMPT('&Button Text:'),AT(4,26,,),RIGHT
       ENTRY(@s128),AT(52,26,172,12),MSG('Text Property'),USE(QFI:sText)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       ENTRY(@s255),AT(52,43,172,12),USE(QFI:sMessage)
       BUTTON('Cancel'),AT(236,40,44,16),USE(?Cancel)
       PROMPT('&Message:'),AT(8,43,,),USE(?Prompt2),RIGHT
     END

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  SELECT(2)
  ACCEPT
    CASE ACCEPTED()
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change static text properties
!=========================================================================
TextDlg         FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Text Properties'),AT(1,0,290,89),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM,GRAY, |
         MODAL
       PROMPT('&Text:'),AT(16,13,21,10),RIGHT
       ENTRY(@s128),AT(39,10,172,12),USE(QFI:sText)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       BUTTON('Cancel'),AT(236,30,44,16),USE(?Cancel)
       BUTTON('&Font...'),AT(236,65,44,16),USE(?Font)
     END

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?Font
        Junk# = FONTDIALOG('Select Legend Font',             |
                            QFI:sTypeface,   QFI:isFontSize, |
                            QFI:ilFontColor, QFI:isFontStyle)
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change image field properties
!=========================================================================
ImageDlg        FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Image Properties'),AT(,,290,57),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM,GRAY, |
         MODAL
       PROMPT('&Image File:'),AT(8,9,40,13),RIGHT
       ENTRY(@s64),AT(52,9,152,12),USE(QFI:sText)
       BUTTON('...'),AT(208,9,12,14),USE(?FileList)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT
       BUTTON('Cancel'),AT(236,30,44,16),USE(?Cancel)
     END

sFileName       STRING( 64 )
sFileTypes      STRING( 'Metafiles (*.WMF)|*.WMF|Bitmaps (*.BMP)|*.BMP|Icons (*.ICO)|*.ICO|All Files (*.*)|*.*' )
sSavedPath      STRING( 64 )

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?FileList
        sSavedPath = PATH()
        sFileName  = '*.WMF'
        IF FILEDIALOG('Select Image File', sFileName, sFileTypes)
          QFI:sText = sFileName
          DISPLAY
        END
        SETPATH( sSavedPath )
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change shaded box properties
!=========================================================================
BoxDlg          FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Box Properties'),AT(,,290,57),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM,GRAY,MODAL
       PROMPT('&Border Color:'),AT(4,9,44,13),RIGHT
       ENTRY(@s64),AT(52,9,152,12),USE(QFI:ilBordColor)
       BUTTON('...'),AT(208,9,12,14),USE(?BorderBtn)
       PROMPT('&Fill Color:'),AT(12,30,,),USE(?Prompt2),RIGHT
       ENTRY(@s20),AT(52,30,152,12),USE(QFI:ilFillColor)
       BUTTON('...'),AT(208,30,12,14),USE(?FillBtn)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT
       BUTTON('Cancel'),AT(236,30,44,16),USE(?Cancel)
     END

ilBordColor     LONG
ilFillColor     LONG

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?BorderBtn
        ilBordColor = QFI:ilBordColor
        IF COLORDIALOG('Select Border Color', ilBordColor)
          QFI:ilBordColor = ilBordColor
          DISPLAY
        END
      OF ?FillBtn
        ilFillColor = QFI:ilFillColor
        IF COLORDIALOG('Select Fill Color', ilFillColor)
          QFI:ilFillColor = ilFillColor
          DISPLAY
        END
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change group box properties
!=========================================================================
GroupBoxDlg     FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Group Box Properties'),AT(,,290,97),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       PROMPT('&Caption Text:'),AT(1,12,,),RIGHT
       ENTRY(@s128),AT(53,12,172,12),USE(QFI:sText)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       BUTTON('Cancel'),AT(236,34,44,16),USE(?Cancel)
       CHECK('Draw Border Around Box'),AT(52,30,,),USE(QFI:bbBoxed)
       BUTTON('&Font...'),AT(236,73,44,16),USE(?Font)
     END

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?Font
        Junk# = FONTDIALOG('Select Group Box Font',          |
                            QFI:sTypeface,   QFI:isFontSize, |
                            QFI:ilFontColor, QFI:isFontStyle)
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change entry field properties
!=========================================================================
EntryFldDlg      FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
sDataField      STRING(64)
sPicture        STRING(20)

wWindow WINDOW('Entry Field Properties'),AT(,,290,97),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       ENTRY(@s255),AT(52,43,172,12),USE(QFI:sMessage)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       STRING('Data Field:'),AT(12,13,,),USE(?String1)
       STRING(@s64),AT(52,13,,),USE(sDataField)
       BUTTON('Cancel'),AT(236,40,44,16),USE(?Cancel)
       PROMPT('&Entry Picture:'),AT(0,26,,),USE(?Prompt6),RIGHT
       STRING(@s20),AT(52,26,,),USE(sPicture)
       PROMPT('&Message:'),AT(12,43,,),USE(?Prompt2),RIGHT
       BUTTON('&Font...'),AT(236,73,44,16),USE(?Font)
     END

  CODE
  FileOpen(DDMst, DDMst::Open)
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  CLEAR( DDM:Record )
  DDM:ilID = QFI:ilDDID
  GET(DDMst, DDM:ByID)
  OPEN( wWindow )
  sDataField = DDM:sDesc
  sPicture   = DDM:sPicture
  ACCEPT
    CASE ACCEPTED()
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
      OF ?Font
        Junk# = FONTDIALOG('Select Entry Field Font',          |
                            QFI:sTypeface,   QFI:isFontSize, |
                            QFI:ilFontColor, QFI:isFontStyle)
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  FileClose(DDMst, DDMst::Open)
  RETURN( isRetVal )


!=========================================================================
! Change check box properties
!=========================================================================
CheckBoxDlg     FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
sDataField      STRING(64)

wWindow WINDOW('Check Box Properties'),AT(,,290,108),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       ENTRY(@s128),AT(52,26,172,12),USE(QFI:sText)
       ENTRY(@s255),AT(52,43,172,12),USE(QFI:sMessage)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       STRING(@s64),AT(52,9,,),USE(sDataField)
       BUTTON('Cancel'),AT(236,40,44,16),USE(?Cancel)
       PROMPT('&Box Text:'),AT(12,26,,),USE(?Prompt6),RIGHT
       PROMPT('&Data Field:'),AT(9,9,,),USE(?Prompt5),RIGHT
       PROMPT('&Message:'),AT(12,43,,),USE(?Prompt2),RIGHT
       BUTTON('&Font...'),AT(236,73,44,16),USE(?Font)
     END

  CODE
  FileOpen(DDMst, DDMst::Open)
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  CLEAR( DDM:Record )
  DDM:ilID = QFI:ilDDID
  GET(DDMst, DDM:ByID)
  OPEN( wWindow )
  sDataField = DDM:sDesc
  ACCEPT
    CASE ACCEPTED()
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
      OF ?Font
        Junk# = FONTDIALOG('Select Check Box Font',          |
                            QFI:sTypeface,   QFI:isFontSize, |
                            QFI:ilFontColor, QFI:isFontStyle)
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  FileClose(DDMst, DDMst::Open)
  RETURN( isRetVal )


!=========================================================================
! Change radio box properties
!=========================================================================
RadioBoxDlg     FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Radio Box Properties'),AT(,,290,97),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       ENTRY(@n6),AT(52,8,16,12),USE(QFI:isField),READONLY
       PROMPT('Control ID:'),AT(12,8,36,10),USE(?Prompt3),RIGHT
       PROMPT('&Caption Text:'),AT(0,26,,),RIGHT
       ENTRY(@s128),AT(52,26,172,12),USE(QFI:sText)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       BUTTON('Cancel'),AT(236,34,44,16),USE(?Cancel)
       CHECK('Draw Border Around Box'),AT(52,65,,),USE(QFI:bbBoxed)
       BUTTON('&Font...'),AT(236,73,44,16),USE(?Font)
       PROMPT('&Data Field:'),AT(8,43,,),USE(?Prompt5),RIGHT
       ENTRY(@s32),AT(52,43,172,12),USE(QFI:sUse)
     END

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?Font
        Junk# = FONTDIALOG('Select Radio Box Font',          |
                            QFI:sTypeface,   QFI:isFontSize, |
                            QFI:ilFontColor, QFI:isFontStyle)
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )


!=========================================================================
! Change radio button properties
!=========================================================================
RadioBtnDlg     FUNCTION( isField )

                ! Return:
isRetVal        SHORT

                ! Locals:
wWindow WINDOW('Radio Button Properties'),AT(,,290,65),FONT('MS Sans Serif',8,,FONT:bold),CENTER,SYSTEM, |
         GRAY,MODAL
       ENTRY(@n6),AT(52,8,16,12),USE(QFI:isField),READONLY
       ENTRY(@s128),AT(52,26,,),USE(QFI:sText)
       ENTRY(@s255),AT(53,44,172,12),USE(QFI:sMessage)
       BUTTON('OK'),AT(236,9,44,16),USE(?OK),DEFAULT,REQ
       BUTTON('Cancel'),AT(236,40,44,16),USE(?Cancel)
       PROMPT('Control ID:'),AT(12,8,36,10),USE(?Prompt3),RIGHT
       PROMPT('&Button Text:'),AT(4,26,,),USE(?Prompt6),RIGHT
       PROMPT('&Message:'),AT(13,44,,),USE(?Prompt2),RIGHT
     END

  CODE
  isRetVal = FALSE
  QFI:isField = isField
  GET(qFields, +QFI:isField)
  OPEN( wWindow )
  ACCEPT
    CASE ACCEPTED()
      OF ?Ok
        isRetVal = 1
        BREAK
      OF ?Cancel
        BREAK
     END
  END
  CLOSE(wWindow )
  IF isRetVal THEN PUT( qFields ).
  RETURN( isRetVal )

