
                MEMBER( 'HCWSM' )

!-------------------------------------------------------------------------
!  Module Variables
!-------------------------------------------------------------------------

qHandleInfo     QUEUE,PRE(QHI)
isHandleNo        SHORT
isFlags           SHORT
isXPos            SHORT
isYPos            SHORT
isWidth           SHORT
isHeight          SHORT
ilFill            LONG
sCursor           STRING(4)
                END


!=========================================================================
! Make the cursor for the specified handle the default window cursor
!=========================================================================
HandleCursor    PROCEDURE( isHandle )

  CODE
  GET(qHandleInfo, isHandle)
  SETCURSOR( QHI:sCursor )
  RETURN


!=========================================================================
! Destroy control handles
!=========================================================================
HandleDone      PROCEDURE

  CODE
  FREE(qHandleInfo)
  RETURN


!=========================================================================
! Get direction flags for specified handle
!=========================================================================
HandleGetFlags   FUNCTION( isHandle )

  CODE
  GET(qHandleInfo, isHandle)
  RETURN( QHI:isFlags )


!=========================================================================
! Translate mouse position to control handle queue index
!=========================================================================
HandleIndex     FUNCTION( isMouseX, isMouseY )

                ! Return:
isRetVal        SHORT

                ! Locals:
isQueueNdx      SHORT

isX1            SHORT
isY1            SHORT
isX2            SHORT
isY2            SHORT

  CODE
  isRetVal = 0
  LOOP isQueueNdx = 1 TO RECORDS(qHandleInfo)
    GET(qHandleInfo, isQueueNdx)
    isX1 = QHI:isXPos
    isY1 = QHI:isYPos
    isX2 = isX1 + (QHI:isWidth  - 1)
    isY2 = isY1 + (QHI:isHeight - 1)
    IF INRANGE(isMouseX, isX1, isX2) AND INRANGE(isMouseY, isY1, isY2)
      isRetVal = isQueueNdx
      BREAK
    END
  END
  RETURN( isRetVal )


!=========================================================================
! Initialize control handles
!=========================================================================
HandleInit      PROCEDURE( isFirstHandle )

                ! Equates:
eSize           EQUATE( 4 )

                ! Locals:
isHandle        SHORT

  CODE
  isHandle = isFirstHandle
  QHI:isFlags = eHandleNorth + eHandleEast
  QHI:sCursor = CURSOR:SizeNESW
  DO NextHandle

  QHI:isFlags = eHandleEast
  QHI:sCursor = CURSOR:SizeWE
  DO NextHandle

  QHI:isFlags = eHandleSouth + eHandleEast
  QHI:sCursor = CURSOR:SizeNWSE
  DO NextHandle

  QHI:isFlags = eHandleSouth
  QHI:sCursor = CURSOR:SizeNS
  DO NextHandle

  QHI:isFlags = eHandleSouth + eHandleWest
  QHI:sCursor = CURSOR:SizeNESW
  DO NextHandle

  QHI:isFlags = eHandleWest
  QHI:sCursor = CURSOR:SizeWE
  DO NextHandle

  QHI:isFlags = eHandleNorth + eHandleWest
  QHI:sCursor = CURSOR:SizeNWSE
  DO NextHandle

  QHI:isFlags = eHandleNorth
  QHI:sCursor = CURSOR:SizeNS
  DO NextHandle

!-------------------------------------------------------------------------
NextHandle      ROUTINE     ! Create next handle
!-------------------------------------------------------------------------
  QHI:isHandleNo = isHandle
  QHI:isXPos     = 0
  QHI:isYPos     = 0
  QHI:isWidth    = eSize
  QHI:isHeight   = eSize
  QHI:ilFill     = COLOR:Red
  ADD(qHandleInfo, +QHI:isHandleNo)
  CREATE(isHandle, CREATE:Region)
  isHandle += 1


!=========================================================================
! Display control handles for selected field
!=========================================================================
HandleShow      PROCEDURE( isField )

                ! Equates:
eSize           EQUATE( 4 )

                ! Locals:
isQueueNdx      SHORT

isHandle        SHORT
isFlags         SHORT

isLeft          SHORT
isTop           SHORT
isRight         SHORT
isBottom        SHORT
isCenterX       SHORT
isCenterY       SHORT

  CODE
  IF isField = 0
    DO HideHandles
  ELSE
    DO DispHandles
  END
  RETURN

!-------------------------------------------------------------------------
HideHandles     ROUTINE     ! Hide all control handles
!-------------------------------------------------------------------------
  LOOP isQueueNdx = 1 TO RECORDS(qHandleInfo)
    GET(qHandleInfo, isQueueNdx)
    HIDE( QHI:isHandleNo )
  END

!-------------------------------------------------------------------------
DispHandles     ROUTINE     ! Display control handles for selected field
!-------------------------------------------------------------------------
  isLeft    = isField{PROP:XPos}
  isTop     = isField{PROP:YPos}
  isRight   = isLeft + (isField{PROP:Width}  - 1) - (eSize / 2)
  isBottom  = isTop  + (isField{PROP:Height} - 1) - (eSize / 2)
  isCenterX = (isLeft + isRight ) / 2
  isCenterY = (isTop  + isBottom) / 2

  LOOP isQueueNdx = 1 TO RECORDS(qHandleInfo)
    GET(qHandleInfo, isQueueNdx)
    isHandle = QHI:isHandleNo
    isFlags  = QHI:isFlags
    IF BAND(isFlags, eHandleEast)
      QHI:isXPos = isRight
    ELSIF BAND(isFlags, eHandleWest)
      QHI:isXPos = isLeft
    ELSE
      QHI:isXPos = isCenterX
    END
    IF BAND(isFlags, eHandleNorth)
      QHI:isYPos = isTop
    ELSIF BAND(isFlags, eHandleSouth)
      QHI:isYPos = isBottom
    ELSE
      QHI:isYPos = isCenterY
    END
    PUT( qHandleInfo )
    isHandle{PROP:Fill}   = QHI:ilFill
    isHandle{PROP:Cursor} = QHI:sCursor
    SETPOSITION(isHandle, QHI:isXPos, QHI:isYPos, QHI:isWidth, QHI:isHeight)
    UNHIDE( isHandle )
  END
  RETURN
