
                MEMBER('HCWSM.clw')

!====================================================================
!  Start screen index browse thread
!====================================================================
ThreadSCNbrw    PROCEDURE

  CODE
  Junk# = SCNbrw( 0 )
  RETURN


!====================================================================
!  Browse Screen Index file
!====================================================================
SCNbrw          FUNCTION( ilRequest )

                ! Return:
ilRetVal        LONG

                ! Locals:
ForceRefresh         LONG,AUTO
RecordFiltered       LONG
CurrentSelected  LONG,AUTO
Queue:Browse         QUEUE                        ! Browsing Queue
BRW1::SCN:sTitle       LIKE(SCN:sTitle)           ! Queue Display field
BRW1::Position         STRING(255)                ! Queue POSITION information
BRW1::Mark             BYTE                       ! Queue POSITION information
                     END                          ! END (Browsing Queue)
BRW1::QuickScan      BYTE                         ! Flag for Range/Filter test
BRW1::RecordStatus   BYTE                         ! Flag for Range/Filter test
BRW1::InitializePage BYTE                         ! Flag for Range/Filter test
BRW1::ItemsToFill    LONG                         ! Controls records retrieved
BRW1::MaxItemsInList LONG                         ! Retrieved after window opened
BRW1::LocatedPosition STRING(255)                 ! POSITION of located record
BRW1::QueuePointer   LONG                         ! Queue position of located record
BRW1::NextChoice     LONG                         ! Queue position of located record
BRW1::NewSelectPosted BYTE                        ! Queue position of located record
BRW1::CurrentScroll  BYTE                         ! Queue position of scroll thumb
BRW1::CurrentScrollRecord LONG                    ! Queue position of scroll thumb

BrowseWindow         WINDOW('Vacancy Listing Pages'),AT(,,211,134),CENTER,SYSTEM,GRAY,MDI
                       LIST,AT(5,5,139,100),MSG('Browsing Records'),USE(?List),IMM,VSCROLL,FORMAT('256L(5)~Page Title~C@s64@'),FROM(Queue:Browse)
                       BUTTON('&Layout'),AT(152,36,44,16),USE(?Layout),DEFAULT
                       BUTTON('&New'),AT(152,12,44,16),KEY(InsertKey),USE(?Insert)
                       BUTTON('&Properties'),AT(152,60,44,16),KEY(CtrlEnter),USE(?Change)
                       BUTTON('&Delete'),AT(152,84,44,16),KEY(DeleteKey),USE(?Delete)
                       BUTTON('&Select'),AT(32,112,40,12),KEY(EnterKey),USE(?Select)
                       BUTTON('Close'),AT(88,112,40,12),USE(?Close)
                     END

  CODE
  ilRetVal = RequestCancelled

  ForceRefresh = False
  FileOpen(ScrnIndx, ScrnIndx::Open)

  OPEN(BrowseWindow)
  HIDE(?Close)

  SET(SCN:ByTitle)

  ?List{Prop:Alrt,251} = MouseLeft2
  IF ilRequest = SelectRecord
    ?Select{Prop:Hide} = False
    ENABLE(?Select)
    ?Select{Prop:Default} = True
  ELSE
    ?Select{Prop:Hide} = True
    DISABLE(?Select)
  END
  ?List{Prop:Alrt,255} = InsertKey
  ?List{Prop:Alrt,254} = DeleteKey
  ?List{Prop:Alrt,253} = CtrlEnter

  ACCEPT
    CASE EVENT()
      OF EVENT:OpenWindow
        DO InitializeWindow
        SELECT(?List)
   END

    CASE FIELD()
    OF ?List
      CASE EVENT()
      OF EVENT:NewSelection
        DO BRW1::NewSelection
      OF EVENT:ScrollUp
        DO BRW1::ScrollUp
      OF EVENT:ScrollDown
        DO BRW1::ScrollDown
      OF EVENT:PageUp
        DO BRW1::PageUp
      OF EVENT:PageDown
        DO BRW1::PageDown
      OF EVENT:ScrollTop
        DO BRW1::ScrollTop
      OF EVENT:ScrollBottom
        DO BRW1::ScrollBottom
      OF EVENT:AlertKey
        DO BRW1::AlertKey
      OF EVENT:ScrollDrag
        IF ?List{Prop:VScrollPos} <= 1
          POST(Event:ScrollTop,?List)
        ELSIF ?List{Prop:VScrollPos} = 100
          POST(Event:ScrollBottom,?List)
        ELSE
          CYCLE
        END
      END
    OF ?Layout
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO Layout
        DO RefreshWindow
      END
    OF ?Insert
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonInsert
      END
    OF ?Change
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonChange
      END
    OF ?Delete
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        DO BRW1::ButtonDelete
      END
    OF ?Select
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ilRetVal = RequestCompleted
        POST(Event:CloseWindow)
      END
    OF ?Close
      CASE EVENT()
      OF EVENT:Accepted
        DO SyncWindow
        ilRetVal = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  DO ProcedureReturn

!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
!---------------------------------------------------------------------------
  FileClose(ScrnIndx, ScrnIndx::Open)
  CLOSE(BrowseWindow)
  RETURN( ilRetVal )

!---------------------------------------------------------------------------
InitializeWindow ROUTINE
!---------------------------------------------------------------------------
  DO BRW1::OpenWindow
  DO RefreshWindow

!---------------------------------------------------------------------------
RefreshWindow ROUTINE
!---------------------------------------------------------------------------
  CurrentSelected = SELECTED()
  IF NOT ForceRefresh
    IF RECORDS(Queue:Browse)
      GET(Queue:Browse,CHOICE(?List))
      DO BRW1::FillBuffer
      DO BRW1::ValidateRecord
      IF BRW1::RecordStatus <> Record:OK
        FREE(Queue:Browse)
        DO BRW1::InitializeBrowse
      END
    ELSE
      DO BRW1::InitializeBrowse
    END
  ELSE
    DO BRW1::InitializeBrowse
    DO BRW1::RefreshPage
  END
  ?List{Prop:VScrollPos} = BRW1::CurrentScroll
  DISPLAY()
  ForceRefresh = False
  IF SELECTED() <> CurrentSelected
    SELECT(CurrentSelected)
  END

!---------------------------------------------------------------------------
SyncWindow ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,CHOICE(?List))
    REGET(SCN:ByTitle,BRW1::Position)
  END

!----------------------------------------------------------------------
BRW1::OpenWindow ROUTINE
!---------------------------------------------------------------------------
  IF ilRequest = SelectRecord
    SET(SCN:ByTitle,SCN:ByTitle)
    DO BRW1::LocateRecord
  ELSE
    DO BRW1::InitializeBrowse
    SELECT(?List,1)
  END
  DO BRW1::FillBuffer
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END

!----------------------------------------------------------------------
BRW1::InitializeBrowse ROUTINE
!----------------------------------------------------------------------
  IF SEND(ScrnIndx,'QUICKSCAN=on').
  IF SEND(ScrnIndx,'QUICKSCAN=off').
  DO BRW1::RefreshPage

!----------------------------------------------------------------------
BRW1::FillBuffer ROUTINE
!----------------------------------------------------------------------
  SCN:sTitle = BRW1::SCN:sTitle

!----------------------------------------------------------------------
BRW1::ResetLow ROUTINE
!----------------------------------------------------------------------
  SET(SCN:ByTitle)

!----------------------------------------------------------------------
BRW1::ResetHigh ROUTINE
!----------------------------------------------------------------------
  SET(SCN:ByTitle)

!----------------------------------------------------------------------
BRW1::ResetClear    ROUTINE
!----------------------------------------------------------------------
  SET(SCN:ByTitle)

!----------------------------------------------------------------------
BRW1::FillQueue     ROUTINE
!----------------------------------------------------------------------
  BRW1::SCN:sTitle = SCN:sTitle
  BRW1::Position = POSITION(SCN:ByTitle)

!----------------------------------------------------------------------
BRW1::NewSelection  ROUTINE
!----------------------------------------------------------------------
  BRW1::NewSelectPosted = False
  IF RECORDS(Queue:Browse)
    DO BRW1::FillBuffer
    DO RefreshWindow
  END

!----------------------------------------------------------------------
BRW1::ScrollUp  ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)>1
      SELECT(?List, CHOICE(?List)-1)
    ELSE
      GET(Queue:Browse,1)                         ! Get the first queue item
      RESET(SCN:ByTitle,BRW1::Position)           ! Reset for sequential processing
      PREVIOUS(ScrnIndx)                          ! Retrieve record, reverse access
      BRW1::ItemsToFill = 1                       ! Load a single item
      DO BRW1::FillBackward                       ! Fill with previous read(s)
      IF BRW1::ItemsToFill                        ! If Load failed
        BRW1::CurrentScroll = 0                   ! Move Thumb to top
      ELSE
        BRW1::CurrentScroll = 50                  ! Move Thumb to center
      END
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::ScrollDown    ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    IF CHOICE(?List)<RECORDS(Queue:Browse)
      SELECT(?List, CHOICE(?List)+1)
    ELSE
      GET(Queue:Browse,RECORDS(Queue:Browse))     ! Get the last queue item
      RESET(SCN:ByTitle,BRW1::Position)           ! Reset for sequential processing
      NEXT(ScrnIndx)                              ! Retrieve record, forward access
      BRW1::ItemsToFill = 1                       ! load a single item
      DO BRW1::FillForward                        ! Fill with next read(s)
      IF BRW1::ItemsToFill                        ! If Load failed
        BRW1::CurrentScroll = 100                 ! Move Thumb to top
      ELSE
        BRW1::CurrentScroll = 50                  ! Move Thumb to center
      END
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::PageUp    ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,1)                           ! Get the first queue item
    RESET(SCN:ByTitle,BRW1::Position)             ! Reset for sequential processing
    PREVIOUS(ScrnIndx)                            ! Retrieve record, reverse access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)-BRW1::ItemsToFill
      IF BRW1::NextChoice < 1
        BRW1::NextChoice = 1
      END
      SELECT(?List, BRW1::NextChoice)
      BRW1::CurrentScroll = 0                     ! Move Thumb to top
    ELSE
      BRW1::CurrentScroll = 50                    ! Move Thumb to center
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::PageDown  ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    GET(Queue:Browse,RECORDS(Queue:Browse))       ! Get the last queue item
    RESET(SCN:ByTitle,BRW1::Position)             ! Reset for sequential processing
    NEXT(ScrnIndx)                                ! Retrieve record, forward access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillForward                          ! Fill with next read(s)
    IF BRW1::ItemsToFill
      BRW1::NextChoice = CHOICE(?List)+BRW1::ItemsToFill
      IF BRW1::NextChoice > RECORDS(Queue:Browse)
        BRW1::NextChoice = RECORDS(Queue:Browse)
      END
      SELECT(?List, BRW1::NextChoice)
      BRW1::CurrentScroll = 100                   ! Move Thumb to top
    ELSE
      BRW1::CurrentScroll = 50                    ! Move Thumb to center
    END
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::ScrollTop ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    FREE(Queue:Browse)
    DO BRW1::RefreshPage
    SELECT(?List,1)                               ! Select first list item
    BRW1::CurrentScroll = 0
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::ScrollBottom  ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    SETCURSOR(Cursor:Wait)
    FREE(Queue:Browse)                            ! Free the browse queue
    DO BRW1::ResetHigh                            ! Reset for first page access
    BRW1::ItemsToFill = ?List{Prop:Items}         ! Load a full page
    DO BRW1::FillBackward                         ! Fill with previous read(s)
    SELECT(?List, RECORDS(Queue:Browse))          ! Select last list item
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      BRW1::CurrentScroll = 100
    ELSE
      BRW1::CurrentScroll = 0
    END
    SETCURSOR()
    IF NOT BRW1::NewSelectPosted
      BRW1::NewSelectPosted = True
      POST(Event:NewSelection,?List)
    END
  END

!----------------------------------------------------------------------
BRW1::AlertKey  ROUTINE
!----------------------------------------------------------------------
  IF RECORDS(Queue:Browse)
    CASE KEYCODE()                                ! What keycode was hit
    OF MouseLeft2
      IF ilRequest = SelectRecord
        POST(Event:Accepted,?Select)
        EXIT
      END
      POST(Event:Accepted,?Change)
      DO BRW1::FillBuffer
    OF InsertKey
      POST(Event:Accepted,?Insert)
    OF DeleteKey
      POST(Event:Accepted,?Delete)
    OF CtrlEnter
      POST(Event:Accepted,?Change)
    ELSE                                          ! ELSE (What keycode was hit)
      IF CHR(KEYCHAR())
        DO BRW1::ResetClear
        SCN:sTitle = CHR(KEYCHAR())
        GET(ScrnIndx,0)
        DO BRW1::LocateRecord                     ! Find the record
      END
    END                                           ! END (What keycode was hit)
  END
  IF NOT BRW1::NewSelectPosted
    BRW1::NewSelectPosted = True
    POST(Event:NewSelection,?List)
  END

!----------------------------------------------------------------------
BRW1::ValidateRecord    ROUTINE
!----------------------------------------------------------------------
  BRW1::RecordStatus = Record:OK
  EXIT

!----------------------------------------------------------------------
BRW1::FillForward   ROUTINE
!----------------------------------------------------------------------
  IF BRW1::ItemsToFill > 1
    IF SEND(ScrnIndx,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    NEXT(ScrnIndx)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,RECORDS(Queue:Browse))
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,1)
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse)
  END
  IF BRW1::QuickScan
    IF SEND(ScrnIndx,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT

!----------------------------------------------------------------------
BRW1::FillBackward  ROUTINE
!----------------------------------------------------------------------
  IF BRW1::ItemsToFill > 1
    IF SEND(ScrnIndx,'QUICKSCAN=on').
    BRW1::QuickScan = True
  END
  LOOP WHILE BRW1::ItemsToFill
    PREVIOUS(ScrnIndx)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BEGIN
        GET(Queue:Browse,1)
        DO BRW1::FillBuffer
        BREAK
      END
      CYCLE
    END
    IF RECORDS(Queue:Browse) = ?List{Prop:Items}
      GET(Queue:Browse,RECORDS(Queue:Browse))
      DELETE(Queue:Browse)
    END
    BRW1::ItemsToFill -= 1
    DO BRW1::FillQueue
    ADD(Queue:Browse,1)
  END
  IF BRW1::QuickScan
    IF SEND(ScrnIndx,'QUICKSCAN=off').
    BRW1::QuickScan = False
  END
  EXIT

!----------------------------------------------------------------------
BRW1::LocateRecord  ROUTINE
!----------------------------------------------------------------------
  SETCURSOR(Cursor:Wait)
  FREE(Queue:Browse)
  IF POSITION(SCN:ByTitle)
    RESET(SCN:ByTitle,POSITION(SCN:ByTitle))
  ELSE
    SET(SCN:ByTitle,SCN:ByTitle)
  END
  BRW1::LocatedPosition = ''
  LOOP
    NEXT(ScrnIndx)
    IF ERRORCODE() THEN BREAK.
    DO BRW1::ValidateRecord
    EXECUTE(BRW1::RecordStatus)
      BREAK
      CYCLE
    END
    BRW1::LocatedPosition = POSITION(SCN:ByTitle)
    RESET(SCN:ByTitle,BRW1::LocatedPosition)
    BREAK
  END
  BRW1::ItemsToFill = ?List{Prop:Items}
  BRW1::CurrentScroll = 50
  DO BRW1::FillForward
  IF BRW1::ItemsToFill
    BRW1::CurrentScroll = 100
    IF ~RECORDS(Queue:Browse)
      DO BRW1::ResetHigh                          ! Reset for first page access
    ELSE
      GET(Queue:Browse,1)
      RESET(SCN:ByTitle,BRW1::Position)
      PREVIOUS(ScrnIndx)
    END
    DO BRW1::FillBackward
    IF BRW1::ItemsToFill
      BRW1::CurrentScroll = 0
    END
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(SCN:Record)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    IF BRW1::LocatedPosition
      BRW1::QueuePointer = 1
      LOOP
        GET(Queue:Browse,BRW1::QueuePointer)
        IF ERRORCODE() THEN BREAK.
        IF BRW1::Position = BRW1::LocatedPosition THEN BREAK.
        BRW1::QueuePointer += 1
      END
    ELSE
      BRW1::QueuePointer = RECORDS(Queue:Browse)
    END
    SELECT(?List,BRW1::QueuePointer)
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT

!----------------------------------------------------------------------
BRW1::RefreshPage   ROUTINE
!----------------------------------------------------------------------
  SETCURSOR(Cursor:Wait)
  IF NOT RECORDS(Queue:Browse)
    BRW1::InitializePage = True
    DO BRW1::ResetLow
  ELSE
    BRW1::InitializePage = False
    GET(Queue:Browse,1)
    RESET(SCN:ByTitle,BRW1::Position)
  END
  FREE(Queue:Browse)
  BRW1::ItemsToFill = ?List{Prop:Items}
  BRW1::CurrentScroll = 50
  DO BRW1::FillForward
  IF NOT BRW1::InitializePage
    IF BRW1::ItemsToFill
      GET(Queue:Browse,1)
      RESET(SCN:ByTitle,BRW1::Position)
      PREVIOUS(ScrnIndx)
      BRW1::CurrentScroll = 100
      DO BRW1::FillBackward
    END
  END
  IF BRW1::ItemsToFill
    BRW1::CurrentScroll = 0
  END
  IF ~RECORDS(Queue:Browse)
    CLEAR(SCN:Record)
    ?List{Prop:Disable} = 1
    ?Change{Prop:Disable} = 1
    ?Delete{Prop:Disable} = 1
  ELSE
    ?List{Prop:Disable} = 0
    GET(Queue:Browse,CHOICE(?List))
    IF ERRORCODE()
      GET(Queue:Browse,RECORDS(Queue:Browse))
    END
    DO BRW1::FillBuffer
    ?Change{Prop:Disable} = 0
    ?Delete{Prop:Disable} = 0
  END
  SETCURSOR()
  EXIT

!----------------------------------------------------------------
BRW1::ButtonInsert  ROUTINE
!----------------------------------------------------------------
  GET(ScrnIndx,0)
  CLEAR(SCN:Record,0)
  SET(SCN:ByTitle)
  IF SCNupd( InsertRecord ) = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      DO BRW1::LocateRecord
    END
  END
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow

!----------------------------------------------------------------
BRW1::ButtonChange  ROUTINE
!----------------------------------------------------------------
  IF SCNupd( ChangeRecord ) = RequestCompleted
    DO BRW1::ValidateRecord
    IF BRW1::RecordStatus = Record:OK
      IF BRW1::Position = POSITION(SCN:ByTitle)
        DO BRW1::RefreshPage
      ELSE
        DO BRW1::LocateRecord
      END
    ELSE
      SELECT(?List,CHOICE(?List))
    END
  END
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow

!----------------------------------------------------------------
BRW1::ButtonDelete  ROUTINE
!----------------------------------------------------------------
  IF SCNupd( DeleteRecord ) = RequestCompleted
    DELETE(Queue:Browse)
    DO BRW1::RefreshPage
  END
  SELECT(?List)
  ForceRefresh = True
  DO RefreshWindow

!----------------------------------------------------------------
Layout          ROUTINE
!----------------------------------------------------------------
  sWindowTitle = SCN:sTitle                     ! Set global window title
  ilgScreenID  = SCN:ilID                       !
  isgLayoutThread = START(EditScreen, 16000)    ! Edit screen WYSIWIG
