
                MEMBER('HCWSM.clw')

SCNupd          FUNCTION( ilRequest )

                ! Return:
ilRetVal        LONG

                ! Locals:
RecordChanged   BYTE,AUTO
bbCycle         SHORT

Head:Queue      QUEUE,PRE(QUE)
ilID              LONG
ibLevel0          BYTE
ibLevel1          BYTE
ibLevel2          BYTE
sText             STRING(64)
                END

SAV::SCN:Record STRING(SIZE(SCN:Record))

FormWindow WINDOW('Vacancy Page Properties'),AT(1,1,341,186),CENTER,SYSTEM,GRAY,MDI
       STRING('Criteria Heading'),AT(96,4,,),USE(?String1)
       PROMPT('Page Title:'),AT(15,124,,),USE(?SCN:sTitle:Prompt)
       ENTRY(@s80),AT(52,124,,),USE(SCN:sTitle)
       PROMPT('Page No:'),AT(204,124,,),USE(?SCN:ibPageID:Prompt)
       ENTRY(@n3),AT(236,124,,),USE(SCN:ibPageID)
       BUTTON('OK'),AT(256,40,40,12),USE(?OK),DEFAULT,REQ
       CUSTOM('Outline'),AT(52,16,144,100),USE(?Outline),CLASS('MSOUTLIN.VBX','Outline')
       BUTTON('Cancel'),AT(256,72,40,12),USE(?Cancel)
     END

isIndex         SHORT
isIndent        SHORT
isQueueNdx      SHORT

ilID            LONG

  CODE
  ilRetVal = RequestCancelled

  FileOpen(QueHeads, QueHeads::Open)
  FileOpen(ScrnIndx, ScrnIndx::Open)

  SAV::SCN:Record = SCN:Record

  IF ilRequest = InsertRecord
    CLEAR(SCN:Record, 1)
    SET(ScrnIndx, SCN:ByID)
    PREVIOUS(ScrnIndx)
    IF ERRORCODE()
      ilID = 1
    ELSE
      ilID = SCN:ilID + 1
    END
    CLEAR(SCN:Record)
    CLEAR(SCN:Memo)
    SCN:ilID = ilID
  END


  IF ilRequest = DeleteRecord
    DO ProcedureReturn
  END

  OPEN(FormWindow)

  DO LoadHeads
  DO LoadOutline
  DO ExpandOutline
  DO PrimeOutline

  ACCEPT
    CASE EVENT()
      OF   EVENT:CloseWindow
      OROF EVENT:CloseDown
        DO SaveCheck
        IF bbCycle THEN CYCLE.
    ELSE
      IF EVENT() = Event:Completed
        CASE ilRequest
          OF InsertRecord
            ADD(ScrnIndx)
            CASE ERRORCODE()
              OF NoError
                ilRetVal = RequestCompleted
               POST(Event:CloseWindow)
              OF DupKeyErr
                IF DUPLICATE(SCN:ByID)
                  IF Message( 'Creates duplicate key', 'SCN:ByID')
                    SELECT(?SCN:sTitle:Prompt)
                    CYCLE
                  END
                END
            ELSE
              IF Message( 'Error inserting record', 'ERROR' )
                SELECT(?SCN:sTitle:Prompt)
                CYCLE
              END
            END
        OF ChangeRecord
          PUT(ScrnIndx)
          ilRetVal = RequestCompleted
          POST(Event:CloseWindow)
      END
    END

    CASE EVENT()
      OF EVENT:Accepted
        CASE FIELD()
          OF ?OK
            IF ilRequest = ChangeRecord OR ilRequest = InsertRecord
              SELECT()
            ELSE
              POST(EVENT:Completed)
            END
          OF ?Cancel
            ilRetVal = RequestCancelled
            POST(Event:CloseWindow)
        END
      OF EVENT:VbxEvent
        CASE FIELD()
          OF ?Outline
            CASE ?Outline{PROP:VBXEvent}
              OF 'Click'
                DO HeadChange
            END
        END
    END
  END
 END
  DO ProcedureReturn

!---------------------------------------------------------------------------
ProcedureReturn ROUTINE
!---------------------------------------------------------------------------
  FileClose(QueHeads, QueHeads::Open)
  FileClose(ScrnIndx, ScrnIndx::Open)
  CLOSE(FormWindow)
  RETURN( ilRetVal )

!---------------------------------------------------------------------------
SaveCheck       ROUTINE
!---------------------------------------------------------------------------
  bbCycle = FALSE
  IF ilRetVal <> RequestCompleted
    RecordChanged = False
    IF ilRequest = InsertRecord OR ilRequest = ChangeRecord
      IF SAV::SCN:Record <> SCN:Record
        RecordChanged = True
      END
    END
    IF RecordChanged
      CASE Message( 'Save changes?', 'Confirm',, |
                    BUTTON:Yes + BUTTON:No + Button:Cancel, BUTTON:Yes)
        OF Button:Yes
          POST(Event:Accepted,?OK)
          bbCycle = TRUE
        OF Button:No
        OF BUTTON:Cancel
          SELECT(?SCN:sTitle:Prompt)
          bbCycle = TRUE
      END
    END
  END

!--------------------------------------------------------------------
LoadHeads       ROUTINE ! Load subject headings queue
!--------------------------------------------------------------------
  FREE( Head:Queue )
  SET( QHD:ByLevel )
  LOOP
    NEXT( QueHeads )
    IF ERRORCODE() THEN BREAK.
    IF QHD:ibLevel2 THEN CYCLE.
    CLEAR( Head:Queue )
    QUE:ilID     = QHD:ilID
    QUE:ibLevel0 = QHD:ibLevel0
    QUE:ibLevel1 = QHD:ibLevel1
    QUE:ibLevel2 = QHD:ibLevel2
    QUE:sText    = QHD:sText
    ADD( Head:Queue )
  END

!--------------------------------------------------------------------
LoadOutline     ROUTINE ! Load subject headings outline
!--------------------------------------------------------------------
  ?Outline{'Style'}       = 6
  ?Outline{'BorderStyle'} = 1
  ?Outline{'BackColor'}   = COLOR:Red

  ?Outline{'List',   0} = 'HCW Selection Criteria'
  ?Outline{'Indent', 0} = 0
  isIndex = 1

  LOOP isQueueNdx = 1 TO RECORDS( Head:Queue )
    GET(Head:Queue, isQueueNdx)
    IF QUE:ibLevel1
      isIndent = 2
    ELSE
      isIndent = 1
    END
    ?Outline{'List',   isIndex} = QUE:sText
    ?Outline{'Indent', isIndex} = isIndent
    isIndex += 1
  END

  ?Outline{'ListIndex'} = 0
  ?Outline{'TabStop'}   = TRUE

!--------------------------------------------------------------------
ExpandOutline   ROUTINE ! Expand outline
!--------------------------------------------------------------------
  MaxItems# = ?Outline{'ListCount'}
  LOOP isIndex = 0 TO MaxItems# - 1
    ?Outline{'Expand', isIndex} = TRUE
  END

!--------------------------------------------------------------------
PrimeOutline    ROUTINE ! Prime outline selection
!--------------------------------------------------------------------
  SORT(Head:Queue, +QUE:iliD)
  IF SCN:ilHeadID
    CLEAR( Head:Queue )
    QUE:ilID = SCN:ilHeadID
    GET(Head:Queue, +QUE:iliD)
    ?Outline{'ListIndex'} = POINTER(Head:Queue)
  END

!--------------------------------------------------------------------
HeadChange  ROUTINE
!--------------------------------------------------------------------
  isQueueNdx = ?Outline{'ListIndex'}
  GET(Head:Queue, isQueueNdx)
  SCN:ilHeadID = QUE:ilID
