#TEMPLATE (HuSti1, 'Run time filtering for reports and processes')
#! 
#!
#! Written by Hubert Stiglbauer
#!            Germany
#!            
#!            Compuserve: 100327,1221
#!   
#! Version: 0.3
#! Changed: April 7, 1995
#!
#! New in Version 0.3
#!     - Filtering on all fields within procedure (not only Fields of primary file)
#!     - Also support for dimensioned fields and local/module/global data
#!     - Selectable filter entry control (Entry / Check / Droplist)
#!     - Support for Help File
#!     - Save/restore filter settings
#!
#! I hope this template may serve your needs ...
#! You may modify this template code like your will and your needs.
#! This code is free, therefore NO garantee for correct function at all !!!
#! If you like it, send a mail.
#! If you make significant improvements to this template, I would appreciate to get a copy by mail.
#HELP ('CWHELP.HLP')
#! -------------------------------------------------------------------------
#EXTENSION (RunTimeFilter,'Allow filtering during run time.'), PROCEDURE, DESCRIPTION('Run time Filter for Reports and Processes')
#DISPLAY ('This extension allows for filtering of reports at run time.')
#DISPLAY ('Select up to 6 Fields where filtering may occure.')
#DISPLAY ('')
#PROMPT('Select Language',DROP('English|Deutsch')),%RTFLanguage,DEFAULT('English')
#DISPLAY ('')
#PROMPT ('Main Help String on Selection',@s40),%RTFMainHlp
#DISPLAY ('')
#ENABLE(%IniActive)
 #PROMPT('Store user settings permanent?',DROP('Store|Nostore')),%RTFStore,DEFAULT('Store')
#ENDENABLE
#DISPLAY ('')
#BUTTON('Select Fields to filter'),MULTI(%RTFFields,%RTFField)
 #PROMPT('Field:',FIELD),%RTFField
 #PROMPT('Fieldname for Form (Optional):',@s30),%RTFPrompt
 #PROMPT('HelpID:',@s40),%RTFFieldHlp
 #BOXED ('Input Control: ')
  #PROMPT('Control:',DROP('Entry|Check|Drop')),%RTFControl,DEFAULT('Entry')
  #BOXED ('Entry control: '), AT(,60,,), WHERE (%RTFControl = 'Entry')
   #DISPLAY ('')
   #DISPLAY ('Place here an alternate entry picture (e.g. @d1).')
   #DISPLAY ('Otherwise values from the Dictionary will be taken.')
   #PROMPT('Control Picture:',@s20),%RTFPicture
  #ENDBOXED
  #BOXED ('Drop Control: '), AT(,60,,), WHERE (%RTFControl = 'Drop')
   #DISPLAY ('Droplist values must be defined for memory variables!!!')
   #DISPLAY ('Place here an (alternate) drop list (e.g. ''Val1|Val2|Val3'')')
   #DISPLAY ('Otherwise values from the Dictionary will be taken')
   #PROMPT('Values to Drop:',@s160),%RTFDropList
  #ENDBOXED
  #BOXED ('Check Control: '), AT(,60,,), WHERE (%RTFControl = 'Check')
   #DISPLAY ('Fields may be either set (<>0) or unset(=0).')
   #DISPLAY ('')
   #PROMPT('Text if checked:',@s40),%RTFCheckText
   #PROMPT('Text if unchecked:',@s40),%RTFUnCheckText
  #ENDBOXED
 #ENDBOXED
#ENDBUTTON
#!--------------------------------------------------------------------------
#LOCALDATA
RTF:Filter:Text     CSTRING(255)    ! This Text is intended to be included as TEXT within REPORT
#ENDLOCALDATA
#!--------------------------------------------------------------------------
#ATSTART
 #DECLARE(%RTFCount , LONG)                     #! Only 6 Fields are supported at the moment
 #SET(%RTFCount, 0 )                            #! for counting no of fields
 #DECLARE(%RTFYOffs , LONG)                     #! for screen design
 #DECLARE(%RTFYOffs1 , LONG)                    #! dito
 #DECLARE(%RTFInst , LONG)                      #! instance number of field
 #DECLARE(%RTFSecondary)                        #! Filter need additional secondary lookup(s) at validation
 #DECLARE(%RTFTemp)                             #! for temporary data
 #DECLARE(%RTFTempL , LONG)                     #! for temporary data
 #!                                         Additional data for %RTFFields
 #DECLARE(%RTFFieldIDn,%RTFFields)              #! Unique name for RTFField
 #DECLARE(%RTFString,%RTFFields)                #! String picture or empty if binary
 #DECLARE(%RTFFieldID,%RTFFields)               #! Label of field without prefix
 #DECLARE(%RTFFieldType,%RTFFields)             #! Data type of the field
 #DECLARE(%RTFFieldStatement,%RTFFields)        #! The fields declaration statement
 #DECLARE(%RTFFieldDisplayPicture,%RTFFields)   #! default display picture
 #DECLARE(%RTFFieldDropList,%RTFFields)         #! default display picture
 #MESSAGE('Generating Run Time Filter',3)
 #FOR(%RTFFields)
  #SET(%RTFCount , %RTFCount + 1)               #! count selected fields
  #IF (~%RTFControl)                            #! let Version 0.2 of this template be happy
   #SET(%RTFControl,'Entry')
  #ENDIF
 #ENDFOR
 #IF(%RTFCount > 6)
  #ERROR('To much fields for Run Time Filter... Truncating')
  #LOOP, WHILE (%RTFCount > 6)
   #DELETE(%RTFFields , %RTFCount)
   #SET(%RTFCount , %RTFCount - 1)
  #ENDLOOP
 #ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#AT(%DeclarationSection)
#INSERT(%RTFData)                               #! some local data ...
#ENDAT
#!--------------------------------------------------------------------------
#AT(%ProcedureSetup)
 #IF (%RTFCount > 0)                            #! Call filter screen
DO RTF:Init   #<! Initialize Report Filter
 #ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#AT(%RecordFilter)
 #INSERT(%RTFFilter)                            #! Insert filter code
#ENDAT
#!--------------------------------------------------------------------------
#AT(%ProcRoutines)          #! Routines for RTF
 !------------------------------------------------------------------------------------
 !               Run Time Filter ROUTINES
RTF:Init ROUTINE        #<! Ask user for filter data
 #IF (%RTFCount > 0)
  OPEN(RTF:Window)
  RTF:Window{Prop:At,4} = %RTFYOffs+12 #<! Shorten window height
  ?RTF:Filter{PROP:at,2} = ?RTF:Filter{PROP:at,2}-4
 #IF (%IniActive AND (%RTFStore='Store'))
  #INSERT(%RTFGetValues)
  #FOR (%RTFFields)
      IF RTF:Flag:%RTFFieldIDn
         UNHIDE(?RTF:Val1:%RTFFieldIDn)
   #IF (%RTFControl = 'Entry')
         UNHIDE(?RTF:Cond:%RTFFieldIDn)
   #ENDIF
      END
   #IF (%RTFControl = 'Entry')
    #IF (%RTFLanguage = 'English')
      IF RTF:Cond:%RTFFieldIDn = 'Range from / to' OR RTF:Cond:%RTFFieldIDn = 'not in Range'
    #ELSIF (%RTFLanguage = 'Deutsch')
      IF RTF:Cond:%RTFFieldIDn = 'Bereich von / bis' OR RTF:Cond:%RTFFieldIDn = 'nicht im Bereich'
    #ENDIF
         UNHIDE(?RTF:Val2:%RTFFieldIDn)
      END !IF
   #ENDIF
  #ENDFOR
 #ENDIF
  ACCEPT
    CASE EVENT()
    OF EVENT:TIMER
      UPDATE(SELECTED())
      DO RTF:MakeText
    END
    CASE FIELD()
  #FOR(%RTFFields)
    OF ?RTF:Flag:%RTFFieldIDn
      IF RTF:Flag:%RTFFieldIDn
         UNHIDE(?RTF:Val1:%RTFFieldIDn)
   #IF (%RTFControl = 'Entry')
         UNHIDE(?RTF:Cond:%RTFFieldIDn)
    #IF (%RTFLanguage = 'English')
      IF RTF:Cond:%RTFFieldIDn = 'Range from / to' OR RTF:Cond:%RTFFieldIDn = 'not in Range'
    #ELSIF (%RTFLanguage = 'Deutsch')
      IF RTF:Cond:%RTFFieldIDn = 'Bereich von / bis' OR RTF:Cond:%RTFFieldIDn = 'nicht im Bereich'
    #ENDIF
         UNHIDE(?RTF:Val2:%RTFFieldIDn)
      END !IF
   #ENDIF
      ELSE
         HIDE(?RTF:Val1:%RTFFieldIDn)
         CLEAR(RTF:Val1:%RTFFieldIDn)
   #IF (%RTFControl = 'Entry')
         HIDE(?RTF:Cond:%RTFFieldIDn)
         HIDE(?RTF:Val2:%RTFFieldIDn)
         CLEAR(RTF:Val2:%RTFFieldIDn)
   #ENDIF
      END
   #IF (%RTFControl = 'Entry')
    OF ?RTF:Cond:%RTFFieldIDn
    #IF (%RTFLanguage = 'English')
      IF RTF:Cond:%RTFFieldIDn = 'Range from / to' OR RTF:Cond:%RTFFieldIDn = 'not in Range'
    #ELSIF (%RTFLanguage = 'Deutsch')
      IF RTF:Cond:%RTFFieldIDn = 'Bereich von / bis' OR RTF:Cond:%RTFFieldIDn = 'nicht im Bereich'
    #ENDIF
         UNHIDE(?RTF:Val2:%RTFFieldIDn)
      ELSE
         CLEAR(RTF:Val2:%RTFFieldIDn)
         HIDE(?RTF:Val2:%RTFFieldIDn)
      END !IF
   #ENDIF
  #ENDFOR
    OF ?Exit
      BREAK
    OF ?Close
      RETURN
    END !CASE
  END !ACCEPT
  DO RTF:MakeText
  #IF (%IniActive AND (%RTFStore='Store'))
  #INSERT(%RTFPutValues)
  #ENDIF
  CLOSE(RTF:Window)

RTF:MakeText ROUTINE        ! Make readable text to be included within the report
  RTF:Filter:Text = ''
  #FOR(%RTFFields)
  IF RTF:Flag:%RTFFieldIDn
   #IF (%RTFPrompt)
     RTF:Filter:Text = RTF:Filter:Text & '%RTFPrompt' & ': '
   #ELSE
     RTF:Filter:Text = RTF:Filter:Text & '%RTFFieldID' & ': '
   #ENDIF
   #CASE (%RTFControl)
   #OF ('Entry')
     RTF:Filter:Text = RTF:Filter:Text & CLIP(RTF:Cond:%RTFFieldIDn) & ' ' & CLIP(FORMAT(CLIP(RTF:Val1:%RTFFieldIDn),%RTFFieldDisplayPicture))
     IF RTF:Val2:%RTFFieldIDn
        RTF:Filter:Text = RTF:Filter:Text & ' / ' & CLIP(FORMAT(CLIP(RTF:Val2:%RTFFieldIDn),%RTFFieldDisplayPicture))
     END !IF
   #OF ('Check')
     IF RTF:Val1:%RTFFieldIDn
        RTF:Filter:Text = RTF:Filter:Text & '%RTFCheckText'
     ELSE
        RTF:Filter:Text = RTF:Filter:Text & '%RTFUnCheckText'
     END !IF
   #OF ('Drop')
     RTF:Filter:Text = RTF:Filter:Text &' ' & RTF:Val1:%RTFFieldIDn
   #ENDCASE
     RTF:Filter:Text = RTF:Filter:Text & '<13,10>'
  END !IF
  #ENDFOR
  RTF:Filter = RTF:Filter:Text
  IF RTF:Filter:Text <> ''
     RTF:Filter:Text = 'Filter:<13,10>' & RTF:Filter:Text
  END !IF
 #ENDIF
#ENDAT
#!--------------------------------------------------------------------------
#GROUP (%RTFWindowDeclaration)
#IF (%RTFLanguage='English')
RTF:Window WINDOW('Additional Filter options'),AT(,,310,210),FONT('Times New Roman',10,,FONT:regular),CENTER,TIMER(10),GRAY,STATUS,AUTO,HLP('%RTFMainHlp')
           STRING('Field'),AT(16,2,,),USE(?RTFString1)
           STRING('Restriction:'),AT(100,2,,),USE(?RTFString2)
           STRING('Values:'),AT(180,2,,),USE(?RTFString3)
 #SET(%RTFYOffs,12)
 #SET(%RTFYOffs1,%RTFYOffs+12)
 #FOR(%RTFFields)
  #IF (INSTRING('[',%RTFField,1,1))     #! special for arrays
   #SET(%RTFTemp,SUB(%RTFField,1,INSTRING('[',%RTFField,1,1)-1))
  #ELSE
   #SET(%RTFTemp,%RTFField)
  #ENDIF
  #FIND(%Field,%RTFTemp)
  #IF (%RTFPrompt)
           CHECK('%RTFPrompt'),AT(6,%RTFYOffs,,),USE(RTF:Flag:%RTFFieldIDn),MSG('%FieldDescription'),HLP('%RTFFieldHlp')
  #ELSE
           CHECK('%RTFField'),AT(6,%RTFYOffs,,),USE(RTF:Flag:%RTFFieldIDn),MSG('%FieldDescription'),HLP('%RTFFieldHlp')
  #END
  #CASE (%RTFControl)
   #OF ('Entry')
    #IF (%RTFString)
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Cond:%RTFFieldIDn),FROM('=|>=|<<=|<<>|begins with|contains|Range from / to|not in Range'),DROP(8),MSG('Select filter condition'),HIDE,HLP('%RTFFieldHlp')
    #ELSE
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Cond:%RTFFieldIDn),FROM('=|>=|<<=|<<>|Range from / to|not in Range'),DROP(8),MSG('Select filter condition'),HIDE,HLP('%RTFFieldHlp')
    #ENDIF
           ENTRY(%RTFFieldDisplayPicture),AT(180,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),MSG('%FieldDescription'),HIDE,HLP('%RTFFieldHlp')
           ENTRY(%RTFFieldDisplayPicture),AT(180,%RTFYOffs1,,),USE(RTF:Val2:%RTFFieldIDn),MSG('%FieldDescription'),HIDE,HLP('%RTFFieldHlp')
   #OF ('Check')
           CHECK('%RTFCheckText'),AT(100,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),HIDE,HLP('%RTFFieldHlp')
   #OF ('Drop')
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),FROM('%RTFFieldDropList'),DROP(8),MSG('Select value to print'),HIDE,HLP('%RTFFieldHlp')
  #ENDCASE
  #SET(%RTFYOffs,%RTFYOffs+24)
  #SET(%RTFYOffs1,%RTFYOffs+12)
 #ENDFOR
           TEXT,AT(4,%RTFYOffs,165,45),USE(RTF:Filter),READONLY
           BUTTON('Start Report'),AT(185,%RTFYOffs1,50,10),USE(?Exit),DEFAULT
           BUTTON('Cancel'),AT(240,%RTFYOffs1,50,10),USE(?Close),KEY(EscKey)
 #SET(%RTFYOffs,%RTFYOffs+30)
           END
#ELSIF (%RTFLanguage='Deutsch')
RTF:Window WINDOW('Zusatzliche Filterbedingungen'),AT(,,310,210),FONT('Times New Roman',10,,FONT:regular),CENTER,TIMER(10),GRAY,STATUS,AUTO,HLP('%RTFMainHlp')
           STRING('Felder'),AT(16,2,,),USE(?RTFString1)
           STRING('Einschrnkung:'),AT(100,2,,),USE(?RTFString2)
           STRING('Werte:'),AT(180,2,,),USE(?RTFString3)
 #SET(%RTFYOffs,12)
 #SET(%RTFYOffs1,%RTFYOffs+12)
 #FOR(%RTFFields)
  #IF (INSTRING('[',%RTFField,1,1))     #! special for arrays
   #SET(%RTFTemp,SUB(%RTFField,1,INSTRING('[',%RTFField,1,1)-1))
  #ELSE
   #SET(%RTFTemp,%RTFField)
  #ENDIF
  #FIND(%Field,%RTFTemp)
  #IF (%RTFPrompt)
           CHECK('%RTFPrompt'),AT(6,%RTFYOffs,,),USE(RTF:Flag:%RTFFieldIDn),MSG('%FieldDescription'),HLP('%RTFFieldHlp')
  #ELSE
           CHECK('%RTFField'),AT(6,%RTFYOffs,,),USE(RTF:Flag:%RTFFieldIDn),MSG('%FieldDescription'),HLP('%RTFFieldHlp')
  #END
  #CASE (%RTFControl)
   #OF ('Entry')
    #IF (%RTFString)
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Cond:%RTFFieldIDn),FROM('=|>=|<<=|<<>|beginnend mit|enthlt|Bereich von / bis|nicht im Bereich'),DROP(8),MSG('Filterbedingung whlen'),HIDE,HLP('%RTFFieldHlp')
    #ELSE
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Cond:%RTFFieldIDn),FROM('=|>=|<<=|<<>|Bereich von / bis|nicht im Bereich'),DROP(8),MSG('Filterbedingung whlen'),HIDE,HLP('%RTFFieldHlp')
    #ENDIF
           ENTRY(%RTFFieldDisplayPicture),AT(180,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),MSG('%FieldDescription'),HIDE,HLP('%RTFFieldHlp')
           ENTRY(%RTFFieldDisplayPicture),AT(180,%RTFYOffs1,,),USE(RTF:Val2:%RTFFieldIDn),MSG('%FieldDescription'),HIDE,HLP('%RTFFieldHlp')
   #OF ('Check')
           CHECK('%RTFCheckText'),AT(100,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),HIDE,HLP('%RTFFieldHlp')
   #OF ('Drop')
           LIST,AT(100,%RTFYOffs,,),USE(RTF:Val1:%RTFFieldIDn),FROM('%RTFFieldDropList'),DROP(8),MSG('Bitte Datensatz auswhlen'),HIDE,HLP('%RTFFieldHlp')
  #ENDCASE
  #SET(%RTFYOffs,%RTFYOffs+24)
  #SET(%RTFYOffs1,%RTFYOffs+12)
 #ENDFOR
           TEXT,AT(4,%RTFYOffs,165,45),USE(RTF:Filter),READONLY
           BUTTON('Beginne Bericht'),AT(180,%RTFYOffs1,60,10),USE(?Exit),DEFAULT
           BUTTON('Abbruch'),AT(240,%RTFYOffs1,50,10),USE(?Close),KEY(EscKey)
 #SET(%RTFYOffs,%RTFYOffs+30)
           END
#ENDIF
#!--------------------------------------------------------------------------
#GROUP ( %RTFData)
#SET(%RTFSecondary,%False)
#FOR(%RTFFields)                               #! Define some internal data stuff
 #<! Filterdata for %RTFField
 #IF (INSTRING('[',%RTFField,1,1))             #! special for arrays
  #SET(%RTFTemp,SUB(%RTFField,1,INSTRING('[',%RTFField,1,1)-1))
 #ELSE
  #SET(%RTFTemp,%RTFField)
 #ENDIF
 #FIND(%Field,%RTFTemp)
 #IF (%Field)                                  #! normal data file
  #SET(%RTFFieldID,%FieldID)
  #SET(%RTFFieldDisplayPicture,%FieldDisplayPicture)
  #SET(%RTFFieldType,%FieldType)
  #SET(%RTFFieldStatement,%FieldStatement)
  #SET(%RTFFieldDropList,%FieldChoices)
 #ELSE
  #FIX(%LocalData,%RTFTemp)
  #IF (%LocalData)
   #SET(%RTFFieldStatement,%LocalDataStatement)
   #IF (INSTRING(',',%RTFFieldStatement,1,1))     #! special for attributes
    #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING(',',%RTFFieldStatement,1,1)-1))
   #ENDIF
   #IF (INSTRING('(',%RTFFieldStatement,1,1))
    #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING('(',%RTFFieldStatement,1,1)-1))
   #ENDIF
   #SET(%RTFFieldDisplayPicture,'@s27')     #! guess
   #SET(%RTFFieldID,%RTFTemp)
  #ELSE
   #FIX(%ModuleData,%RTFTemp)
   #IF (%ModuleData)
    #SET(%RTFFieldStatement,%ModuleDataStatement)
    #IF (INSTRING(',',%RTFFieldStatement,1,1))     #! special for attributes
     #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING(',',%RTFFieldStatement,1,1)-1))
    #ENDIF
    #IF (INSTRING('(',%RTFFieldStatement,1,1))
     #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING('(',%RTFFieldStatement,1,1)-1))
    #ENDIF
    #SET(%RTFFieldDisplayPicture,'@s27')     #! guess
    #SET(%RTFFieldID,%RTFTemp)
   #ELSE
    #FIX(%GlobalData,%RTFTemp)
    #IF (%GlobalData)
     #SET(%RTFFieldStatement,%GlobalDataStatement)
     #IF (INSTRING(',',%RTFFieldStatement,1,1))     #! special for attributes
      #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING(',',%RTFFieldStatement,1,1)-1))
     #ENDIF
     #IF (INSTRING('(',%RTFFieldStatement,1,1))
      #SET(%RTFFieldType,SUB(%RTFFieldStatement,1,INSTRING('(',%RTFFieldStatement,1,1)-1))
     #ENDIF
      #SET(%RTFFieldDisplayPicture,'@s27')     #! guess if not overwritten by RTFPicture
      #SET(%RTFFieldID,%RTFTemp)
     #ENDIF
    #ENDIF
   #ENDIF
  #ENDIF
  #IF (%File AND UPPER(%File) <> UPPER(%Primary))
   #SET(%RTFSecondary,%True)            #! if field not in primary file -> lookups needed
  #ENDIF
  #IF ((%RTFControl = 'Entry') AND %RTFPicture)
   #SET(%RTFFieldDisplayPicture,%RTFPicture)
  #ENDIF
  #IF ((%RTFControl = 'Drop') AND %RTFDropList)
   #SET(%RTFFieldDropList,%RTFDropList)
  #ENDIF
  #IF ((%RTFControl = 'Check') AND %RTFCheckText)
  #ENDIF
  #SET(%RTFInst,INSTANCE(%RTFFields))
  #SET(%RTFFieldIDn,(%RTFFieldID & %RTFInst)) #! make field name unique
  #CASE (%RTFFieldType)
  #OF   ('STRING')
  #OROF ('CSTRING')
  #OROF ('PSTRING')
  #OROF ('GROUP')
  #OROF ('PICTURE')
  #OROF ('MEMO')
   #SET(%RTFString,%RTFFieldDisplayPicture)
  #ELSE
   #SET(%RTFString,%Null)
  #ENDCASE
RTF:Flag:%RTFFieldIDn   BYTE
  #IF (%RTFControl = 'Entry')
RTF:Cond:%RTFFieldIDn   STRING(20)
  #ENDIF
  #SET(%RTFTempL,INSTRING(',',%RTFFieldStatement,1,1))
  #IF (%RTFTempL)
   #IF (INSTRING('(',SUB(%RTFFieldStatement,1,%RTFTempL),1,1))
    #IF (~INSTRING(')',SUB(%RTFFieldStatement,1,%RTFTempL),1,1))
     #IF (INSTRING(',',%RTFFieldStatement,1,%RTFTempL + 1))    #! next ','
      #SET(%RTFTempL, INSTRING(',',%RTFFieldStatement,1,%RTFTempL + 1))    #! next ','
     #ELSE
      #SET(%RTFTempL,0)
     #ENDIF
    #ENDIF
   #ENDIF
  #ENDIF
  #IF (%RTFTempL)     #! special for attributes
   #SET(%RTFTemp,SUB(%RTFFieldStatement,1,%RTFTempL - 1))
  #ELSE
   #SET(%RTFTemp,%RTFFieldStatement)
  #ENDIF
  #IF (INSTRING('GROUP',%RTFTemp,1,1)=1)
   #SET(%RTFTemp,'STRING(30)')
  #ENDIF
  #IF (INSTRING('MEMO',%RTFTemp,1,1)=1)
   #SET(%RTFTemp,'STRING(30)')
  #ENDIF
  #IF (%RTFControl <> 'Check')
RTF:Val1:%RTFFieldIDn   %RTFTemp
  #ELSE
RTF:Val1:%RTFFieldIDn   BYTE
  #ENDIF
  #IF (%RTFControl = 'Entry')
RTF:Val2:%RTFFieldIDn   %RTFTemp
  #ENDIF
 #ENDFOR
RTF:Filter  CSTRING(255)       #<! dirty: RTF:Filter:Text not accessible for RTF:Window
#INSERT(%RTFWindowDeclaration)
#!--------------------------------------------------------------------------
#GROUP ( %RTFFilter)
#IF (%RTFSecondary)     #! Do Secondary Lookups if any Field not in Primary will be selected
 #<! Some Secondary Lookups
 #INSERT(%StandardSecondaryLookups(Clarion))
#ENDIF
#FOR(%RTFFields)        #! Do real filter stuff
IF RTF:Flag:%RTFFieldIDn
 #CASE (%RTFControl)
 #OF   ('Entry')
   CASE CLIP(RTF:Cond:%RTFFieldIDn)
   OF '='
  #IF (%RTFString)
     IF ~(UPPER(%RTFField) = UPPER(RTF:Val1:%RTFFieldIDn))
  #ELSE
     IF ~(%RTFField = RTF:Val1:%RTFFieldIDn)
  #END
        EXIT
     END !IF
   OF '<<>'
  #IF (%RTFString)
     IF ~(UPPER(%RTFField) <> UPPER(RTF:Val1:%RTFFieldIDn))
  #ELSE
     IF ~(%RTFField <> RTF:Val1:%RTFFieldIDn)
  #END
        EXIT
     END !IF
   OF '>='
  #IF (%RTFString)
     IF ~(UPPER(%RTFField) >= UPPER(RTF:Val1:%RTFFieldIDn))
  #ELSE
     IF ~(%RTFField >= RTF:Val1:%RTFFieldIDn)
  #END
        EXIT
     END !IF
   OF '<<='
  #IF (%RTFString)
     IF ~(UPPER(%RTFField) <= UPPER(RTF:Val1:%RTFFieldIDn))
  #ELSE
     IF ~(%RTFField <= RTF:Val1:%RTFFieldIDn)
  #END
        EXIT
     END !IF
  #IF (%RTFLanguage='English')
   OF 'begins with'
     IF ~(INSTRING(UPPER(CLIP(RTF:Val1:%RTFFieldIDn)),UPPER(%RTFField))=1)
        EXIT
     END !IF
   OF 'contains'
     IF ~(INSTRING(UPPER(CLIP(RTF:Val1:%RTFFieldIDn)),UPPER(%RTFField),1,1)>0)
        EXIT
     END !IF
   OF 'Range from / to'
   #IF (%RTFString)
     IF (UPPER(%RTFField) < UPPER(RTF:Val1:%RTFFieldIDn)) OR (UPPER(%RTFField) > UPPER(RTF:Val2:%RTFFieldIDn))
   #ELSE
     IF (%RTFField < RTF:Val1:%RTFFieldIDn) OR (%RTFField > RTF:Val2:%RTFFieldIDn)
   #END
        EXIT
     END !IF
   OF 'not in Range'
   #IF (%RTFString)
     IF (UPPER(%RTFField) >= UPPER(RTF:Val1:%RTFFieldIDn)) AND (UPPER(%RTFField) <= UPPER(RTF:Val2:%RTFFieldIDn))
   #ELSE
     IF (%RTFField >= RTF:Val1:%RTFFieldIDn) AND (%RTFField <= RTF:Val2:%RTFFieldIDn)
   #ENDIF
        EXIT
     END !IF
  #ELSIF (%RTFLanguage='Deutsch')
   OF 'beginnend mit'
     IF ~(INSTRING(UPPER(CLIP(RTF:Val1:%RTFFieldIDn)),UPPER(%RTFField))=1)
        EXIT
     END !IF
   OF 'enthlt'
     IF ~(INSTRING(UPPER(CLIP(RTF:Val1:%RTFFieldIDn)),UPPER(%RTFField),1,1)>0)
        EXIT
     END !IF
   OF 'Bereich von / bis'
   #IF (%RTFString)
     IF (UPPER(%RTFField) < UPPER(RTF:Val1:%RTFFieldIDn)) OR (UPPER(%RTFField) > UPPER(RTF:Val2:%RTFFieldIDn))
   #ELSE
     IF (%RTFField < RTF:Val1:%RTFFieldIDn) OR (%RTFField > RTF:Val2:%RTFFieldIDn)
   #END
        EXIT
     END !IF
   OF 'nicht im Bereich'
   #IF (%RTFString)
     IF (UPPER(%RTFField) >= UPPER(RTF:Val1:%RTFFieldIDn)) AND (UPPER(%RTFField) <= UPPER(RTF:Val2:%RTFFieldIDn))
   #ELSE
     IF (%RTFField >= RTF:Val1:%RTFFieldIDn) AND (%RTFField <= RTF:Val2:%RTFFieldIDn)
   #ENDIF
        EXIT
     END !IF
  #ENDIF
   END !CASE
 #OF ('Check')
   IF ~((RTF:Val1:%RTFFieldIDn AND %RTFField) OR ~(RTF:Val1:%RTFFieldIDn OR %RTFField)) THEN EXIT END
 #OF ('Drop')
   IF ~(%RTFField = RTF:Val1:%RTFFieldIDn) THEN EXIT END
 #ENDCASE
END !IF
#ENDFOR
#!--------------------------------------------------------------------------
#GROUP ( %RTFGetValues)
#FOR (%RTFFields)
RTF:Flag:%RTFFieldIDn = GETINI('RTF%Procedure','RTF:Flag:%RTFFieldIDn',,'%IniFileName')
RTF:Val1:%RTFFieldIDn = GETINI('RTF%Procedure','RTF:Val1:%RTFFieldIDn',,'%IniFileName')
 #IF (%RTFControl = 'Entry')
RTF:Cond:%RTFFieldIDn = GETINI('RTF%Procedure','RTF:Cond:%RTFFieldIDn',,'%IniFileName')
RTF:Val2:%RTFFieldIDn = GETINI('RTF%Procedure','RTF:Val2:%RTFFieldIDn',,'%IniFileName')
 #ENDIF
#ENDFOR
#!--------------------------------------------------------------------------
#GROUP ( %RTFPutValues)
#FOR (%RTFFields)
PUTINI('RTF%Procedure','RTF:Flag:%RTFFieldIDn',RTF:Flag:%RTFFieldIDn,'%IniFileName')
PUTINI('RTF%Procedure','RTF:Val1:%RTFFieldIDn',RTF:Val1:%RTFFieldIDn,'%IniFileName')
 #IF (%RTFControl = 'Entry')
PUTINI('RTF%Procedure','RTF:Cond:%RTFFieldIDn',RTF:Cond:%RTFFieldIDn,'%IniFileName')
PUTINI('RTF%Procedure','RTF:Val2:%RTFFieldIDn',RTF:Val2:%RTFFieldIDn,'%IniFileName')
 #ENDIF
#ENDFOR
