                     MEMBER('LETTERS.clw')        ! This is a MEMBER module
Rpt:Letters PROCEDURE
RejectRecord         LONG,AUTO
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG,AUTO
RecordsToProcess     LONG,AUTO
RecordsProcessed     LONG,AUTO
RecordsPerCycle      LONG,AUTO
RecordsThisCycle     LONG,AUTO
PercentProgress      DECIMAL(4,1)
RecordStatus         BYTE,AUTO
PersonName           STRING(40)
CityStateZip         STRING(40)
Loc:Salutation       STRING(60)
Loc:MemoDetail       STRING(90)
EndOfReport          BYTE,AUTO
ReportRunDate        LONG,AUTO
ReportRunTime        LONG,AUTO
ReportPageNo         SHORT,AUTO
                     
                     END
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       BOX,AT(15,15,111,12),COLOR(00H),FILL(0FFFFFFH)
                       BOX,AT(21,18,100,6),COLOR(00H),FILL(0C0C0C0H)
                       BOX,AT(21,18,100,6),USE(?Progress:Thermometer),FILL(0FFH)
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END
PreviewReq        BYTE(0)


  CODE
  PreviewReq = False
  LocalRequest = GlobalRequest
  LocalResponse = RequestCancelled
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  RecordsToProcess = BYTES()
  RecordsPerCycle = 25
  RecordsProcessed = 0
  PercentProgress = 0
  OPEN(ProgressWindow)
  ?Progress:Thermometer{Prop:Width} = 0
  ?Progress:PctText{Prop:Text} = '0.0% Completed'
  IF PreviewReq
    ProgressWindow{Prop:Text} = 'Generating Report'
  ELSE
    ProgressWindow{Prop:Text} = 'Printing Report'
  END
  ?Progress:UserString{Prop:Text}=''
  IF SEND(,'QUICKSCAN=on').
  ReportRunDate = TODAY()
  ReportRunTime = CLOCK()
  ACCEPT
    CASE EVENT()
      OF Event:OpenWindow
        SET()
        LOOP
          DO GetNext
          DO ValidateRecord
          EXECUTE RecordStatus
            BEGIN
              LocalResponse = RequestCancelled
              BREAK
            END
            CYCLE
          END
          BREAK
        END
        IF LocalResponse = RequestCancelled
          POST(Event:CloseWindow)
          CYCLE
        END
        OPEN()
        {PROPPRINT:Copies} = 001
        CASE {PROP:Text}
          OF   'A4 Portrait'
          OROF 'A4 Landscape'
            {PROPPRINT:Paper} = PAPER:A4
            {PROP:Text} = ''
          OF   'Envelope10'
            {PROPPRINT:Paper} = PAPER:ENV_10
            {PROP:Text} = ''
          OF   'Portrait Legal'
            {PROPPRINT:Paper} = PAPER:Legal
            {PROP:Text} = ''
        END
      OF Event:Timer
        LOOP RecordsPerCycle TIMES
          
          PRINT()
          LOOP
            DO GetNextRecord
            DO ValidateRecord
            EXECUTE RecordStatus
              BEGIN
                LocalResponse = RequestCancelled
                BREAK
              END
              CYCLE
            END
            BREAK
          END
          IF LocalResponse = RequestCancelled
            LocalResponse = RequestCompleted
            BREAK
          END
          LocalResponse = RequestCancelled
        END
        IF LocalResponse = RequestCompleted
          POST(Event:CloseWindow)
        END
      ELSE
    END
    CASE FIELD()
    OF ?Progress:Cancel
      CASE Event()
      OF Event:Accepted
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END
    END
  END
  IF SEND(,'QUICKSCAN=off').
  CLOSE()
  DO ProcedureReturn
ProcedureReturn ROUTINE
  IF LocalResponse
    GlobalResponse = LocalResponse
  ELSE
    GlobalResponse = RequestCancelled
  END
  RETURN
!-----------------------------------------------------------------------------
ValidateRecord       ROUTINE
  RecordStatus = Record:OutOfRange
  IF LocalResponse = RequestCancelled THEN EXIT.
  IF ERRORCODE() THEN EXIT.
  RecordStatus = Record:OK
  EXIT
GetNext ROUTINE
  LocalResponse = RequestCancelled
  LOOP
    NEXT()
    IF ERRORCODE() THEN EXIT.
    RecordsProcessed += BYTES()
    RecordsThisCycle += BYTES()
    IF PercentProgress < 100
      PercentProgress = (RecordsProcessed / RecordsToProcess)*100
      IF PercentProgress > 100
        PercentProgress = 100
      END
      ?Progress:Thermometer{Prop:Width} = ROUND(PercentProgress,0)
      ?Progress:PctText{Prop:Text} = FORMAT(PercentProgress,@N5.1) & '% Completed'
      DISPLAY()
    END
    BREAK
  END
  LocalResponse = RequestCompleted
  EXIT

GetNextRecord ROUTINE
  DO GetNext
  IF LocalResponse = RequestCompleted THEN EXIT.
