
    ! This Program demonstrates Windows Resource checking and was
    ! written by Bob Butler and Kevin Stilwell of DATA.TXT Corp.
    ! Copyright 1995 - This Program and the associated CHKRES.LIB
    ! and CHKRES.DLL are freeware and may be used and distributed
    ! without royalty on the condition that 1) this copyright notice
    ! is not removed, 2) no technical support is requested or expected,
    ! and 3) this Program is not resold as a separate product or utility.
    ! The restriction of resale of this Program specifically does not
    ! restrict incorporation into, or use by, another program, including
    ! commercial programs sold for profit, when such programs main purpose
    ! is not Resource checking. No Warranties whatsoever are expressed
    ! or implied.  Good Luck and Enjoy!

PROGRAM

    INCLUDE('EQUATES')
    INCLUDE('KEYCODES')
    INCLUDE('ERRORS')

    ! The following MAP lists a LIB for the CHKRES.DLL which extends
    ! the CW 1.0 Windows Lib by adding the Win 3.1 API extensions
    ! for the function GetFreeSytemResources(). CHKRES.LIB must be
    ! in Library Section of MYPROG Project and CHKRES.DLL must be
    ! in the MYPROG's Program's directory or path at run-time.

    MAP
      Module('CHKRES.LIB')
        GetFreeSys(),raw,pascal,short ! This is a CHKRES.DLL function that calls
      End                             ! the API Function GerFreeSystemResources()
    INCLUDE('BUILTINS')
    END

   ! This following omitted section shows enhancement code that can added
   ! to set Threshold levels for when the Resource Advisory opens and how
   ! to set the Threshold Level in the MYPROG.INI file.

    OMIT('**comment**')

    LowLevel short     ! Global Variable Declaration, usually placed in
                       ! MYPROG.CLW

   ! Place following in your Program startup code or opening procedure
   ! This will read the minimum resource level with a default of 30%

    LowLevel = GETINI('Settings', 'CheckResource', '30','MYPROG.INI')

   ! Place following where you want to actually check the Resource level
   ! For example, top of Code where major Lists and Forms are opened.

    IF GetFreeSys() < LowLevel
      Message( 'System Resources Low - Current Level: ' & GetFreeSys() & '% Free', 'Notice! System Resource Alert',ICON:EXCLAMATION )
    RETURN     ! Remove this return if you want to continue after notice
    END

    **comment**

   CODE
   Message( '  Free System Resources: ' & GetFreeSys() & '%  ' , '  System Resource Alert  ',ICON:ASTERISK )
   RETURN
