
!=========================================================================
!  Test VBX method calls with MSOUTLINE VBX
!=========================================================================

Outline PROGRAM

        INCLUDE( 'EQUATES.CLW'  )
        INCLUDE( 'KEYCODES.CLW' )

    MAP
      Main
      INCLUDE( 'VBXMETHD.MOD' )
    END

  CODE
  Main
  RETURN


!=========================================================================
!  Main test procedure
!=========================================================================
Main            PROCEDURE

sItem           STRING(64)
isIndex         SHORT
isIndent        SHORT

sVBXEvent       STRING( 32 )

qVBXEvents      QUEUE,PRE(QVB)
                  STRING(32)
                END

wWindow WINDOW('Example of VBX Method Calls from CW - Using VBXMETHD DLL'),AT(,,302,230),CENTER,STATUS,SYSTEM,GRAY,MAX
       STRING('MS Outline VBX Control'),AT(156,8,112,12),FONT('Arial',14,0FFH,FONT:regular+FONT:italic), |
           USE(?String1)
       CUSTOM('Custom 1'),AT(140,24,144,104),USE(?Outline),CLASS('MSOUTLIN.VBX','Outline'),'BorderStyle'('1')
       PROMPT('Indent &Level:'),AT(16,28,,),USE(?Prompt3)
       SPIN(@n4),AT(64,28,24,12),MSG('Current or new outline indent'),USE(isIndent),RANGE(0,99),STEP(1)
       PROMPT('Item &Text:'),AT(24,44,37,10),USE(?Prompt1)
       ENTRY(@s32),AT(64,44,61,12),MSG('Enter text for new item...'),USE(sItem)
       BUTTON('Call &AddItem() method'),AT(24,64,100,16),MSG('Inserts a new item after selected item'), |
           USE(?Add),DEFAULT
       BUTTON('Call &RemoveItem() method'),AT(24,88,100,16),MSG('Delete selected item'),USE(?Delete)
       STRING('VBX Events'),AT(196,132,39,12),FONT('Arial',10,00H,FONT:regular),USE(?String2)
       BUTTON('&Clear Event List'),AT(24,150,100,16),MSG('Clear the VBX Event List'),USE(?Clear)
       BUTTON('E&xit'),AT(24,190,100,16),MSG('Get the heck out of here...'),USE(?Exit)
       LIST,AT(140,144,144,64),USE(?List1),VSCROLL,FROM(qVBXEvents)
     END

  CODE
  isIndex  = 1
  isIndent = 1
  OPEN(wWindow)

  ?Outline{'Style'}       = 6
  ?Outline{'BorderStyle'} = 1
  ?Outline{'BackColor'}   = COLOR:Red

  ! Build an outline

  ?Outline{'List',   0} = 'Animals'
  ?Outline{'Indent', 0} = 0
  ?Outline{'List',   1} = 'Reptiles'
  ?Outline{'Indent', 1} = 1
  ?Outline{'List',   2} = 'Alligators'
  ?Outline{'Indent', 2} = 2
  ?Outline{'List',   3} = 'Iguanas'
  ?Outline{'Indent', 3} = 2
  ?Outline{'List',   4} = 'Snakes'
  ?Outline{'Indent', 4} = 2
  ?Outline{'List',   5} = 'Fish'
  ?Outline{'Indent', 5} = 1
  ?Outline{'List',   6} = 'Bass'
  ?Outline{'Indent', 6} = 2
  ?Outline{'List',   7} = 'Trout'
  ?Outline{'Indent', 7} = 2
  ?Outline{'List',   8} = 'Birds'
  ?Outline{'Indent', 8} = 1
  ?Outline{'List',   9} = 'Finches'
  ?Outline{'Indent', 9} = 2
  ?Outline{'List',  10} = 'Sparrows'
  ?Outline{'Indent',10} = 2
  ?Outline{'List',  11} = 'Warblers'
  ?Outline{'Indent',11} = 2
  ?Outline{'List',  12} = 'Mammals'
  ?Outline{'Indent',12} = 1
  ?Outline{'List',  13} = 'Bears'
  ?Outline{'Indent',13} = 2
  ?Outline{'List',  14} = 'Lions'
  ?Outline{'Indent',14} = 2
  ?Outline{'List',  15} = 'Tigers'
  ?Outline{'Indent',15} = 2

  ! Oops, forgot some.  But now we can use AddItem() method...

  VBXAddItem(?Outline, 'Rattle Snakes', 5)
  ?Outline{'Indent', 5} = 3
  VBXAddItem(?Outline, 'Cottonmouths', 5)
  ?Outline{'Indent', 5} = 3
  VBXAddItem(?Outline, 'Coral Snakes', 5)
  ?Outline{'Indent', 5} = 3

  ! Expand the whole outline

  MaxItems# = ?Outline{'ListCount'}
  LOOP I# = 0 TO MaxItems# - 1
    ?Outline{'Expand', I#} = TRUE
  END

  ! Set it up for input

  ?Outline{'ListIndex'} = 0
  ?Outline{'TabStop'}   = TRUE

  ACCEPT
     CASE EVENT()
       OF EVENT:VBXEvent
         CASE FIELD()
           OF ?Outline
             ! Just some debugging display to track VBX events
             sVBXEvent = ?Outline{PROP:VBXEvent}
             IF sVBXEvent <> 'MouseMove'
               IF RECORDS(qVBXEvents) >= 10
                 GET(qVBXEvents, 1)
                 DELETE(qVBXEvents)
               END
               qVBXEvents = sVBXEvent
               ADD(qVBXEvents)
               ?List1{PROP:VScrollPos} = 100
             END
             CASE sVBXEvent
               OF 'KeyUp' OROF 'Click'
                 isIndex  = ?Outline{'ListIndex'}
                 isIndent = ?Outline{'Indent', isIndex}
                 DISPLAY(?isIndent)
              END
         END
      OF EVENT:Accepted
        CASE FIELD()
          OF ?Add
            IF NOT sItem
              Junk# = Message( 'You forgot to fill in the Item Name', 'OOPS!', ICON:Exclamation)
              CYCLE
            END
            IF ?Outline{'ListCount'} = 0
              ?Outline{'List',   0} = sItem
              ?Outline{'Indent', 0} = 0
            ELSE
              ! Add a new outline item with AddItem() method
              isIndex = ?Outline{'ListIndex'} + 1
              VBXAddItem(?Outline, sItem, isIndex)
              ?Outline{'Indent', isIndex} = isIndent
              ?Outline{'ListIndex'} = isIndex
            END
            SELECT(?sItem)
          OF ?Delete
            ! Delete the highlighted outline item with RemoveItem() method
            isIndex = ?Outline{'ListIndex'}
            VBXRemoveItem(?Outline, isIndex)
            SELECT(?sItem)
          OF ?Clear
            FREE(qVBXEvents)
          OF ?Exit
            POST(EVENT:CloseWindow)
        END
     END
   END
   CLOSE(wWindow)
   RETURN
