 PROGRAM

!-----------------------------------------------------------------------
! WIN COMM API / YIELD  Demo Program by:
! Larry Teames
! CREATIVE PC SOLUTIONS
! CIS: 73150,104
! (602) 963-3506
!-----------------------------------------------------------------------


!***********************************************************************
! This program demonstrates how to use the Windows Comm API to create a
! Phone Dialer / Modem Testing capability.  Since one of the issues
! involved is a timed loop from which the user must be able to break at
! will, this example illustrates how to develop such a "loop" by
! controlling the execution of a TIMER (ie. turning it on and off).
!
! For a shorter "true" loop, the YIELD command is used to allow other
! executing applications their turn at processing.  Without the YIELD
! command, a normal LOOP structure will "hog" the system, and inhibit
! the "cooperative multi-tasking" capability of Windows, until the loop
! is completed.
!***********************************************************************



        MAP
          CommDemo
          ErrorMessage(STRING)
          MODULE('Comm Prototypes')
            BuildCommDCB(*CSTRING,*STRING),SHORT,RAW,PASCAL
            ClearCommBreak(SHORT),SHORT,PASCAL
            CloseComm(SHORT),SHORT,PASCAL
            EscapeCommFunction(SHORT,SHORT),SHORT,PASCAL
            FlushComm(SHORT,SHORT),SHORT,PASCAL
            GetCommError(SHORT,*STRING),SHORT,RAW,PASCAL
            GetCommEventMask(SHORT,SHORT),USHORT,PASCAL
            GetCommState(SHORT,*STRING),SHORT,RAW,PASCAL
            OpenComm(*CSTRING,USHORT,USHORT),SHORT,RAW,PASCAL
            ReadComm(SHORT,*STRING,SHORT),SHORT,RAW,PASCAL
            SetCommBreak(SHORT),SHORT,PASCAL
            SetCommEventMask(SHORT,USHORT),USHORT,PASCAL
            SetCommState(*STRING),SHORT,RAW,PASCAL
            TransmitCommChar(SHORT,BYTE),SHORT,PASCAL
            UnGetCommChar(SHORT,BYTE),SHORT,PASCAL
            WriteComm(SHORT,*STRING,SHORT),SHORT,RAW,PASCAL
          END
          INCLUDE('WINDOWS.CLW')
        .

    INCLUDE('EQUATES.CLW')



Cmd           CSTRING('YLDOTH.EXE')



CommPort      SHORT          ! This is Negative if CommPort is NOT set


PortStruct    GROUP,PRE(PTS)
ID              BYTE(1)
BaudRate        USHORT(19200)
ByteSize        BYTE(8)
Parity          BYTE(0)
StopBits        BYTE(1)
RLSTimeout      USHORT(100)
CTSTimeout      USHORT(100)
DSRTimeout      USHORT(100)

FBinary         USHORT(1)
FRTSDisable     USHORT(1)
FParity         USHORT(1)
FOUTXCTSFlow    USHORT(0)
FOUTXDSRFlow    USHORT(0)
Fdummy          USHORT
FDTRDisable     USHORT(0)

FOUTx           USHORT(0)
FINx            USHORT(0)
FPEChar         USHORT(0)
FNull           USHORT(0)
FCHEVT          USHORT(0)
FDTRFlow        USHORT(0)
FRTSFlow        USHORT(0)
Fdummy2         USHORT

XONchar         BYTE
XOFFchar        BYTE
XONlim          USHORT
XOFFlim         USHORT
PEchar          BYTE
EOFchar         BYTE
EVTchar         BYTE
TXDelay         USHORT
              .


Buffer1kStr     STRING(1024)
Buffer32Str     STRING(32)
Buffer32Cstr    CSTRING(32)
Buffer20Str     STRING(20)
EventResp       USHORT
EventMask       USHORT

Mode50Cstr      CSTRING(51)
PortNbr5Cstr    CSTRING(5)
ReturnValue     SHORT

CommStatGrp     GROUP
status            BYTE
cbinq             USHORT
cboutq            USHORT
                .



  CODE

  CommDemo



!-----------------------------------------------------------------------
CommDemo        PROCEDURE
!-----------------------------------------------------------------------

ACTIONSTR      CSTRING(40)
NBRTODIAL      CSTRING(40)
STATUSSTR      CSTRING(40)
RESPONSESTR    CSTRING(4000)

MainWin WINDOW('COMM API Demo'),AT(1,1,184,180),SYSTEM,MAX,RESIZE
       BUTTON('Begin'),AT(10,7,,),USE(?Begin)
       BUTTON('Start YLDOTH.EXE'),AT(57,7,,),USE(?StartPartner)
       BUTTON('E&xit'),AT(143,7,,),USE(?Exit)
       PROMPT('Nbr to Dial (or Modem Cmd):'),AT(10,29,,),USE(?Prompt1)
       ENTRY(@S40),AT(10,39,164,12),FONT('MS Sans Serif',10,,FONT:regular),USE(NbrToDial),LEFT,REQ,OVR, |
           UPR
       STRING('Current Action:'),AT(10,58,,),USE(?String1),TRN
       ENTRY(@s40),AT(10,68,164,12),FONT('MS Sans Serif',10,,FONT:regular),USE(ACTIONSTR),LEFT,READONLY
       STRING('Status:'),AT(10,88,,),USE(?String2),TRN
       ENTRY(@S40),AT(10,97,164,12),FONT('MS Sans Serif',10,,FONT:regular),USE(?StatusStr),LEFT,READONLY
       PROMPT('Response:'),AT(9,121,,),USE(?Prompt2)
       TEXT,AT(10,131,165,45),FONT('MS Sans Serif',8,,FONT:regular),USE(Buffer1kStr),HVSCROLL
     END



   CODE

   NbrToDial = 'ATDT 555-9999'

   OPEN(MainWin)
   CommPort = -255

   ACCEPT
     CASE EVENT()
       OF EVENT:CloseWindow
         DO ClosePort
         BREAK

       ! This is the event which drives the "timed loop" of the
       ! WaitForResp routine.  That routine is used to "read"
       ! characters from the commport after a command is sent to
       ! the modem.  Since it may take 10 or more seconds to fully
       ! receive all characters, and the user may want to "quit"
       ! during that period, the "looping" must be performed from
       ! the ACCEPT Loop construct to allow for user intervention.
       ! The TIMER Event starts when the TIMER is assigned a POSITIVE
       ! value and stops when the TIMER is assigned a NEGATIVE value.
       ! By using this approach, you can devise numerous approaches to
       ! handling the need to accomplish LOOPing which is "COOPERATIVE"
       ! with the other executing applications.
       !
       OF EVENT:TIMER
           REMTIME# = ENDTIME# - CLOCK()     ! Are we done?
           IF REMTIME# > 0                   ! No, do another iteration
             DO WaitForResp
           ELSE                              ! Yes:
             TARGET{PROP:Timer} = -1         ! STOP Timer Events with neg val
             RESPONSESTR = Buffer1kStr
             DO ClosePort
             SELECT(?Exit)
             CYCLE
           END

       OF EVENT:ACCEPTED
         CASE FIELD()
           OF ?StartPartner
             x# = WinExec(Cmd,3)             ! Start YldOth.EXE for Evaluation

           OF ?NbrToDial
             SELECT(?Begin)

           OF ?Begin
             ACTIONSTR = ''
             STATUSSTR = ''
             DONE# = 0
             DISPLAY
             CommPort = -255               ! Say CommPort not open
             DO OpenPort                   ! Try to open the CommPort
             IF CommPort => 0              ! If successful
               DO SendData                 ! Send the Modem Command then
               WaitTime# = 1000            ! set the Resp WaitTime to 10 Secs
               ENDTIME# = CLOCK()+WaitTime#
               Buffer1kStr = ''
               NDX# = 0
               SETCURSOR(CURSOR:Wait)
               TARGET{PROP:Timer} = 1      ! Now, let the TIMER take over
             END


           OF ?Exit
             POST(EVENT:CloseWindow)
       END
     END
   END
   CLOSE(MainWin)
   RETURN


OPENPORT        ROUTINE
! **************************************
! *** Change to the Appropriate Port ***
! **************************************
  PortNbr5Cstr = 'COM3'

  ACTIONSTR = 'Opening ' & PortNbr5Cstr
  DISPLAY
  CommPort = OpenComm(PortNbr5Cstr,1024,128)
  IF CommPort < 0; ErrorMessage('Error OPENING Port ' & PortNbr5Cstr & ': ').
  IF CommPort < 0; EXIT.

  ReturnValue = GetCommState(CommPort,PortStruct)

  Mode50Cstr = CLIP(PortNbr5Cstr) & ':9600,N,8,1'
  ACTIONSTR = 'Building Comm DCB with: ' & Mode50Cstr
  DISPLAY
  ReturnValue = BuildCommDCB(Mode50Cstr,PortStruct)
  IF ReturnValue < 0; ErrorMessage('Error Building DCB: ').

  ACTIONSTR = 'Setting Comm State...'
  DISPLAY
  ReturnValue = SetCommState(PortStruct)
  IF ReturnValue < 0; ErrorMessage('Error Setting Port: ').

  ACTIONSTR = 'Flushing ' & PortNbr5Cstr
  DISPLAY
  ReturnValue = FlushComm(CommPort,0)
  IF ReturnValue < 0; ErrorMessage('Error Flushing Port: ').



SENDDATA       ROUTINE
  EventResp = SetCommEventMask(CommPort,0001h)
  Buffer20Str = CLIP(NbrToDial) & '<13>'
  ACTIONSTR = 'Sending "' & CLIP(Buffer20Str) & '" to ' & PortNbr5Cstr
  DISPLAY
  ReturnValue = Writecomm(CommPort,Buffer20Str,LEN(CLIP(Buffer20Str)))
  IF ReturnValue < LEN(CLIP(Buffer20Str)); ErrorMessage('Error Sending Data to Port: ').

  ReturnValue = GetCommError(CommPort,CommStatGrp)
  IF ReturnValue <> 0; ErrorMessage('GetCommError() returns: ').



! This is the routine which is executed from the TIMER Event
!
WaitForResp    ROUTINE
    EventResp = GetCommEventMask(CommPort,0001h)
    IF BAND(EventResp,0001h)                            ! Chars waiting?
      ReturnValue = ReadComm(CommPort,Buffer32Str,31)   ! Try to read them
      IF ReturnValue > 0                                ! If some read
        NDX# += 1
        Buffer32Cstr = Buffer32Str
        Buffer1kStr[NDX#:NDX#+ABS(ReturnValue)-1] = Buffer32Cstr
        DISPLAY(?Buffer1kStr)
        NDX# += ReturnValue
        IF INSTRING('BUSY<13>',CLIP(Buffer1kStr),1) or |
           INSTRING('OK<13>',CLIP(Buffer1kStr),1)
          Buffer1kStr[NDX#+1:NDX#+15] = FORMAT('(' & FORMAT(WaitTime#-REMTIME#,@P<<.##P) & ' secs)',@S15)
          ENDTIME# = 0                  ! Say we're done
          EXIT
        END
      END
    END




CLOSEPORT       ROUTINE
  IF CommPort < 0; EXIT.
  ACTIONSTR = 'Resetting: ' & PortNbr5Cstr
  DISPLAY
  ReturnValue = SetCommState(PortStruct)
  IF ReturnValue < 0; ErrorMessage('Error Setting Port' & PortNbr5Cstr & ': ').

  Buffer20Str = 'ATH<13>'
  ACTIONSTR = 'Sending "' & CLIP(Buffer20Str) & '" to ' & PortNbr5Cstr
  DISPLAY
  ReturnValue = Writecomm(CommPort,Buffer20Str,LEN(CLIP(Buffer20Str)))
  IF ReturnValue < LEN(CLIP(Buffer20Str)); ErrorMessage('Error Sending ATH to Port: ').

  ReturnValue = GetCommError(CommPort,CommStatGrp)
  IF ReturnValue <> 0; ErrorMessage('GetCommError() returns: ').

! To understand the effect of the standard LOOP construct
! change the WaitTime# variable to 3000 (30 seconds), then
! run the LOOP below both WITH and WITHOUT the YIELD command
! WHILE YLDOTH.EXE is running.

!  WaitTime# = 3000
  WaitTime# = 100
  ENDTIME# = CLOCK()+WaitTime#
  ACTIONSTR = 'Closing ' & PortNbr5Cstr & ' (Wait ' & FORMAT(WaitTime#,@P<<.##P) & ' secs)'
  DISPLAY
  LOOP UNTIL CLOCK() > ENDTIME#.
!  LOOP UNTIL CLOCK() > ENDTIME#; YIELD.

  ReturnValue = CloseComm(CommPort)
  IF ReturnValue <> 0
    ErrorMessage('Error Closing Port' & PortNbr5Cstr & ': ')
  ELSE
    CommPort = -255
  END
  ACTIONSTR = ''
  DISPLAY
  SETCURSOR(CURSOR:Arrow)



ErrorMessage             PROCEDURE(ErrMsgStr)

  CODE
  r# = MESSAGE(ErrMsgStr & ReturnValue,'Problem',ICON:EXCLAMATION)

