#TEMPLATE (MikePickusOutline, 'Mike Pickus Outline First Template')
#!
#! This is my first template, so comments and improvements are appreciated.
#!    TAI. Mike Pickus 70304,33
#!
#PROCEDURE (InitializeTreeControl, 'Outline--Initialize the Recursive Proc.'), PRIMARY('Outline File')
#LOCALDATA
OutLineOrder         ULONG
DummyVar             BYTE,AUTO
#ENDLOCALDATA
%Procedure PROCEDURE
#BOXED ('Initialize Outline Prompts')
  #PROMPT ('File to Sort Hierarchically:', FILE), %OutlineFile, REQ
  #PROMPT ('Recursive Function Name:', PROCEDURE), %CreateOrderFunction, REQ
  #PROMPT ('Initial Root Text:', @s20), %RootText, REQ, DEFAULT('''''')
#ENDBOXED
#INSERT (%FileControlInitialize (Clarion))
#EMBED (%DataSection, 'Data Section'), DATA       #! Embedded Source Code
#FOR (%LocalData)
%[20]LocalData %LocalDataStatement
#ENDFOR
 CODE                                             #<! Begin processed code
 #INSERT (%FileControlOpen (Clarion))
 #EMBED (%BeforeCode, 'Before Code')              #! Embedded Source Code
 STREAM     (%OutlineFile)

 !***---> Initialize the Recursive Procedure <---***
 DummyVar = %CreateOrderFunction   (0, OutLineOrder, %RootText)

 FLUSH      (%OutlineFile)
 #EMBED (%AfterCode, 'After Code - Before Return')#! Embedded Source Code
 #INSERT (%FileControlClose (Clarion))
 RETURN

#! -----------------
#PROCEDURE (TreeControlUpdate, 'Outline--Recursive Procedure.'), PRIMARY('Outline File')
#LOCALDATA
KeyPointer           LONG,AUTO
CurrentLeaf          BYTE,AUTO
BranchOrLeaf         BYTE,AUTO
#ENDLOCALDATA
%Procedure FUNCTION (InIndent, OutLineOrder, InText)#<! Declare Procedure
#PROTOTYPE ('(BYTE, *ULONG, STRING), BYTE')
#BOXED ('Outline Prompts')
  #PROMPT ('File to Sort Hierarchically:', FILE), %OutlineFile, REQ
  #PROMPT ('Parent-Child Key:', KEY), %ParentChildKey, REQ
  #PROMPT ('Parent Field:', COMPONENT), %ParentField, REQ
  #PROMPT ('Child Field:', COMPONENT), %ChildField, REQ
  #PROMPT ('Order Field:', FIELD), %OrderField, REQ
  #PROMPT ('Indent Field:', FIELD), %IndentField, REQ
  #PROMPT ('Leaf Field:', FIELD), %LeafField, REQ
#ENDBOXED
Branch               EQUATE(0)
Leaf                 EQUATE(1)
#FOR (%LocalData)
%[20]LocalData %LocalDataStatement
#ENDFOR
 CODE
 BranchOrLeaf    = Leaf                          #<! Function Returns TRUE
 %ParentField    = InText                        #<! Start Here
 %ChildField     = ''
 SET       (%ParentChildKey, %ParentChildKey)    #<! Parent/Child-Text Key
 LOOP
   NEXT (%OutlineFile)                           #<! Sequential Read
   IF InText    ~= %ParentField OR ERRORCODE()   #<! No Match or EOF
     RETURN (BranchOrLeaf)                       #<! RETURN
   END

   BranchOrLeaf  = Branch                        #<! Function Returns FALSE
   KeyPointer    = POINTER (%ParentChildKey)     #<! Rememberrrrr Key
   %LeafField    = Branch                        #<! FALSE (Default)
   %IndentField  = InIndent                      #<! Indent Level
   %OrderField   = OutlineOrder                  #<! Outline Sequence Number
   PUT     (%OutlineFile)                        #<! Update Record
   OutlineOrder += 1

   !***---> Recursive Procedure <---***
   CurrentLeaf = %Procedure (InIndent + 1, OutLineOrder, %ChildField)

   SET     (%ParentChildKey, KeyPointer)         #<! Remember Key?
   NEXT    (%OutlineFile)                        #<! I'm Baaaack!

   IF CurrentLeaf                                #<! I'm a Leaf not a Branch
      %LeafField = Leaf                          #<! TRUE (Not a Branch)
      PUT  (%OutlineFile)                        #<! Save me
   END #<! IF CurrentLeaf
 END #<! LOOP

#! -----------------
#CONTROL (MSOutlineWrapper, 'Wrapper for MSOutline.VBX'), PRIMARY('Tree File'), WINDOW
     CONTROLS
       CUSTOM('Outline'),AT(,,50,50),USE(?Outline),CLASS('MSOutlin.VBX','Outline'),'BorderStyle'('1'), |
           'Style'('5')
     END

#LOCALDATA
OutlineIndex         LONG,AUTO
#ENDLOCALDATA
#BOXED ('Outline Prompts')
  #PROMPT ('Tree File: ', FILE), %OutlineFile, REQ
  #PROMPT ('Tree Order Key: ', KEY), %OrderKey, REQ
  #PROMPT ('Text Field: ', FIELD), %ChildField, REQ
  #PROMPT ('Order Field: ', FIELD), %OrderField, REQ
  #PROMPT ('Indent Field: ', FIELD), %IndentField, REQ
  #PROMPT ('Leaf Field: ', FIELD), %LeafField, REQ
#ENDBOXED
#ATSTART
  #INSERT (%FileControlInitialize (Clarion))
#ENDAT
#AT (%DataSectionAfterWindow)
PictureClosed        EQUATE(0)
PictureOpen          EQUATE(1)
PictureLeaf          EQUATE(2)
#ENDAT
#AT (%AfterWindowOpening)
  DO FillOutline
#ENDAT
#AT (%ControlEventHandling, '?CancelButton', 'Accepted')
  DO ProcedureReturn
#ENDAT
#AT (%ControlEventHandling, '?Outline', 'VBXEvent')
  DO MSOutlineEvents
#ENDAT

#! -----------------
#AT (%ProcedureRoutines)
FillOutline ROUTINE
 %OrderField                    = 0
 SET (%OrderKey, %OrderKey)
 LOOP
      NEXT (%OutlineFile)
      IF ERRORCODE() THEN BREAK.
      ?Outline{'List',           %OrderField} = %ChildField
      ?Outline{'Indent',         %OrderField} = %IndentField
      IF %LeafField
         ?Outline{'PictureType', %OrderField} = PictureLeaf
      ELSIF %IndentField < 1
         ?Outline{'PictureType', %OrderField} = PictureOpen
      END
 END
 ?Outline{'Expand',   0}      = True  ! Expand 1 Level
 EXIT
#! -----------------
MSOutlineEvents     ROUTINE
! These are the only Events that are unique to MSOutlin.VBX
  CASE ?Outline {Prop:VBXevent}
  OF 'Collapse'
      OutlineIndex = ?Outline{prop:VbxEventArg,     1}
      IF OutlineIndex
         ?Outline{'PictureType',  OutlineIndex } = PictureClosed
      END
      #EMBED (%Collapse, 'Collapse')             #! Embedded Source Code
  OF 'Expand'
      %OrderField = ?Outline{prop:VbxEventArg,     1}
      GET (%OutlineFile, %OrderKey)
      IF %LeafField
         ?Outline{'PictureType',     %OrderField}     = PictureLeaf
      ELSE
         ?Outline{'PictureType',     %OrderField}     = PictureOpen
      END
      #EMBED (%Expand, 'Expand')                 #! Embedded Source Code
  OF 'PictureDblClick'
      %OrderField = ?Outline{prop:VbxEventArg,     1}
      GET (%OutlineFile, %OrderKey)
      #EMBED (%PictureDblClick, 'PictureDblClick')#! Embedded Source Code
      IF %LeafField
        #EMBED (%PictureDblClickLeaf, 'PictureDoubleClick Leaf Only')#! Embedded Source Code
        #! ***---> Do something interesting here
      END
  OF 'PictureClick'
      OutlineIndex = ?Outline{Prop:VbxEventArg,     1}
      IF    ?Outline{'PictureType',  OutlineIndex    } = PictureOpen   AND |
            ?Outline{'IsItemVisible',OutlineIndex + 1} = TRUE
            ?Outline{'Expand',       OutlineIndex    } = FALSE
            IF OutlineIndex
               ?Outline{'PictureType',  OutlineIndex } = PictureClosed
            END
      ELSIF ?Outline{'PictureType',  OutlineIndex    } = PictureClosed OR  |
           (?Outline{'PictureType',  OutlineIndex    } = PictureOpen   AND |
            ?Outline{'IsItemVisible',OutlineIndex + 1} = FALSE)
            ?Outline{'Expand',       OutlineIndex    } = TRUE
            ?Outline{'PictureType',  OutlineIndex    } = PictureOpen
      END ! IF
  END ! CASE Outline
  EXIT
#ENDAT
