                     MEMBER('DEMO.clw')           ! This is a MEMBER module




BrowseBeginning      PROCEDURE

!--------------------------------------------------------------------------------------------------!
! Declarations                                                                                     !
!--------------------------------------------------------------------------------------------------!
LocalRequest         LONG,AUTO
LocalResponse        LONG,AUTO
WindowOpened         LONG
Search               STRING(40)
TypeDsp              STRING(7)
OriginalRequest      LONG,AUTO
WindowInitialized    LONG
ForceRefresh         LONG,AUTO
WinWidth             LONG(195)                                  ! Save Window Width for Resizing
WinHeight            LONG(163)                                  ! Save Window Height for Resizing
CurrentSelected      LONG,AUTO                                  ! Save Current Selected Field

FORMAT:BRWQ:Default  EQUATE('80L(1)|_*~Name~@S20@24L(1)|_~Code~@S5@28L(1)|_~Type~@s7@')


BRWQ                 QUEUE                                      !Queue Used by List when Browsing Records
RCP:Name               LIKE(RCP:Name)                           !  Queue Display Field
RCP:Name:NormalFG      LONG                                     !    Normal Foreground
RCP:Name:NormalBG      LONG                                     !    Normal Background
RCP:Name:SelectedFG    LONG                                     !    Selected Foreground
RCP:Name:SelectedBG    LONG                                     !    Selected Background
RCP:Code               LIKE(RCP:Code)                           !  Queue Display Field
TypeDsp                LIKE(TypeDsp)                            !  Queue Display Field
Position               STRING(255)                              !  Queue POSITION Information
                     END                                        !End Queue Declaration
VIEW:BRWQ            VIEW(RECIPE)
                       PROJECT(RCP:Code)
                       PROJECT(RCP:Name)
                     END
RevOrder:BRWQ        BYTE(1)
LocLen:BRWQ          BYTE


Screen               WINDOW('Beginning Browse Exercise'),AT(,,195,163),FONT('MS Sans Serif',8,,),CENTER,STATUS,SYSTEM,GRAY,MAX,RESIZE,MDI,IMM
                       LIST,AT(4,18,186,89),MSG('Browsing Records'),ALRT(CtrlEnter),ALRT(InsertKey),ALRT(DeleteKey),ALRT(F2Key),ALRT(CtrlF2),USE(?List),IMM,HVSCROLL,VCR,FORMAT(FORMAT:BRWQ:Default),FROM(BRWQ)
                       PROMPT('Search:'),AT(5,4,25,10),USE(?Search:Prompt)
                       ENTRY(@S40),AT(32,4,80,10),MSG('Enter Search Criteria'),USE(Search)
                       BUTTON('Close'),AT(151,4,40,10),USE(?Close)
                       BUTTON('Select'),AT(151,110,40,10),USE(?Select)
                       BUTTON('Reverse'),AT(151,124,40,10),USE(?RevKeyOrder)
                       PROMPT('&Recipe#:'),AT(8,133),USE(?RCP:RecipeNo:Prompt)
                       ENTRY(@N_5),AT(42,132),USE(RCP:RecipeNo),READONLY
                       PROMPT('&Name:'),AT(15,148),USE(?RCP:Name:Prompt)
                       ENTRY(@S20),AT(42,147),ALRT(F2Key),ALRT(CtrlF2),USE(RCP:Name),READONLY
                       BUTTON('Insert'),AT(4,110,40,10),USE(?Insert)
                       BUTTON('Change'),AT(53,110,40,10),USE(?Change)
                       BUTTON('Delete'),AT(101,110,40,10),USE(?Delete)
                     END


!--------------------------------------------------------------------------------------------------!
! Code Section                                                                                     !
!--------------------------------------------------------------------------------------------------!
  CODE

  LocalRequest = GlobalRequest
  OriginalRequest = LocalRequest
  LocalResponse = RequestCancelled
  ForceRefresh = False
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)

  IF LocalRequest <> SelectRecord THEN TypeFilter = '123'.
  IF RECIPE::Used = 0
    CheckOpen(RECIPE,1)
  END
  RECIPE::Used += 1

  OPEN(Screen)
  WindowOpened = True
  INIRestoreWindow('BrowseBeginning','PTDEMO.INI')
  DO ResizeWindow                                               !Call Resize Window Routine
  Screen{PROP:Imm} = 1                                          !Allow Resize Events to be Posted
  HIDE(?List)                                                   !Delay Display of List Box
  RevOrder:BRWQ = False                                         !Set Normal Key Order for BRWQ
  ?RevKeyOrder{PROP:Text} = 'Reverse'                           !Set Test for Rev Key Order Button
  IF LocalRequest = SelectRecord                                !If Calling Procedure as a Lookup
    ENABLE(?Select)                                             !  Enable the Select Button
  ELSE                                                          !Otherwise
    DISABLE(?Select)                                            !  Disable the Select Button
  END                                                           !End If
  SELECT(?List)

  ?List{Prop:Alrt,250} = BSKey                                  !Alert BackSpace Key for Incremental Locator
  ?List{Prop:Alrt,249} = SpaceKey                               !Alert Space Key for Incremental Locator

  ACCEPT                                                        !Begin Processing Event Loop
                                                                !
    IF SELECTED() THEN CurrentSelected = SELECTED().            !Save Current Field Selection
    CASE EVENT()                                                !Process Events for the Window
    OF EVENT:OpenWindow
      IF NOT WindowInitialized
        DO InitializeWindow
        WindowInitialized = True
      END
      SELECT(FIRSTFIELD())
      UNHIDE(?List)                                             !Unhide Filled List Box
    OF EVENT:GainFocus
      IF NOT WindowInitialized
        WindowInitialized = True
        DO InitializeWindow
      ELSE
        ForceRefresh = True
        DO RefreshWindow
      END
    ELSE
      IF EVENT() = EVENT:Sized                                  !IF Window Was Resized
        DO ResizeWindow                                         !  Call Resize Window Routine
      END                                                       !End If
    END                                                         !End Events for Window

    CASE FIELD()                                                !Process Events for Controls
    OF ?List
      CASE EVENT()                           
      OF EVENT:Locate                 
        SELECT(?Search)                                         !Select Locator Field
      OF EVENT:AlertKey                 
        DO IncrementalSearch:BRWQ
      END
      IF EVENT() <> EVENT:AlertKey AND |                        !If Not an Alert Key or a
         EVENT() <> EVENT:PreAlertKey AND |                     !   Pre-Alert Key Event and
         EVENT() <> EVENT:Selected                              !   Control not reselected
        LocLen:BRWQ = 0                                         !  Clear Locator Length
        Search = ''                                             !  Clear the Search Input Field
        DISPLAY(?Search)                                        !  Display Locator Field
      END                                                       !End If
      DO BrowseList:BRWQ                                        !Fill Browse Area
    OF ?Search                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        DO EntrySearch:BRWQ
      END                                    
    OF ?Close                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        LocalResponse = RequestCancelled
        POST(Event:CloseWindow)
      END                                    
    OF ?Select                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        GET(BRWQ,TC_PROP:BRW(?List,TCPROP:CurItem))             !  Reread Current Record Position
        REGET(RECIPE,BRWQ:Position)                             !  Load the Record
        LocalResponse = RequestCompleted                        !  Lookup was completed
        POST(Event:CloseWindow)                                 !  Return Selected Record to Caller
      END                                    
    OF ?RevKeyOrder                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        IF RevOrder:BRWQ
          RevOrder:BRWQ = False
          ?RevKeyOrder{PROP:Text} = 'Reverse'
        ELSE
          RevOrder:BRWQ = True
          ?RevKeyOrder{PROP:Text} = 'Normal'
        END
        POST(TCEVENT:SamePage,?List)
      END                                    
    OF ?RCP:Name                              
      CASE EVENT()                           
      OF EVENT:AlertKey                 
        CASE KEYCODE()
        OF F2Key
          MESSAGE('F2 Key')
        OF CtrlF2
          MESSAGE('Ctrl F2')
        END
      END                                    
    OF ?Insert                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        POST(TCEVENT:InsertRecord,?List)                        !Send Insert Message to List Box
      END                                    
    OF ?Change                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        POST(TCEVENT:ChangeRecord,?List)                        !Send Change Message to List Box
      END                                    
    OF ?Delete                              
      CASE EVENT()                           
      OF EVENT:Accepted                 
        POST(TCEVENT:DeleteRecord,?List)                        !Send Delete Message to List Box
      END                                    
    END                                                         !End Events for Controls
  END                                                           !End Event Loop
                                                                !
  DO ProcedureReturn                                            !Cleanup and Exit the Procedure


!--------------------------------------------------------------------------------------------------!
! InitializeWindow Routine                                                                         !
!                                                                                                  !
! Initialize and Display window for the first time.                                                !
!--------------------------------------------------------------------------------------------------!
InitializeWindow   ROUTINE
  DO RefreshWindow


!--------------------------------------------------------------------------------------------------!
! RefreshWindow Routine                                                                            !
!                                                                                                  !
! Redisplays the fields for the window.                                                            !
!--------------------------------------------------------------------------------------------------!
RefreshWindow      ROUTINE

  IF Screen{Prop:AcceptAll} THEN EXIT.
  TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)
  TC_PROP:BRW(?List,TCPROP:SetToItem,CHOICE(?List))
  TC_PROP:BRW(?List,TCPROP:DontSelect,True)
  DO BrowseList:BRWQ
  DISPLAY()
  ForceRefresh = False





!--------------------------------------------------------------------------------------------------!
! ResizeWindow Routine                                                                             !
!                                                                                                  !
! Resize the Window and Redsiplay any list boxes that were resized.Resized List Boxes              !
!--------------------------------------------------------------------------------------------------!
ResizeWindow       ROUTINE

  IF WinWidth = Screen{PROP:Width} AND |                        !If Window Width was not Changed AND
     WinHeight = Screen{PROP:Height}                            !   Window Height was not Changed
    EXIT                                                        !  Resize Not Needed - Exit Routine
  END                                                           !End If
                                                                !
  TC_ResizeWin(?List,WinWidth,WinHeight)                        !Reset Window Size
  WinWidth = Screen{PROP:Width}                                 !Save Current Window Width
  WinHeight = Screen{PROP:Height}                               !Save Current Window Height
                                                                      !
  IF NOT WindowInitialized THEN EXIT.                           !Refresh not needed if window not Init.
                                                                !
  TC_PROP:BRW(?List,TCPROP:Rows,?List{PROP:Items})              !Reset Number of Rows in List Box
  TC_PROP:BRW(?List,TCPROP:SetToPosition,3)                     !Set for Redisplay at Key Position
  TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)             !Tell Browse to Redisplay
  DO BrowseList:BRWQ                                            !Fill Browse Area
                                                                !
  IF CurrentSelected THEN SELECT(CurrentSelected).              !Reslect Current Field



!--------------------------------------------------------------------------------------------------!
! BrowseList:BRWQ Routine                                                                          !
!                                                                                                  !
! This routine calls the browser to do a page-loaded display from a file.                          !
!--------------------------------------------------------------------------------------------------!
BrowseList:BRWQ      ROUTINE

  IF NOT TC_PROP:BRW(?List,TCPROP:Initialized)                  !If Browse Not Initialized
    IF NOT TC_InitBrowse(?List,THREAD()) THEN EXIT.             !  Initialize Browse Processing for List Box
    IF LocalRequest = SelectRecord                              !  If Browse Procedure Called as a Lookup
      TC_PROP:BRW(?List,TCPROP:SetToPosition,1)                 !    Start Lookup on Current Record
      TC_PROP:BRW(?List,TCPROP:SelectRecord,True)               !    Set Double Click to Select Record
    END                                                         !  End If
    TC_PROP:BRW(?List,TCPROP:UseView,1)                         !  Use a View Structure
  END                                                           !End If
                                                                !
  LOOP                                                          !Process File Browse Loop
    TC_PROP:BRW(?List,TCPROP:RevOrder,RevOrder:BRWQ)            !  Set Reverse Ordering Flag
    TC_Browse(?List                ,|                           !  Browse Handle
              VIEW:BRWQ            ,|                           !  File Name
              RCP:RECORD           ,|                           !  Record Area
              RCP:Key_Name         ,|                           !  Key Order for Display
              BRWQ                 ,|                           !  Queue Name for List
              BRWQ:Position        )                            !  Record Position in Key Order

    CASE TC_PROP:BRW(?List,TCPROP:Action)                       !Process Browse Actions
    OF TCACTION:FillQueue                                       !Fill List Queue Action
      IF NOT(INSTRING(RCP:Type,TypeFilter,1))                   !If Filter Condition Not Met
        TC_PROP:BRW(?List,TCPROP:SkipRecord,1)                  !  Tell Browse to Skip Record
        CYCLE                                                   !  No need to fill the Queue
      END                                                       !End If
      CASE RCP:Type
      OF 1
        TypeDsp = 'Main'
      OF 2
        TypeDsp = 'Side'
      OF 3
        TypeDsp = 'Dessert'
      END
      BRWQ:RCP:Code = RCP:Code                                  !  Move Data to Queue
      BRWQ:RCP:Name = RCP:Name                                  !  Move Data to Queue
      BRWQ:TypeDsp = TypeDsp                                    !  Move Data to Queue
      DO SetFieldColors:BRWQ                                    !  Set Colors for List Box
                                                                !
    OF TCACTION:InsertRecord                                    !Insert Record Action
      GET(RECIPE,0)                                             !  Clear Pending Record
      CLEAR(RCP:RECORD)                                         !  Clear Record Area
      GlobalRequest = InsertRecord                              !  Tell Form To Insert Record
      UpdateRecipe                                              !  Insert Record
      IF GlobalResponse = RequestCompleted                      !  If Record Added
        TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)       !    Tell Browse to Redisplay
        TC_PROP:BRW(?List,TCPROP:SetToPosition,1)               !    Record at Current Key Positon
      END                                                       !  End If
                                                                !
    OF TCACTION:ChangeRecord                                    !Change Record Action
      GlobalRequest = ChangeRecord                              !  Tell Form To Change Record
      UpdateRecipe                                              !  Change Record
      IF GlobalResponse = RequestCompleted                      !  If Record Added
        TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)       !    Tell Browse to Redisplay
        TC_PROP:BRW(?List,TCPROP:SetToPosition,1)               !    Record at the Current Key Positon
      END                                                       !  End If
                                                                !
    OF TCACTION:DeleteRecord                                    !Delete Record Action
      GlobalRequest = DeleteRecord                              !  Tell Form To Delete Record
      UpdateRecipe                                              !  Delete Record
      IF GlobalResponse = RequestCompleted                      !  If Record Deleted
        TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)       !    Tell Browse to Redisplay
        TC_PROP:BRW(?List,TCPROP:SetToItem,True)                !    Record at the Current Item
      END                                                       !  End If
                                                                !
    OF TCACTION:SelectRecord                                    !Select Record Action
      LocalResponse = RequestCompleted                          !  Lookup was completed
      POST(Event:CloseWindow)                                   !  Return Selected Record to Caller
                                                                !
    OF TCACTION:DisplayFields                                   !Display Fields Action
      DISPLAY()                                                 !  Display All Fields
      IF RECORDS(BRWQ)                                          !  If Records Displayed
        IF OriginalRequest = SelectRecord                       !    If Browse was Called as a Lookup
          ENABLE(?Select)                                       !      Enable the Select Button
        END                                                     !    End If
        ENABLE(?Change)                                         !    Enable Change Button
        ENABLE(?Delete)                                         !    Enable Delete Button
      ELSE                                                      !  Else
        IF OriginalRequest = SelectRecord                       !    If Browse was Called as a Lookup
          DISABLE(?Select)                                      !      Disable the Select Button
        END                                                     !    End If
        DISABLE(?Change)                                        !    Disable Change Button
        DISABLE(?Delete)                                        !    Disable Delete Button
      END                                                       !  End If
                                                                !
    OF TCACTION:ExitBrowse                                      !Exit Browse Action
      BREAK                                                     !
    END                                                         !End Process Browse Actions
  END                                                           !End Process File Browse Loop



!--------------------------------------------------------------------------------------------------!
! EntrySearch:BRWQ Routine                                                                         !
!                                                                                                  !
! This routine processes a Entry search for ?List                                                  !
!--------------------------------------------------------------------------------------------------!
EntrySearch:BRWQ     ROUTINE

  IF TC_PROP:BRW(?List,TCPROP:RevOrder)                         !If Using Reverse Key Order
    RCP:Name = CLIP(Search) & '<255>'                           !  Fill Search Key and Adjust for Key Order
  ELSE                                                          !Otherwise
    RCP:Name = Search                                           !  Fill Search key
  END                                                           !End If
  LocLen:BRWQ = 0                                               !Clear Locator Length
  Search = ''                                                   !Clear Search Input Field
  DISPLAY(?Search)                                              !
  TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)             !Tell Browse to Redisplay
  TC_PROP:BRW(?List,TCPROP:SetToKey,True)                       !Redisplay after searching by key
  SELECT(?List)                                                 !Reselect Main List Box



!--------------------------------------------------------------------------------------------------!
! IncrementalSearch:BRWQ Routine                                                                   !
!                                                                                                  !
! This routine processes a incremental search for ?List                                            !
!--------------------------------------------------------------------------------------------------!
IncrementalSearch:BRWQ ROUTINE

  IF INRANGE(KEYCODE(),KeyPad0,KeyPad9)                         !If Key is a numeric keypad key
    SETKEYCODE(KEYCODE()-48)                                    !  Convert to regular numeric key
  END                                                           !End If
  IF (INRANGE(KEYCODE(),Key0,ZKey) OR |                         !If Key is a lower case 0-Z Key
      INRANGE(KEYCODE(),187,192) OR |                           !   or other usable characters
      INRANGE(KEYCODE(),Shift0,ShiftZ) OR |                     !   or it's a upper case 0-Z Key
      KEYCODE() = BSKey OR KEYCODE() = SpaceKey)                !   or it's the BackSpace or Space Key
    IF KEYCODE() = BSKey                                        !  If BackSpace Key Pressed
      IF LocLen:BRWQ                                            !    If Not First Position in Locator
        LocLen:BRWQ -= 1                                        !      Substract 1 from Length
        Search = SUB(Search,1,LocLen:BRWQ)                      !      Remove Last Character from Search
      END                                                       !    End If
    ELSIF KEYCODE() = SpaceKey                                  !  If BackSpace Key Pressed
      IF LocLen:BRWQ < LEN(Search)                              !    If Not Last Position in Locator
        LocLen:BRWQ += 1                                        !      Add 1 to Length
      END                                                       !    End If
    ELSE
      IF LocLen:BRWQ < LEN(Search)                              !    If Not Last Position in Locator
        Search = SUB(Search,1,LocLen:BRWQ) & CHR(KEYCHAR())     !  Add Character to Search
        LocLen:BRWQ += 1                                        !      Add 1 to Length
      END                                                       !    End if
    END                                                         !  End
    IF TC_PROP:BRW(?List,TCPROP:RevOrder)                       !  If Using Reverse Key Order
      RCP:Name = CLIP(Search) & '<255>'                         !    Fill Search Key and Adjust for Key Order
    ELSE                                                        !  Otherwise
      RCP:Name = Search                                         !    Fill Search Key
    END                                                         !  End If
    TC_PROP:BRW(?List,TCPROP:Action,TCACTION:Refresh)           !  Tell Browse to Redisplay
    TC_PROP:BRW(?List,TCPROP:SetToKey,True)                     !  Redisplay after searching by key
  ELSE                                                          !Else
    LocLen:BRWQ = 0                                             !  Clear Locator Length
    Search = ''                                                 !  Clear the Search Input Field
  END                                                           !End If
  DISPLAY(?Search)                                              !Display Locator Field



!--------------------------------------------------------------------------------------------------!
! SetFieldColors:BRWQ Routine                                                                      !
!                                                                                                  !
! This routine sets the color of fields for ?List                                                  !
!--------------------------------------------------------------------------------------------------!
SetFieldColors:BRWQ  ROUTINE

  IF(INSTRING('CHICKEN',UPPER(RCP:Name),1,1))                   !  If INSTRING('CHICKEN',UPPER(RCP:Name),1,1)
    BRWQ:RCP:Name:NormalFG = COLOR:Blue                         !    Set Normal Foreground Color
    BRWQ:RCP:Name:NormalBG = COLOR:NONE                         !    Set Normal Background Color
    BRWQ:RCP:Name:SelectedFG = COLOR:NONE                       !    Set Selected Foreground Color
    BRWQ:RCP:Name:SelectedBG = COLOR:Blue                       !    Set Selected Background Color
  ELSIF(INSTRING('BEEF',UPPER(RCP:Name),1,1))                   !  If INSTRING('BEEF',UPPER(RCP:Name),1,1)
    BRWQ:RCP:Name:NormalFG = COLOR:Red                          !    Set Normal Foreground Color
    BRWQ:RCP:Name:NormalBG = COLOR:NONE                         !    Set Normal Background Color
    BRWQ:RCP:Name:SelectedFG = COLOR:NONE                       !    Set Selected Foreground Color
    BRWQ:RCP:Name:SelectedBG = COLOR:Red                        !    Set Selected Background Color
  ELSE                                                          !  Otherwise Set Default Colors
    BRWQ:RCP:Name:NormalFG = COLOR:NONE                         !    Set Normal Foreground Color
    BRWQ:RCP:Name:NormalBG = COLOR:NONE                         !    Set Normal Background Color
    BRWQ:RCP:Name:SelectedFG = COLOR:NONE                       !    Set Selected Foreground Color
    BRWQ:RCP:Name:SelectedBG = COLOR:NONE                       !    Set Selected Background Color
  END                                                           !  End If



!--------------------------------------------------------------------------------------------------!
! ProcedureReturn Routine                                                                                   !
!                                                                                                  !
! End of procedure cleanup and exit.                                                               !
!--------------------------------------------------------------------------------------------------!
ProcedureReturn    ROUTINE

  CLOSE(VIEW:BRWQ)
  RECIPE::Used -= 1
  IF RECIPE::Used = 0 THEN CLOSE(RECIPE).

  IF WindowOpened
    INISaveWindow('BrowseBeginning','PTDEMO.INI')
    CLOSE(Screen)
  END

  FREE(BRWQ)                                                    !Release Memory use by Browse Queue

  GlobalResponse = LocalResponse
  RETURN


