#!---------------------------------------------------------!
#!                                                         !
#! Copyright 1994, 1995 ToolCraft Development Corporation  !
#!                                                         !
#!                  ALL RIGHTS RESERVED                    !
#!                                                         !
#!---------------------------------------------------------!
#TEMPLATE (ToolCraft, 'Power Browse Template')
#HELP ('TCTPL.HLP')
#!
#INCLUDE('PTMODCW.TPW')
#INCLUDE('PTINLINE.TPW')
#INCLUDE('PBROWSE.TPW')
#INCLUDE('PBCTRL.TPW')
#INCLUDE('PBCTRLGR.TPW')
#INCLUDE('PBCOMBO.TPW')
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseLibrary, 'Include Power Browse Library Functions in the Application' ),APPLICATION,HLP('~PBGlobalExtension')
#!
#BUTTON('Power Browse Options'),AT(10,,180)
  #BOXED(''),AT(,5,,130)
    #IMAGE('PBCNOTC.BMP')
    #DISPLAY('This is a demo version of Power Browse.  Distribution'),AT(,95)
    #DISPLAY('of any applications created using this software is')
    #DISPLAY('prohibited.  You are licensed to use this software for')
    #DISPLAY('evaluation purposes only.')
  #ENDBOXED
  #BOXED('Global Options'),AT(,140)
    #DISPLAY(''),AT(,142)
    #PROMPT('Force Vertical Scroll Bar to Always be Displayed',CHECK),%ToolCraftForceVScrollDef,DEFAULT(0),AT(10,,190)
    #ENABLE(NOT %ToolCraftForceVScrollDef)
      #PROMPT('Disable Extended Checks on Vertical Scroll Display',CHECK),%ToolCraftNoExtVScrollDef,DEFAULT(1),AT(10,,190)
    #ENDENABLE
    #PROMPT('Disable Delayed List Box Display',CHECK),%ToolCraftNoDelayedDisplay,DEFAULT(0),AT(10,,130)
    #PROMPT('Disable Beep on Begin/End of File',CHECK),%ToolCraftNoSound,DEFAULT(0),AT(10,,130)
  #ENDBOXED
  #BOXED('Declare Hidden Global Variables'),WHERE(NOT %True),AT(0,0,0,0)
    #PROMPT('',@S10),%ToolCraftInLineFieldNumberOffset
  #ENDBOXED
#ENDBUTTON
#!
#!
#!------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
#IF(%Target32)
  #IF(%ApplicationLocalLibrary)
    #PROJECT('TCBRW32L.LIB')
  #ELSE
    #PROJECT('TCBRW32.LIB')
  #ENDIF
#ELSE
  #IF(%ApplicationLocalLibrary)
    #PROJECT('TCBRW16L.LIB')
  #ELSE
    #PROJECT('TCBRW16.LIB')
  #ENDIF
#ENDIF
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalMap)
INCLUDE('TCBROWSE.CLW','BrowseLibrary')
#ENDAT
#!------------------------------------------------------------------------
#AT(%GlobalData)


  INCLUDE('TCBROWSE.CLW','BrowseGlobals')


#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup),WHERE(%ToolCraftForceVScrollDef)
TC:BRW:ForceVScrollDef = True                       #<!Force VScroll to Always Display
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup)#!,WHERE(NOT %ToolCraftForceVScrollDef AND %ToolCraftNoExtVScrollDef)
TC:BRW:ExtVScrollDef = False                        #<!Turn off Extended VScroll Bar Conditions
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProgramSetup),WHERE(%ToolCraftNoSound)
TC:BRW:SoundOff = True                              #<!Turn off Beep for Power Browse BOF/EOF
#ENDAT
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseOptions, 'Enable Power Browse Options on a Standard Template Procedure' ),PROCEDURE,REQ(PowerBrowseLibrary(ToolCraft)),HLP('~PBOptionsExtension'),LAST
#!
#BOXED('Window Settings')
  #PROMPT('Maximize the Window on Open',CHECK),%AlwaysMaximizeOnOpen,AT(10,,115)
  #PROMPT('Specify the Field to Select on Open',CHECK),%SpecifyFirstField,AT(10,,130)
  #ENABLE(%SpecifyFirstField)
    #PROMPT('Field to Select:',CONTROL),%FirstFieldToSelect
    #VALIDATE(%FirstFieldToSelect,'You Must Specify the Field to Select')
  #ENDENABLE
#ENDBOXED
#BOXED('Resize Options')
  #PROMPT('Enable Window Resizing',CHECK),%EnableWindowResize,AT(10,,95)
  #ENABLE(%EnableWindowResize)
    #PROMPT('Parent List Box:',CONTROL),%ResizeListBox
    #ENABLE(%ResizeListBox)
      #PROMPT('Enable Secondary Window Resizing',CHECK),%EnableSecondaryResize,AT(10,,130)
      #ENABLE(%EnableSecondaryResize)
        #PROMPT('Child List Box:',CONTROL),%SecondaryResizeListBox
      #ENDENABLE
    #ENDENABLE
  #ENDENABLE
#ENDBOXED
#!
#RESTRICT
  #IF(%ProcedureTemplate = 'PowerBrowse')
    #REJECT
  #ENDIF
#ENDRESTRICT
#!
#ATSTART
#IF(%ProcedureTemplate = 'PowerBrowse')
  #ERROR('ERROR#012:' & %Procedure & '- Extension Invalid on PowerBrowse Template -- Remove the extension to correct the probelm.')
#ENDIF
#!------------------------------------------------------------------------
#DECLARE(%CmtPos)
#SET(%CmtPos,65)
#COMMENT(%CmtPos)
#CLEAR(%ToolCraftInLineFieldNumberOffset)
#INSERT(%WindowResizeSetup)
#ENDAT
#!------------------------------------------------------------------------
#!END OF #ATSTART
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#AT(%DataSectionBeforeWindow)
#INSERT(%PowerBrowseDeclarations)
#ENDAT
#!------------------------------------------------------------------------
#AT(%OtherLocalVariables)
#INSERT(%GenerateResizeLocalVariables)
#ENDAT
#!------------------------------------------------------------------------
#AT(%AfterWindowOpening)
#IF(%EnableWindowResize)
#INSERT(%GenerateResizeOpenWindowHandling)
#ENDIF
#INSERT(%GenerateHideListBoxControls)
#INSERT(%GenerateIconListAssignments)
#ENDAT
#!------------------------------------------------------------------------
#AT(%AcceptLoopBeforeEventHandling),WHERE(%EnableWindowResize)
IF SELECTED() THEN CurrentSelected = SELECTED().    #<!Save Current Field Selection
#ENDAT
#!------------------------------------------------------------------------
#AT(%WindowOtherEventHandling),WHERE(%EnableWindowResize)
#INSERT(%GenerateResizeEventHandling)
#ENDAT
#!------------------------------------------------------------------------
#AT(%ProcedureRoutines),WHERE(%EnableWindowResize)
#INSERT(%GenerateResizeWindowRoutine)
#ENDAT
#!------------------------------------------------------------------------
#!
#!
#!------------------------------------------------------------------------
#EXTENSION(PowerBrowseInLine, 'Enable Power Browse InLine Edit on a Standard Template Procedure' ),PROCEDURE,LAST,HLP('~PBInLineExtension')
#!
#DISPLAY('')
#DISPLAY('This extension adds the ability to use the')
#DISPLAY('InLine Edit option on any of the standard ')
#DISPLAY('template procedures.')
#DISPLAY('')
#RESTRICT
  #IF(%ProcedureTemplate = 'PowerBrowse')
    #REJECT
  #ENDIF
#ENDRESTRICT
#!
#AT(%ProcedureRoutines)
#EMBED(%LocalProcedures,'Local Procedures'),HIDE
#ENDAT
#!------------------------------------------------------------------------
