!-------------------------------------------------------------------!
!                                                                   !
! Copyright 1994 by ToolCraft Development Corporation               !
!                                                                   !
!                 ALL RIGHTS RESERVED                               !
!-------------------------------------------------------------------!


  SECTION('BrowseLibrary')
!-------------------  PowerBrowse Library MAP Additions -------------
  MODULE('ToolCraft Browse Library')
    TC_Browse(SHORT,*FILE,*GROUP,*KEY,*QUEUE,*STRING,<*?>,<?>,<?>,<BYTE>,<*?>,<?>,<*?>,<?>,<*?>,<?>)
    TC_InitBrowse(SHORT,USHORT,<BYTE>),BYTE
    TC_PROP:BRW(SHORT,BYTE,<BYTE>),SHORT,PROC
    TC_ResizeWin(LONG,LONG,LONG,<LONG>)
    TC_InLine(LONG,*LONG[],STRING)
    TC_AutoFill(*FILE,*GROUP,*KEY,*?,*?,BYTE,<*?>,<?>,<?>,<*?>,<?>,<*?>,<?>,<*?>,<?>),BYTE,PROC
  END
!--------------------------------------------------------------------

  SECTION('BrowseGlobals')
!-------------------  PowerBrowse Global Declarations ---------------
TCEVENT:InsertBatch       EQUATE(401H)      !Add a batch of records
TCEVENT:InsertRecord      EQUATE(402H)      !Add a record
TCEVENT:ChangeRecord      EQUATE(403H)      !Change a record
TCEVENT:DeleteRecord      EQUATE(404H)      !Delete a record
TCEVENT:SamePage          EQUATE(405H)      !Load and display same page
TCEVENT:SetToKey          EQUATE(406H)      !Set by key and redisplay
TCEVENT:SetToItem         EQUATE(407H)      !Set by current item and redisplay at top of list
TCEVENT:SetKeyPosition    EQUATE(408H)      !Set by current key position and keep record on same line
TCEVENT:SetQueuePosition  EQUATE(409H)      !Set by current queue position and keep record on same line
TCEVENT:AcceptSelection   EQUATE(410H)      !Accept Drop Down Combo Selection
TCEVENT:RejectSelection   EQUATE(411H)      !Reject Drop Combo Selection

TCACTION:Refresh          EQUATE(0)         !Refresh List Box
TCACTION:FillQueue        EQUATE(1)         !Fill queue for list
TCACTION:InsertBatch      EQUATE(2)         !Insert a batch of new records
TCACTION:InsertRecord     EQUATE(3)         !Insert a new record
TCACTION:ChangeRecord     EQUATE(4)         !Change the current record
TCACTION:DeleteRecord     EQUATE(5)         !Delete the current record
TCACTION:SelectRecord     EQUATE(6)         !Select the current record
TCACTION:DragThumb        EQUATE(7)         !Process Drag on Vertical Scroll Bar Thumb
TCACTION:SetThumb         EQUATE(8)         !Process Set Thumb Position
TCACTION:DisplayFields    EQUATE(9)         !Display Related Fields
TCACTION:NoRecords        EQUATE(10)        !No Records to Display
TCACTION:FirstRecord      EQUATE(11)        !On Inserting of First Record
TCACTION:ExitBrowse       EQUATE(12)        !Exit the browse routine

TCPROP:Action             EQUATE(1)         !Browse Action to Process
TCPROP:CurRow             EQUATE(2)         !Current Row Being Filled
TCPROP:CurItem            EQUATE(3)         !Current List Box Item Choice
TCPROP:DescendingKey      EQUATE(4)         !Descending Key Flag
TCPROP:DontSelect         EQUATE(5)         !Don't Select List on Refresh Flag
TCPROP:DroppedDown        EQUATE(6)         !PB Drop Combo List is Dropped Flag
TCPROP:EndBatch           EQUATE(7)         !End Batch Entry Flag
TCPROP:ExtVScroll         EQUATE(8)         !Use Extended Vertical Scroll Checking
TCPROP:ForceVScroll       EQUATE(9)         !Force Vertical Scroll to be Displayed
TCPROP:Initialized        EQUATE(10)        !Browse Initialized Flag
TCPROP:InsertMode         EQUATE(11)        !Insert Moe Flag
TCPROP:RevOrder           EQUATE(12)        !Process in Reverse Key Order Flag
TCPROP:Rows               EQUATE(13)        !Number of Rows in List Box
TCPROP:SetToItem          EQUATE(14)        !Set Refresh To Begin with Item
TCPROP:SetToKey           EQUATE(15)        !Set Refresh to Begin with Key
TCPROP:SetToPosition      EQUATE(16)        !Set Refresh to Begin at Position
TCPROP:SelectRecord       EQUATE(17)        !Double Click Selects Record Flag
TCPROP:SkipRecord         EQUATE(18)        !Skip Filling Record in Queue Flag
TCPROP:ThumbOption        EQUATE(19)        !Thumb Option Setting
TCPROP:UseView            EQUATE(20)        !Use a View Structure Flag
TCPROP:WatchOff           EQUATE(21)        !Disable Automatic File Concurency Checking

TC:BRW:ActiveList         USHORT            !Field # of Currently Active List Box
TC:BRW:ActiveThread       USHORT            !Thread# of Currently Active List Box
TC:BRW:ActiveWindow       UNSIGNED          !Handle of Currently Active Window
TC:BRW:BeepSound          LONG(1)           !Beep Value to for BOF/EOF Condition
TC:BRW:DeletedLast        BYTE              !Last Record in Browse Deleted Flag
TC:BRW:ExtVScrollDef      BYTE(1)           !Use Extended VScroll Bar Conditions
TC:BRW:ForceVScrollDef    BYTE(0)           !Force VScroll Bar to Always Display
TC:BRW:SoundOff           BYTE              !Turn Sound Off for BOF/EOF Flag
TC:BRW:ProcessMarked      BYTE              !Process Marked Records Flag
TC:BRW:MarkAllFlag        BYTE              !All Records Marked Flag
TC:BRW:MarkQueue          &QUEUE            !Name of Mark Records Queue


!-----------------  AutoFill Global Declarations -------------------
TC:AUT:SkipRecord         BYTE              !Skip Record and Search to Next

!-----------------  ResizeWin Global Declarations -------------------
TC:RSZ:SetTabWidth        BYTE
TC:RSZ:SetTabHeight       BYTE
TC:RSZ:TabControl         BYTE
TC:RSZ:TabControl2        BYTE

!-------------------  InLine Global Declarations --------------------
TCACTION:ExitInLine       EQUATE(0)
TCACTION:SetFields        EQUATE(1)
TCACTION:SetHotKeys       EQUATE(2)
TCACTION:FieldEdits       EQUATE(3)
TCACTION:UpdateRecord     EQUATE(4)
TCACTION:AbortUpdate      EQUATE(5)

TC:INL:Action             BYTE
TC:INL:AbortButton        BYTE
TC:INL:AbortKey           LONG
TC:INL:AbortUpdate        BYTE
TC:INL:CloseWindow        BYTE
TC:INL:Column             BYTE
TC:INL:CurItem            BYTE
TC:INL:EditNextKey1       LONG
TC:INL:EditNextKey2       LONG
TC:INL:EditPrevKey1       LONG
TC:INL:EditPrevKey2       LONG
TC:INL:Field              LONG
TC:INL:FirstField         BYTE
TC:INL:HotKey1            LONG
TC:INL:HotKey2            LONG
TC:INL:HotKey3            LONG
TC:INL:HotKey4            LONG
TC:INL:HotKey5            LONG
TC:INL:PostField          BYTE
TC:INL:PostEvent          BYTE
TC:INL:ResizeWindow       BYTE
TC:INL:SaveButton         BYTE
TC:INL:SaveKey            LONG
TC:INL:SelectField        BYTE
TC:INL:UpdateAction       BYTE
TC:INL:UpdateMode         BYTE
!--------------------------------------------------------------------
